/*
 * Copyright (c) 2005 Lukasz Dembinski <dembol@nasa.com.pl>
 */

#include <stdio.h>
#include <netinet/in.h>
#include <netdb.h>
#include <linux/if_ether.h>
#include <linux/if_packet.h>
#include <linux/if.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/socket.h>

int main(int argc, char **argv)
{
    struct sockaddr_ll sll;
    int sin_len = sizeof(sll);
    char fd_str[10];
    int fd;
    struct ifreq ifr;

    if (argc != 2) {
	printf("You must specify network interface name\n");
	return -1;
    }
    
    if ((fd = socket(AF_PACKET, SOCK_RAW, htons(ETH_P_ALL))) < 0) {
	printf("Can create AF_PACKET RAW socket\n");
	return -1;
    }

    strcpy(ifr.ifr_name, argv[1]);
    ioctl (fd, SIOCGIFINDEX, &ifr);

    sll.sll_family   = AF_PACKET;
    sll.sll_ifindex  = ifr.ifr_ifindex;
    sll.sll_protocol = htons(ETH_P_ALL);
    
    printf("Binding to %s\n", argv[1]);
    bind(fd, (struct sockaddr *)&sll, sin_len);

    sprintf(fd_str, "%d", fd);
    printf("%d\n", execl("/bin/bash", "bash", "/mnt/hdc5/src/agnix-sf/emulators/qemu/start.sh", fd_str, NULL));
}

