#ifndef _AGNIX_ADI_DRIVERS_H_
#define _AGNIX_ADI_DRIVERS_H_

#include <agnix/adi/char/adi_char.h>
#include <agnix/adi/block/adi_block.h>
#include <agnix/adi/chips/chips.h>
#include <agnix/adi/net/adi_net.h>
#include <agnix/adi/buses/adi_buses.h>

#define ADI_DRIVER_TYPE_PCI		0x00
#define ADI_DRIVER_TYPE_USB		0x01
#define ADI_DRIVER_TYPE_ISA		0x02

struct adi_driver_id_s {
    u16 vendor_id;
    u16 device_id;
    u16 device_class_id;
};

struct adi_driver_pci_s {
    int (*adi_driver_probe)(struct pcidev_s *pcidev, struct adi_driver_id_s *adi_id);
    int (*adi_driver_remove)(struct pcidev_s *pcidev);
};

struct adi_driver_s {
    const char *adi_driver_name; 
    int adi_driver_type;
    
    struct adi_driver_id_s *adi_driver_id;

    union adi_driver_union_s {
	struct adi_driver_pci_s *adi_driver_pci;
    } adi_driver_union;
    
    struct list_head adi_driver_list;
};

int adi_drivers_init(void);
int adi_register_driver(struct adi_driver_s *adi_driver);

#endif
