#ifndef _AGNIX_ADI_RESOURCES_H_
#define _AGNIX_ADI_RESOURCES_H_

#include <agnix/list.h>
#include <asm/types.h>

#define ADI_RES_FLAG_MEM	0x01
#define ADI_RES_FLAG_IO		0x02

struct adi_resource_s {
    const char *res_name;
    u32 res_start;
    u32 res_end;
    int res_flags;
    struct list_head res_list;
};

int adi_register_resource(struct adi_resource_s *adi_resource);
int adi_unregister_resource(struct adi_resource_s *adi_resource);
int adi_print_resources(int res_flags_mask);
int adi_print_mem_resources(void);
int adi_print_io_resources(void);
int adi_resources_init(void);

#endif
