#ifndef _AGNIX_FS_FILE_H_
#define _AGNIX_FS_FILE_H_

#include <agnix/tasks.h>

struct file_ops_s;

struct file_s {
    u16 file_mode;    
    u16 file_flags;
    u16 file_count;
    u32 file_pos;
    void *file_data;
//    struct vnode *vnode;

    struct file_ops_s *file_ops;
};

struct file_ops_s {
    int (*open) (struct file_s *file, int flag, int mode);
    int (*read) (struct file_s *file, char *buf, int count);
    int (*write)(struct file_s *file, char *buf, int count);
    int (*lseek)(struct file_s *file, int offset, int whence);
    int (*close)(struct file_s *file);
};

int file_install_fd(struct file_s *file);
int files_fork(struct task_s *cur_task, struct task_s *new_task);
struct files_s *files_create(void);
struct files_s *files_copy(struct files_s *cur_files);
struct file_s *file_create(void);
void file_destroy(struct file_s *file);

#endif
