#ifndef _AGNIX_MEMORY_BUDDY_ALLOC_H_
#define _AGNIX_MEMORY_BUDDY_ALLOC_H_

#include <asm/types.h>
#include <agnix/list.h>
#include <agnix/spinlock.h>

#define BUDDY_ALLOC_MAX_AREAS		20
#define BUDDY_ALLOC_NORMAL_AREAS	20
#define BUDDY_ALLOC_DMA_AREAS		10

struct buddy_area_s {
    u32 *area_bitmap;
    struct list_head area_list;
    int free_units;
};

struct buddy_allocator_s {
    const char 		*buddy_name;
    int 		buddy_alloc_req_areas;
    struct buddy_area_s buddy_area[BUDDY_ALLOC_MAX_AREAS];
    spinlock_t 		buddy_lock;
};

void buddy_alloc_init(void);
void buddy_alloc_print_units(struct buddy_allocator_s *buddy_alloc, int broadcast);
void buddy_alloc_print_stats(void);
void buddy_alloc_print_free(void);

#endif
