/*
 * kernel_sys/pseudo_vfs.c
 *
 * Copyright (c) 2003-2005 Lukasz Dembinski <dembol@nasa.com.pl>
 * All Rights Reserved
 * 
 * Date:	2005/04
 * Author: 	Lukasz Dembinski
 * Info:	It's only stub for real virtual filesystem
 * Contact:	mailto: <dembol@nasa.com.pl>
 *
 */

/*
 * TODO
 * - all VFS module
 */

#include <agnix/agnix.h>
#include <agnix/adi/adi.h>
#include <agnix/fs.h>
#include <agnix/terminal.h>
#include <agnix/console.h>

#define MOD_NAME	"VFS: "

int do_sys_open(char *filename, int flag, int mode)
{
    struct adi_chrdev_s *dev;    
    struct file_s *file;
    int ret;
    int fd;

    if ((dev = adi_chrdev_find_by_name(filename))) {
	file = file_create();
	file->file_ops  = dev->file_ops;
	file->file_data = (void *)DEV_MINOR(dev);

	if (file->file_ops && file->file_ops->open) {
		if ((ret = file->file_ops->open(file, flag, mode)) < 0) {
		    file_destroy(file);
		    return ret;
	    }
	} else {
	    printk("no open function %08x %08x %08x\n", file->file_ops, file->file_ops->open, dev->file_ops);

	    return -1;
	}
	
	if ((fd = file_install_fd(file)) < 0) {
	    file_destroy(file);
	    return -1;    
	}
	
	return fd;
    } 

    return -1;
}

int do_sys_read(int fd, char *buf, int count)
{
    struct file_s *file;
    
    file = current_task->files->file[fd];

    if (file->file_ops && file->file_ops->read) {
	return file->file_ops->read(file, buf, count);
    }
    
    return -1;
}

int do_sys_write(int fd, char *buf, int count)
{
    struct file_s *file;
    
    file = current_task->files->file[fd];

    if (file->file_ops && file->file_ops->write) {
	return file->file_ops->write(file, buf, count);
    }

    return -1;
}

int do_sys_lseek(int fd, int offset, int whence)
{
    return 0;
}

int do_sys_close(int fd)
{
    return 0;
}
