/*
 * kernel_net/layer_3/core/core.c
 *
 * Copyright (c) 2003-2005 Lukasz Dembinski <dembol@nasa.com.pl>
 * All Rights Reserved
 * 
 * Date:	2005/06
 * Author: 	Lukasz Dembinski
 * Info:	core.c core file
 * Contact:	mailto: <dembol@nasa.com.pl>
 *
 */

#include <agnix/agnix.h>
#include <agnix/adi/adi.h>
#include <agnix/init.h>
#include <agnix/net/net.h>
#include <agnix/memory.h>
#include <agnix/strings.h>
#include <agnix/console.h>
#include <agnix/types.h>

#define MOD_NAME	"NET: "

int net_addr(char *addr, struct net_addr_s *net_addr)
{
    char buf[NET_ADDR_STRING_MAX_LEN];
    char *ptr;
    int i, j;
    int dots;

    j = 0;
    dots = 0;
    for (i = 0; i < NET_ADDR_STRING_MAX_LEN; i++) {
	if (addr[i] == '.' && j > 0) {
	    buf[i] = 0;
	    j = 0;
	    dots++;
	    if (dots > 3)
		return -1;
		
	} else 
	if ((addr[i] >= '0') && (addr[i] <= '9') && (j < 3)) {
	    buf[i] = addr[i];
	    j++;
	} else
	if (addr[i] == 0 || addr[i] == '\n')
	    break;
	else
	    return -1;
    }
    
    if ((dots != 3) || (addr[i - 1] == '.'))
	return -1;
	
    buf[i] = 0;
    net_addr->address[0] = (u8)atoi(buf);
    ptr = buf + strlen(buf) + 1;
    net_addr->address[1] = (u8)atoi(ptr);
    ptr += strlen(ptr) + 1;
    net_addr->address[2] = (u8)atoi(ptr);
    ptr += strlen(ptr) + 1;
    net_addr->address[3] = (u8)atoi(ptr);

    return 0;
}

int net_layer_3_init(void)
{
    printk(MOD_NAME "\tLayer 3: core");

    net_layer_3_ip_init();
    
    printk("\n");

    return 0;
}
