/*
 * kernel_super/sched/sleep.c
 *
 * Copyright (c) 2003-2005 Lukasz Dembinski <dembol@nasa.com.pl>
 * All Rights Reserved
 * 
 * Date:	2005/05
 * Author: 	Lukasz Dembinski
 * Info:	sleep.c core file
 * Contact:	mailto: <dembol@nasa.com.pl>
 *
 */

#include <agnix/agnix.h>
#include <agnix/timers.h>
#include <agnix/tasks.h>
#include <agnix/sched.h>

void sleep_timer_expire(void *data)
{
    sched_activate_task((struct task_s *)data);
}

void sleep_timeout(u32 timeout_jiffies)
{
    struct timer_s sleep_timer;

    sleep_timer.timer_function = sleep_timer_expire;
    sleep_timer.timer_data     = (void *)current_task;
    sleep_timer.timer_expire   = timeout_jiffies;
    sleep_timer.timer_flags    = TIMER_FLAG_ONESHOT;
       
    sched_deactivate_task(current_task);
    register_timer(&sleep_timer);
    
    schedule_task();
}

