/* 
 * kernel_drivers/adi_buses/pci/pcibus_device_names.c
 * 
 * Copyright (c) 2003-2004 Lukasz Dembinski <dembol@nasa.com.pl>
 * All Rights Reserved
 * 
 * Date:	2004/06
 * Author: 	Lukasz Dembinski
 * Info:	pcibus_device_names.c core file
 * Contact:	mailto: <dembol@nasa.com.pl>
 * 
 */

#include <agnix/agnix.h>
#include <agnix/adi/adi.h>

struct pcibus_device_name_s pcibus_device_names[] = {
	{ 0x0675, 0x1700, "IS64PH ISDN Adapter" }, 
	{ 0x0675, 0x1702, "IS64PH ISDN Adapter" }, 
	{ 0x09c1, 0x0704, "CM 200E Cable Modem" }, 
	{ 0x0e11, 0x0001, "PCI to EISA Bridge" }, 
	{ 0x0e11, 0x0002, "PCI to ISA Bridge" }, 
	{ 0x0e11, 0x0049, "NC7132 Gigabit Upgrade Module" }, 
	{ 0x0e11, 0x004a, "NC6136 Gigabit Server Adapter" }, 
	{ 0x0e11, 0x0508, "Netelligent 4/16 Token Ring" }, 
	{ 0x0e11, 0x1000, "Triflex/Pentium Bridge, Model 1000" }, 
	{ 0x0e11, 0x2000, "Triflex/Pentium Bridge, Model 2000" }, 
	{ 0x0e11, 0x3032, "QVision 1280/p" }, 
	{ 0x0e11, 0x3033, "QVision 1280/p" }, 
	{ 0x0e11, 0x3034, "QVision 1280/p" }, 
	{ 0x0e11, 0x4000, "4000 [Triflex]" }, 
	{ 0x0e11, 0x6010, "HotPlug PCI Bridge 6010" }, 
	{ 0x0e11, 0x7020, "USB Controller" }, 
	{ 0x0e11, 0xa0ec, "Fibre Channel Host Controller" }, 
	{ 0x0e11, 0xa0f0, "Advanced System Management Controller" }, 
	{ 0x0e11, 0xa0f3, "Triflex PCI to ISA Bridge" }, 
	{ 0x0e11, 0xa0f7, "PCI Hotplug Controller" }, 
	{ 0x0e11, 0xa0f8, "ZFMicro Chipset USB" }, 
	{ 0x0e11, 0xa0fc, "Fibre Channel Host Controller" }, 
	{ 0x0e11, 0xae10, "Smart-2/P RAID Controller" }, 
	{ 0x0e11, 0xae29, "MIS-L" }, 
	{ 0x0e11, 0xae2a, "MPC" }, 
	{ 0x0e11, 0xae2b, "MIS-E" }, 
	{ 0x0e11, 0xae31, "System Management Controller" }, 
	{ 0x0e11, 0xae32, "Netelligent 10/100" }, 
	{ 0x0e11, 0xae33, "Triflex Dual EIDE Controller" }, 
	{ 0x0e11, 0xae34, "Netelligent 10" }, 
	{ 0x0e11, 0xae35, "Integrated NetFlex-3/P" }, 
	{ 0x0e11, 0xae40, "Netelligent 10/100 Dual" }, 
	{ 0x0e11, 0xae43, "ProLiant Integrated Netelligent 10/100" }, 
	{ 0x0e11, 0xae69, "CETUS-L" }, 
	{ 0x0e11, 0xae6c, "Northstar" }, 
	{ 0x0e11, 0xae6d, "NorthStar CPU to PCI Bridge" }, 
	{ 0x0e11, 0xb011, "Integrated Netelligent 10/100" }, 
	{ 0x0e11, 0xb012, "Netelligent 10 T/2" }, 
	{ 0x0e11, 0xb02f, "NC1120 Ethernet NIC" }, 
	{ 0x0e11, 0xb030, "Netelligent WS 5100" }, 
	{ 0x0e11, 0xb060, "Smart Array 5300 Controller" }, 
	{ 0x0e11, 0xb178, "Smart Array 5i/532" }, 
	{ 0x0e11, 0xf130, "NetFlex-3/P ThunderLAN 1.0" }, 
	{ 0x0e11, 0xf150, "NetFlex-3/P ThunderLAN 2.3" }, 
	{ 0x1000, 0x0001, "53c810" }, 
	{ 0x1000, 0x0002, "53c820" }, 
	{ 0x1000, 0x0003, "53c825" }, 
	{ 0x1000, 0x0004, "53c815" }, 
	{ 0x1000, 0x0005, "53c810AP" }, 
	{ 0x1000, 0x0006, "53c860" }, 
	{ 0x1000, 0x000a, "53c1510" }, 
	{ 0x1000, 0x000b, "53c896" }, 
	{ 0x1000, 0x000c, "53c895" }, 
	{ 0x1000, 0x000d, "53c885" }, 
	{ 0x1000, 0x000f, "53c875" }, 
	{ 0x1000, 0x0010, "53c895" }, 
	{ 0x1000, 0x0012, "53c895a" }, 
	{ 0x1000, 0x0020, "53c1010 Ultra3 SCSI Adapter" }, 
	{ 0x1000, 0x0021, "53c1010 66MHz  Ultra3 SCSI Adapter" }, 
	{ 0x1000, 0x0030, "53c1030" }, 
	{ 0x1000, 0x0040, "53c1035" }, 
	{ 0x1000, 0x008f, "53c875J" }, 
	{ 0x1000, 0x0621, "FC909" }, 
	{ 0x1000, 0x0622, "FC929" }, 
	{ 0x1000, 0x0623, "FC929 LAN" }, 
	{ 0x1000, 0x0624, "FC919" }, 
	{ 0x1000, 0x0625, "FC919 LAN" }, 
	{ 0x1000, 0x0626, "FC929X" }, 
	{ 0x1000, 0x0627, "FC929X LAN" }, 
	{ 0x1000, 0x0628, "FC919X" }, 
	{ 0x1000, 0x0629, "FC919X LAN" }, 
	{ 0x1000, 0x0701, "83C885 NT50 DigitalScape Fast Ethernet" }, 
	{ 0x1000, 0x0702, "Yellowfin G-NIC gigabit ethernet" }, 
	{ 0x1000, 0x0901, "61C102" }, 
	{ 0x1000, 0x1000, "63C815" }, 
	{ 0x1001, 0x0010, "PCI 1616 Measurement card with 32 digital I/O lines" }, 
	{ 0x1001, 0x0011, "OPTO-PCI Opto-Isolated digital I/O board" }, 
	{ 0x1001, 0x0012, "PCI-AD/DA Analogue I/O board" }, 
	{ 0x1001, 0x0013, "PCI-OPTO-RELAIS Digital I/O board with relay outputs" }, 
	{ 0x1001, 0x0014, "PCI-Counter/Timer Counter Timer board" }, 
	{ 0x1001, 0x0015, "PCI-DAC416 Analogue output board" }, 
	{ 0x1001, 0x0016, "PCI-MFB Analogue I/O board" }, 
	{ 0x1001, 0x0017, "PROTO-3 PCI Prototyping board" }, 
	{ 0x1001, 0x9100, "INI-9100/9100W SCSI Host" }, 
	{ 0x1002, 0x4158, "68800AX [Mach32]" }, 
	{ 0x1002, 0x4242, "Radeon 8500 DV" }, 
	{ 0x1002, 0x4354, "215CT [Mach64 CT]" }, 
	{ 0x1002, 0x4358, "210888CX [Mach64 CX]" }, 
	{ 0x1002, 0x4554, "210888ET [Mach64 ET]" }, 
	{ 0x1002, 0x4654, "Mach64 VT" }, 
	{ 0x1002, 0x4742, "3D Rage Pro AGP 1X/2X" }, 
	{ 0x1002, 0x4744, "3D Rage Pro AGP 1X" }, 
	{ 0x1002, 0x4747, "3D Rage Pro" }, 
	{ 0x1002, 0x4749, "3D Rage Pro" }, 
	{ 0x1002, 0x474c, "Rage XC" }, 
	{ 0x1002, 0x474d, "Rage XL AGP 2X" }, 
	{ 0x1002, 0x474e, "Rage XC AGP" }, 
	{ 0x1002, 0x474f, "Rage XL" }, 
	{ 0x1002, 0x4750, "3D Rage Pro 215GP" }, 
	{ 0x1002, 0x4751, "3D Rage Pro 215GQ" }, 
	{ 0x1002, 0x4752, "Rage XL" }, 
	{ 0x1002, 0x4753, "Rage XC" }, 
	{ 0x1002, 0x4754, "3D Rage I/II 215GT [Mach64 GT]" }, 
	{ 0x1002, 0x4755, "3D Rage II+ 215GTB [Mach64 GTB]" }, 
	{ 0x1002, 0x4756, "3D Rage IIC 215IIC [Mach64 GT IIC]" }, 
	{ 0x1002, 0x4757, "3D Rage IIC AGP" }, 
	{ 0x1002, 0x4758, "210888GX [Mach64 GX]" }, 
	{ 0x1002, 0x4759, "3D Rage IIC" }, 
	{ 0x1002, 0x475a, "3D Rage IIC AGP" }, 
	{ 0x1002, 0x4c42, "3D Rage LT Pro AGP-133" }, 
	{ 0x1002, 0x4c44, "3D Rage LT Pro AGP-66" }, 
	{ 0x1002, 0x4c45, "Rage Mobility M3 AGP" }, 
	{ 0x1002, 0x4c46, "Rage Mobility M3 AGP 2x" }, 
	{ 0x1002, 0x4c47, "3D Rage LT-G 215LG" }, 
	{ 0x1002, 0x4c49, "3D Rage LT Pro" }, 
	{ 0x1002, 0x4c4d, "Rage Mobility P/M AGP 2x" }, 
	{ 0x1002, 0x4c4e, "Rage Mobility L AGP 2x" }, 
	{ 0x1002, 0x4c50, "3D Rage LT Pro" }, 
	{ 0x1002, 0x4c51, "3D Rage LT Pro" }, 
	{ 0x1002, 0x4c52, "Rage Mobility P/M" }, 
	{ 0x1002, 0x4c53, "Rage Mobility L" }, 
	{ 0x1002, 0x4c54, "264LT [Mach64 LT]" }, 
	{ 0x1002, 0x4c57, "Radeon Mobility M7 LW" }, 
	{ 0x1002, 0x4c58, "Radeon Mobility M6 LX" }, 
	{ 0x1002, 0x4c59, "Radeon Mobility M6 LY" }, 
	{ 0x1002, 0x4c5a, "Radeon Mobility M6 LZ" }, 
	{ 0x1002, 0x4d46, "Rage Mobility M4 AGP" }, 
	{ 0x1002, 0x4d4c, "Rage Mobility M4 AGP" }, 
	{ 0x1002, 0x5041, "Rage 128 PA/PRO" }, 
	{ 0x1002, 0x5042, "Rage 128 PB/PRO AGP 2x" }, 
	{ 0x1002, 0x5043, "Rage 128 PC/PRO AGP 4x" }, 
	{ 0x1002, 0x5044, "Rage 128 PD/PRO TMDS" }, 
	{ 0x1002, 0x5045, "Rage 128 PE/PRO AGP 2x TMDS" }, 
	{ 0x1002, 0x5046, "Rage 128 PF/PRO AGP 4x TMDS" }, 
	{ 0x1002, 0x5047, "Rage 128 PG/PRO" }, 
	{ 0x1002, 0x5048, "Rage 128 PH/PRO AGP 2x" }, 
	{ 0x1002, 0x5049, "Rage 128 PI/PRO AGP 4x" }, 
	{ 0x1002, 0x504a, "Rage 128 PJ/PRO TMDS" }, 
	{ 0x1002, 0x504b, "Rage 128 PK/PRO AGP 2x TMDS" }, 
	{ 0x1002, 0x504c, "Rage 128 PL/PRO AGP 4x TMDS" }, 
	{ 0x1002, 0x504d, "Rage 128 PM/PRO" }, 
	{ 0x1002, 0x504e, "Rage 128 PN/PRO AGP 2x" }, 
	{ 0x1002, 0x504f, "Rage 128 PO/PRO AGP 4x" }, 
	{ 0x1002, 0x5050, "Rage 128 PP/PRO TMDS" }, 
	{ 0x1002, 0x5051, "Rage 128 PQ/PRO AGP 2x TMDS" }, 
	{ 0x1002, 0x5052, "Rage 128 PR/PRO AGP 4x TMDS" }, 
	{ 0x1002, 0x5053, "Rage 128 PS/PRO" }, 
	{ 0x1002, 0x5054, "Rage 128 PT/PRO AGP 2x" }, 
	{ 0x1002, 0x5055, "Rage 128 PU/PRO AGP 4x" }, 
	{ 0x1002, 0x5056, "Rage 128 PV/PRO TMDS" }, 
	{ 0x1002, 0x5057, "Rage 128 PW/PRO AGP 2x TMDS" }, 
	{ 0x1002, 0x5058, "Rage 128 PX/PRO AGP 4x TMDS" }, 
	{ 0x1002, 0x5144, "Radeon QD" }, 
	{ 0x1002, 0x5145, "Radeon QE" }, 
	{ 0x1002, 0x5146, "Radeon QF" }, 
	{ 0x1002, 0x5147, "Radeon QG" }, 
	{ 0x1002, 0x5148, "Radeon R200 QH" }, 
	{ 0x1002, 0x5149, "Radeon R200 QI" }, 
	{ 0x1002, 0x514a, "Radeon R200 QJ" }, 
	{ 0x1002, 0x514b, "Radeon R200 QK" }, 
	{ 0x1002, 0x514c, "Radeon QL" }, 
	{ 0x1002, 0x5157, "Radeon 7500 QW" }, 
	{ 0x1002, 0x5158, "Radeon 7500 QX" }, 
	{ 0x1002, 0x5159, "Radeon VE QY" }, 
	{ 0x1002, 0x515a, "Radeon VE QZ" }, 
	{ 0x1002, 0x5168, "Radeon R200 Qh" }, 
	{ 0x1002, 0x5169, "Radeon R200 Qi" }, 
	{ 0x1002, 0x516a, "Radeon R200 Qj" }, 
	{ 0x1002, 0x516b, "Radeon R200 Qk" }, 
	{ 0x1002, 0x5245, "Rage 128 RE/SG" }, 
	{ 0x1002, 0x5246, "Rage 128 RF/SG AGP" }, 
	{ 0x1002, 0x5247, "Rage 128 RG" }, 
	{ 0x1002, 0x524b, "Rage 128 RK/VR" }, 
	{ 0x1002, 0x524c, "Rage 128 RL/VR AGP" }, 
	{ 0x1002, 0x5345, "Rage 128 SE/4x" }, 
	{ 0x1002, 0x5346, "Rage 128 SF/4x AGP 2x" }, 
	{ 0x1002, 0x5347, "Rage 128 SG/4x AGP 4x" }, 
	{ 0x1002, 0x5348, "Rage 128 SH" }, 
	{ 0x1002, 0x534b, "Rage 128 SK/4x" }, 
	{ 0x1002, 0x534c, "Rage 128 SL/4x AGP 2x" }, 
	{ 0x1002, 0x534d, "Rage 128 SM/4x AGP 4x" }, 
	{ 0x1002, 0x534e, "Rage 128 4x" }, 
	{ 0x1002, 0x5354, "Mach 64 VT" }, 
	{ 0x1002, 0x5446, "Rage 128 Pro Ultra TF" }, 
	{ 0x1002, 0x544c, "Rage 128 Pro Ultra TL" }, 
	{ 0x1002, 0x5452, "Rage 128 Pro Ultra TR" }, 
	{ 0x1002, 0x5453, "Rage 128 Pro Ultra TS" }, 
	{ 0x1002, 0x5454, "Rage 128 Pro Ultra TT" }, 
	{ 0x1002, 0x5455, "Rage 128 Pro Ultra TU" }, 
	{ 0x1002, 0x5654, "264VT [Mach64 VT]" }, 
	{ 0x1002, 0x5655, "264VT3 [Mach64 VT3]" }, 
	{ 0x1002, 0x5656, "264VT4 [Mach64 VT4]" }, 
	{ 0x1003, 0x0201, "US201" }, 
	{ 0x1004, 0x0005, "82C592-FC1" }, 
	{ 0x1004, 0x0006, "82C593-FC1" }, 
	{ 0x1004, 0x0007, "82C594-AFC2" }, 
	{ 0x1004, 0x0008, "82C596/7 [Wildcat]" }, 
	{ 0x1004, 0x0009, "82C597-AFC2" }, 
	{ 0x1004, 0x000c, "82C541 [Lynx]" }, 
	{ 0x1004, 0x000d, "82C543 [Lynx]" }, 
	{ 0x1004, 0x0101, "82C532" }, 
	{ 0x1004, 0x0102, "82C534 [Eagle]" }, 
	{ 0x1004, 0x0103, "82C538" }, 
	{ 0x1004, 0x0104, "82C535" }, 
	{ 0x1004, 0x0105, "82C147" }, 
	{ 0x1004, 0x0200, "82C975" }, 
	{ 0x1004, 0x0280, "82C925" }, 
	{ 0x1004, 0x0304, "QSound ThunderBird PCI Audio" }, 
	{ 0x1004, 0x0305, "QSound ThunderBird PCI Audio Gameport" }, 
	{ 0x1004, 0x0306, "QSound ThunderBird PCI Audio Support Registers" }, 
	{ 0x1004, 0x0702, "VAS96011 [Golden Gate II]" }, 
	{ 0x1005, 0x2064, "ALG2032/2064" }, 
	{ 0x1005, 0x2128, "ALG2364A" }, 
	{ 0x1005, 0x2301, "ALG2301" }, 
	{ 0x1005, 0x2302, "ALG2302" }, 
	{ 0x1005, 0x2364, "ALG2364" }, 
	{ 0x1005, 0x2464, "ALG2364A" }, 
	{ 0x1005, 0x2501, "ALG2564A/25128A" }, 
	{ 0x100b, 0x0001, "DP83810" }, 
	{ 0x100b, 0x0002, "87415/87560 IDE" }, 
	{ 0x100b, 0x000e, "87560 Legacy I/O" }, 
	{ 0x100b, 0x000f, "FireWire Controller" }, 
	{ 0x100b, 0x0011, "NS87560 National PCI System I/O" }, 
	{ 0x100b, 0x0012, "USB Controller" }, 
	{ 0x100b, 0x0020, "DP83815 (MacPhyter) Ethernet Controller" }, 
	{ 0x100b, 0x0022, "DP83820 10/100/1000 Ethernet Controller" }, 
	{ 0x100b, 0x0500, "SCx200 Bridge" }, 
	{ 0x100b, 0x0501, "SCx200 SMI" }, 
	{ 0x100b, 0x0502, "SCx200 IDE" }, 
	{ 0x100b, 0x0503, "SCx200 Audio" }, 
	{ 0x100b, 0x0504, "SCx200 Video" }, 
	{ 0x100b, 0x0505, "SCx200 XBus" }, 
	{ 0x100b, 0xd001, "87410 IDE" }, 
	{ 0x100c, 0x3202, "ET4000/W32p rev A" }, 
	{ 0x100c, 0x3205, "ET4000/W32p rev B" }, 
	{ 0x100c, 0x3206, "ET4000/W32p rev C" }, 
	{ 0x100c, 0x3207, "ET4000/W32p rev D" }, 
	{ 0x100c, 0x3208, "ET6000" }, 
	{ 0x100c, 0x4702, "ET6300" }, 
	{ 0x100e, 0x9000, "P9000 Viper" }, 
	{ 0x100e, 0x9001, "P9000 Viper" }, 
	{ 0x100e, 0x9002, "P9000 Viper" }, 
	{ 0x100e, 0x9100, "P9100 Viper Pro/SE" }, 
	{ 0x1011, 0x0001, "DECchip 21050" }, 
	{ 0x1011, 0x0002, "DECchip 21040 [Tulip]" }, 
	{ 0x1011, 0x0004, "DECchip 21030 [TGA]" }, 
	{ 0x1011, 0x0007, "NVRAM [Zephyr NVRAM]" }, 
	{ 0x1011, 0x0008, "KZPSA [KZPSA]" }, 
	{ 0x1011, 0x0009, "DECchip 21140 [FasterNet]" }, 
	{ 0x1011, 0x000a, "21230 Video Codec" }, 
	{ 0x1011, 0x000d, "PBXGB [TGA2]" }, 
	{ 0x1011, 0x000f, "DEFPA" }, 
	{ 0x1011, 0x0014, "DECchip 21041 [Tulip Pass 3]" }, 
	{ 0x1011, 0x0016, "DGLPB [OPPO]" }, 
	{ 0x1011, 0x0019, "DECchip 21142/43" }, 
	{ 0x1011, 0x001a, "Farallon PN9000SX" }, 
	{ 0x1011, 0x0021, "DECchip 21052" }, 
	{ 0x1011, 0x0022, "DECchip 21150" }, 
	{ 0x1011, 0x0023, "DECchip 21150" }, 
	{ 0x1011, 0x0024, "DECchip 21152" }, 
	{ 0x1011, 0x0025, "DECchip 21153" }, 
	{ 0x1011, 0x0026, "DECchip 21154" }, 
	{ 0x1011, 0x0045, "DECchip 21553" }, 
	{ 0x1011, 0x0046, "DECchip 21554" }, 
	{ 0x1011, 0x1065, "StrongARM DC21285" }, 
	{ 0x1013, 0x0038, "GD 7548" }, 
	{ 0x1013, 0x0040, "GD 7555 Flat Panel GUI Accelerator" }, 
	{ 0x1013, 0x004c, "GD 7556 Video/Graphics LCD/CRT Ctrlr" }, 
	{ 0x1013, 0x00a0, "GD 5430/40 [Alpine]" }, 
	{ 0x1013, 0x00a2, "GD 5432 [Alpine]" }, 
	{ 0x1013, 0x00a4, "GD 5434-4 [Alpine]" }, 
	{ 0x1013, 0x00a8, "GD 5434-8 [Alpine]" }, 
	{ 0x1013, 0x00ac, "GD 5436 [Alpine]" }, 
	{ 0x1013, 0x00b0, "GD 5440" }, 
	{ 0x1013, 0x00b8, "GD 5446" }, 
	{ 0x1013, 0x00bc, "GD 5480" }, 
	{ 0x1013, 0x00d0, "GD 5462" }, 
	{ 0x1013, 0x00d2, "GD 5462 [Laguna I]" }, 
	{ 0x1013, 0x00d4, "GD 5464 [Laguna]" }, 
	{ 0x1013, 0x00d6, "GD 5465 [Laguna]" }, 
	{ 0x1013, 0x00e8, "GD 5436U" }, 
	{ 0x1013, 0x1100, "CL 6729" }, 
	{ 0x1013, 0x1110, "PD 6832 PCMCIA/CardBus Ctrlr" }, 
	{ 0x1013, 0x1112, "PD 6834 PCMCIA/CardBus Ctrlr" }, 
	{ 0x1013, 0x1113, "PD 6833 PCMCIA/CardBus Ctrlr" }, 
	{ 0x1013, 0x1200, "GD 7542 [Nordic]" }, 
	{ 0x1013, 0x1202, "GD 7543 [Viking]" }, 
	{ 0x1013, 0x1204, "GD 7541 [Nordic Light]" }, 
	{ 0x1013, 0x4400, "CD 4400" }, 
	{ 0x1013, 0x6001, "CS 4610/11 [CrystalClear SoundFusion Audio Accelerator]" }, 
	{ 0x1013, 0x6003, "CS 4614/22/24 [CrystalClear SoundFusion Audio Accelerator]" }, 
	{ 0x1013, 0x6004, "CS 4614/22/24 [CrystalClear SoundFusion Audio Accelerator]" }, 
	{ 0x1013, 0x6005, "Crystal CS4281 PCI Audio" }, 
	{ 0x1014, 0x0002, "PCI to MCA Bridge" }, 
	{ 0x1014, 0x0005, "Alta Lite" }, 
	{ 0x1014, 0x0007, "Alta MP" }, 
	{ 0x1014, 0x000a, "Fire Coral" }, 
	{ 0x1014, 0x0017, "CPU to PCI Bridge" }, 
	{ 0x1014, 0x0018, "TR Auto LANstreamer" }, 
	{ 0x1014, 0x001b, "GXT-150P" }, 
	{ 0x1014, 0x001c, "Carrera" }, 
	{ 0x1014, 0x001d, "82G2675" }, 
	{ 0x1014, 0x0020, "MCA" }, 
	{ 0x1014, 0x0022, "IBM27-82351" }, 
	{ 0x1014, 0x002d, "Python" }, 
	{ 0x1014, 0x002e, "ServeRAID-3x" }, 
	{ 0x1014, 0x0036, "Miami" }, 
	{ 0x1014, 0x003a, "CPU to PCI Bridge" }, 
	{ 0x1014, 0x003e, "16/4 Token ring UTP/STP controller" }, 
	{ 0x1014, 0x0045, "SSA Adapter" }, 
	{ 0x1014, 0x0046, "MPIC interrupt controller" }, 
	{ 0x1014, 0x0047, "PCI to PCI Bridge" }, 
	{ 0x1014, 0x0048, "PCI to PCI Bridge" }, 
	{ 0x1014, 0x0049, "Warhead SCSI Controller" }, 
	{ 0x1014, 0x004e, "ATM Controller (14104e00)" }, 
	{ 0x1014, 0x004f, "ATM Controller (14104f00)" }, 
	{ 0x1014, 0x0050, "ATM Controller (14105000)" }, 
	{ 0x1014, 0x0053, "25 MBit ATM Controller" }, 
	{ 0x1014, 0x0057, "MPEG PCI Bridge" }, 
	{ 0x1014, 0x005c, "i82557B 10/100" }, 
	{ 0x1014, 0x007c, "ATM Controller (14107c00)" }, 
	{ 0x1014, 0x007d, "3780IDSP [MWave]" }, 
	{ 0x1014, 0x0090, "GXT 3000P" }, 
	{ 0x1014, 0x0095, "20H2999 PCI Docking Bridge" }, 
	{ 0x1014, 0x0096, "Chukar chipset SCSI controller" }, 
	{ 0x1014, 0x00a5, "ATM Controller (1410a500)" }, 
	{ 0x1014, 0x00a6, "ATM 155MBPS MM Controller (1410a600)" }, 
	{ 0x1014, 0x00b7, "256-bit Graphics Rasterizer [Fire GL1]" }, 
	{ 0x1014, 0x00be, "ATM 622MBPS Controller (1410be00)" }, 
	{ 0x1014, 0x0142, "Yotta Video Compositor Input" }, 
	{ 0x1014, 0x0144, "Yotta Video Compositor Output" }, 
	{ 0x1014, 0x0156, "405GP PLB to PCI Bridge" }, 
	{ 0x1014, 0x01a7, "PCI-X to PCI-X Bridge" }, 
	{ 0x1014, 0x01bd, "Netfinity ServeRAID controller" }, 
	{ 0x1014, 0x01be, "ServeRAID-4M" }, 
	{ 0x1014, 0x01bf, "ServeRAID-4L" }, 
	{ 0x1014, 0x022e, "ServeRAID-4H" }, 
	{ 0x1014, 0xffff, "MPIC-2 interrupt controller" }, 
	{ 0x1017, 0x5343, "SPEA 3D Accelerator" }, 
	{ 0x101a, 0x0005, "100VG ethernet" }, 
	{ 0x101c, 0x0193, "33C193A" }, 
	{ 0x101c, 0x0196, "33C196A" }, 
	{ 0x101c, 0x0197, "33C197A" }, 
	{ 0x101c, 0x0296, "33C296A" }, 
	{ 0x101c, 0x3193, "7193" }, 
	{ 0x101c, 0x3197, "7197" }, 
	{ 0x101c, 0x3296, "33C296A" }, 
	{ 0x101c, 0x4296, "34C296" }, 
	{ 0x101c, 0x9710, "Pipeline 9710" }, 
	{ 0x101c, 0x9712, "Pipeline 9712" }, 
	{ 0x101c, 0xc24a, "90C" }, 
	{ 0x101e, 0x1960, "MegaRAID" }, 
	{ 0x101e, 0x9010, "MegaRAID 428 Ultra RAID Controller" }, 
	{ 0x101e, 0x9030, "EIDE Controller" }, 
	{ 0x101e, 0x9031, "EIDE Controller" }, 
	{ 0x101e, 0x9032, "EIDE & SCSI Controller" }, 
	{ 0x101e, 0x9033, "SCSI Controller" }, 
	{ 0x101e, 0x9040, "Multimedia card" }, 
	{ 0x101e, 0x9060, "MegaRAID 434 Ultra GT RAID Controller" }, 
	{ 0x101e, 0x9063, "MegaRAC" }, 
	{ 0x1022, 0x2000, "79c970 [PCnet LANCE]" }, 
	{ 0x1022, 0x2001, "79c978 [HomePNA]" }, 
	{ 0x1022, 0x2020, "53c974 [PCscsi]" }, 
	{ 0x1022, 0x2040, "79c974" }, 
	{ 0x1022, 0x7006, "AMD-751 [Irongate] System Controller" }, 
	{ 0x1022, 0x7007, "AMD-751 [Irongate] AGP Bridge" }, 
	{ 0x1022, 0x700c, "AMD-760 MP [IGD4-2P] System Controller" }, 
	{ 0x1022, 0x700d, "AMD-760 MP [IGD4-2P] AGP Bridge" }, 
	{ 0x1022, 0x700e, "AMD-760 [IGD4-1P] System Controller" }, 
	{ 0x1022, 0x700f, "AMD-760 [IGD4-1P] AGP Bridge" }, 
	{ 0x1022, 0x7400, "AMD-755 [Cobra] ISA" }, 
	{ 0x1022, 0x7401, "AMD-755 [Cobra] IDE" }, 
	{ 0x1022, 0x7403, "AMD-755 [Cobra] ACPI" }, 
	{ 0x1022, 0x7404, "AMD-755 [Cobra] USB" }, 
	{ 0x1022, 0x7408, "AMD-756 [Viper] ISA" }, 
	{ 0x1022, 0x7409, "AMD-756 [Viper] IDE" }, 
	{ 0x1022, 0x740b, "AMD-756 [Viper] ACPI" }, 
	{ 0x1022, 0x740c, "AMD-756 [Viper] USB" }, 
	{ 0x1022, 0x7410, "AMD-766 [ViperPlus] ISA" }, 
	{ 0x1022, 0x7411, "AMD-766 [ViperPlus] IDE" }, 
	{ 0x1022, 0x7413, "AMD-766 [ViperPlus] ACPI" }, 
	{ 0x1022, 0x7414, "AMD-766 [ViperPlus] USB" }, 
	{ 0x1022, 0x7440, "AMD-768 [Opus] ISA" }, 
	{ 0x1022, 0x7441, "AMD-768 [Opus] IDE" }, 
	{ 0x1022, 0x7443, "AMD-768 [Opus] ACPI" }, 
	{ 0x1022, 0x7448, "AMD-768 [Opus] PCI" }, 
	{ 0x1022, 0x7449, "AMD-768 [Opus] USB" }, 
	{ 0x1022, 0x7454, "AMD-8151 System Controller" }, 
	{ 0x1022, 0x7455, "AMD-8151 AGP Bridge" }, 
	{ 0x1022, 0x7460, "AMD-8111 PCI" }, 
	{ 0x1022, 0x7461, "AMD-8111 USB" }, 
	{ 0x1022, 0x7462, "AMD-8111 Ethernet" }, 
	{ 0x1022, 0x7468, "AMD-8111 LPC" }, 
	{ 0x1022, 0x7469, "AMD-8111 IDE" }, 
	{ 0x1022, 0x746a, "AMD-8111 SMBus 2.0" }, 
	{ 0x1022, 0x746b, "AMD-8111 ACPI" }, 
	{ 0x1022, 0x746d, "AMD-8111 AC97 Audio" }, 
	{ 0x1022, 0x756b, "AMD-8111 ACPI" }, 
	{ 0x1023, 0x0194, "82C194" }, 
	{ 0x1023, 0x2000, "4DWave DX" }, 
	{ 0x1023, 0x2001, "4DWave NX" }, 
	{ 0x1023, 0x8400, "CyberBlade/i7" }, 
	{ 0x1023, 0x8420, "CyberBlade/i7d" }, 
	{ 0x1023, 0x8500, "CyberBlade/i1" }, 
	{ 0x1023, 0x8520, "CyberBlade i1" }, 
	{ 0x1023, 0x8820, "CyberBlade XPAi1" }, 
	{ 0x1023, 0x9320, "TGUI 9320" }, 
	{ 0x1023, 0x9350, "GUI Accelerator" }, 
	{ 0x1023, 0x9360, "Flat panel GUI Accelerator" }, 
	{ 0x1023, 0x9382, "Cyber 9382 [Reference design]" }, 
	{ 0x1023, 0x9383, "Cyber 9383 [Reference design]" }, 
	{ 0x1023, 0x9385, "Cyber 9385 [Reference design]" }, 
	{ 0x1023, 0x9386, "Cyber 9386" }, 
	{ 0x1023, 0x9388, "Cyber 9388" }, 
	{ 0x1023, 0x9397, "Cyber 9397" }, 
	{ 0x1023, 0x939a, "Cyber 9397DVD" }, 
	{ 0x1023, 0x9420, "TGUI 9420" }, 
	{ 0x1023, 0x9430, "TGUI 9430" }, 
	{ 0x1023, 0x9440, "TGUI 9440" }, 
	{ 0x1023, 0x9460, "TGUI 9460" }, 
	{ 0x1023, 0x9470, "TGUI 9470" }, 
	{ 0x1023, 0x9520, "Cyber 9520" }, 
	{ 0x1023, 0x9525, "Cyber 9525" }, 
	{ 0x1023, 0x9540, "Cyber 9540" }, 
	{ 0x1023, 0x9660, "TGUI 9660/968x/968x" }, 
	{ 0x1023, 0x9680, "TGUI 9680" }, 
	{ 0x1023, 0x9682, "TGUI 9682" }, 
	{ 0x1023, 0x9683, "TGUI 9683" }, 
	{ 0x1023, 0x9685, "ProVIDIA 9685" }, 
	{ 0x1023, 0x9750, "3DImage 9750" }, 
	{ 0x1023, 0x9753, "TGUI 9753" }, 
	{ 0x1023, 0x9754, "TGUI 9754" }, 
	{ 0x1023, 0x9759, "TGUI 975" }, 
	{ 0x1023, 0x9783, "TGUI 9783" }, 
	{ 0x1023, 0x9785, "TGUI 9785" }, 
	{ 0x1023, 0x9850, "3DImage 9850" }, 
	{ 0x1023, 0x9880, "Blade 3D PCI/AGP" }, 
	{ 0x1023, 0x9910, "CyberBlade/XP" }, 
	{ 0x1023, 0x9930, "CyberBlade/XPm" }, 
	{ 0x1025, 0x1435, "M1435" }, 
	{ 0x1025, 0x1445, "M1445" }, 
	{ 0x1025, 0x1449, "M1449" }, 
	{ 0x1025, 0x1451, "M1451" }, 
	{ 0x1025, 0x1461, "M1461" }, 
	{ 0x1025, 0x1489, "M1489" }, 
	{ 0x1025, 0x1511, "M1511" }, 
	{ 0x1025, 0x1512, "ALI M1512 Aladdin" }, 
	{ 0x1025, 0x1513, "M1513" }, 
	{ 0x1025, 0x1521, "ALI M1521 Aladdin III CPU Bridge" }, 
	{ 0x1025, 0x1523, "ALI M1523 ISA Bridge" }, 
	{ 0x1025, 0x1531, "M1531 Northbridge [Aladdin IV/IV+]" }, 
	{ 0x1025, 0x1533, "M1533 PCI-to-ISA Bridge" }, 
	{ 0x1025, 0x1535, "M1535 PCI Bridge + Super I/O + FIR" }, 
	{ 0x1025, 0x1541, "M1541 Northbridge [Aladdin V]" }, 
	{ 0x1025, 0x1542, "M1542 Northbridge [Aladdin V]" }, 
	{ 0x1025, 0x1543, "M1543 PCI-to-ISA Bridge + Super I/O + FIR" }, 
	{ 0x1025, 0x1561, "M1561 Northbridge [Aladdin 7]" }, 
	{ 0x1025, 0x1621, "M1621 Northbridge [Aladdin-Pro II]" }, 
	{ 0x1025, 0x1631, "M1631 Northbridge+3D Graphics [Aladdin TNT2]" }, 
	{ 0x1025, 0x1641, "M1641 Northbridge [Aladdin-Pro IV]" }, 
	{ 0x1025, 0x1647, "M1647 [MaGiK1] PCI North Bridge" }, 
	{ 0x1025, 0x3141, "M3141" }, 
	{ 0x1025, 0x3143, "M3143" }, 
	{ 0x1025, 0x3145, "M3145" }, 
	{ 0x1025, 0x3147, "M3147" }, 
	{ 0x1025, 0x3149, "M3149" }, 
	{ 0x1025, 0x3151, "M3151" }, 
	{ 0x1025, 0x3307, "M3307 MPEG-I Video Controller" }, 
	{ 0x1025, 0x3309, "M3309 MPEG-II Video w/ Software Audio Decoder" }, 
	{ 0x1025, 0x3321, "M3321 MPEG-II Audio/Video Decoder" }, 
	{ 0x1025, 0x5212, "M4803" }, 
	{ 0x1025, 0x5215, "ALI PCI EIDE Controller" }, 
	{ 0x1025, 0x5217, "M5217H" }, 
	{ 0x1025, 0x5219, "M5219" }, 
	{ 0x1025, 0x5225, "M5225" }, 
	{ 0x1025, 0x5229, "M5229" }, 
	{ 0x1025, 0x5235, "M5235" }, 
	{ 0x1025, 0x5237, "M5237 PCI USB Host Controller" }, 
	{ 0x1025, 0x5240, "EIDE Controller" }, 
	{ 0x1025, 0x5241, "PCMCIA Bridge" }, 
	{ 0x1025, 0x5242, "General Purpose Controller" }, 
	{ 0x1025, 0x5243, "PCI to PCI Bridge Controller" }, 
	{ 0x1025, 0x5244, "Floppy Disk Controller" }, 
	{ 0x1025, 0x5247, "M1541 PCI to PCI Bridge" }, 
	{ 0x1025, 0x5251, "M5251 P1394 Controller" }, 
	{ 0x1025, 0x5427, "PCI to AGP Bridge" }, 
	{ 0x1025, 0x5451, "M5451 PCI AC-Link Controller Audio Device" }, 
	{ 0x1025, 0x5453, "M5453 PCI AC-Link Controller Modem Device" }, 
	{ 0x1025, 0x7101, "M7101 PCI PMU Power Management Controller" }, 
	{ 0x1028, 0x0001, "PowerEdge Expandable RAID Controller 2/Si" }, 
	{ 0x1028, 0x0002, "PowerEdge Expandable RAID Controller 3/Di" }, 
	{ 0x1028, 0x0003, "PowerEdge Expandable RAID Controller 3/Si" }, 
	{ 0x1028, 0x0004, "PowerEdge Expandable RAID Controller 3/Si" }, 
	{ 0x1028, 0x0005, "PowerEdge Expandable RAID Controller 3/Di" }, 
	{ 0x1028, 0x0006, "PowerEdge Expandable RAID Controller 3/Di" }, 
	{ 0x1028, 0x0007, "Remote Assitant Card 3" }, 
	{ 0x1028, 0x0008, "PowerEdge Expandable RAID Controller 3/Di" }, 
	{ 0x1028, 0x000a, "PowerEdge Expandable RAID Controller 3/Di" }, 
	{ 0x1028, 0x000c, "Embedded Systems Management Device 4" }, 
	{ 0x102a, 0x0000, "HYDRA" }, 
	{ 0x102a, 0x0010, "ASPEN" }, 
	{ 0x102b, 0x0010, "MGA-I [Impression?]" }, 
	{ 0x102b, 0x0518, "MGA-II [Athena]" }, 
	{ 0x102b, 0x0519, "MGA 2064W [Millennium]" }, 
	{ 0x102b, 0x051a, "MGA 1064SG [Mystique]" }, 
	{ 0x102b, 0x051b, "MGA 2164W [Millennium II]" }, 
	{ 0x102b, 0x051e, "MGA 1064SG [Mystique] AGP" }, 
	{ 0x102b, 0x051f, "MGA 2164W [Millennium II] AGP" }, 
	{ 0x102b, 0x0520, "MGA G200" }, 
	{ 0x102b, 0x0521, "MGA G200 AGP" }, 
	{ 0x102b, 0x0525, "MGA G400 AGP" }, 
	{ 0x102b, 0x0d10, "MGA Ultima/Impression" }, 
	{ 0x102b, 0x1000, "MGA G100 [Productiva]" }, 
	{ 0x102b, 0x1001, "MGA G100 [Productiva] AGP" }, 
	{ 0x102b, 0x2007, "MGA Mistral" }, 
	{ 0x102b, 0x2527, "MGA G550 AGP" }, 
	{ 0x102b, 0x4536, "VIA Framegrabber" }, 
	{ 0x102b, 0x6573, "Shark 10/100 Multiport SwitchNIC" }, 
	{ 0x102c, 0x00b8, "F64310" }, 
	{ 0x102c, 0x00c0, "F69000 HiQVideo" }, 
	{ 0x102c, 0x00d0, "F65545" }, 
	{ 0x102c, 0x00d8, "F65545" }, 
	{ 0x102c, 0x00dc, "F65548" }, 
	{ 0x102c, 0x00e0, "F65550" }, 
	{ 0x102c, 0x00e4, "F65554" }, 
	{ 0x102c, 0x00e5, "F65555 HiQVPro" }, 
	{ 0x102c, 0x00f0, "F68554" }, 
	{ 0x102c, 0x00f4, "F68554 HiQVision" }, 
	{ 0x102c, 0x00f5, "F68555" }, 
	{ 0x102d, 0x50dc, "3328 Audio" }, 
	{ 0x102f, 0x0009, "r4x00" }, 
	{ 0x102f, 0x0020, "ATM Meteor 155" }, 
	{ 0x1031, 0x5601, "DC20 ASIC" }, 
	{ 0x1031, 0x5607, "Video I/O & motion JPEG compressor" }, 
	{ 0x1031, 0x5631, "Media 3D" }, 
	{ 0x1031, 0x6057, "MiroVideo DC10/DC30+" }, 
	{ 0x1033, 0x0001, "PCI to 486-like bus Bridge" }, 
	{ 0x1033, 0x0002, "PCI to VL98 Bridge" }, 
	{ 0x1033, 0x0003, "ATM Controller" }, 
	{ 0x1033, 0x0004, "R4000 PCI Bridge" }, 
	{ 0x1033, 0x0005, "PCI to 486-like bus Bridge" }, 
	{ 0x1033, 0x0006, "GUI Accelerator" }, 
	{ 0x1033, 0x0007, "PCI to UX-Bus Bridge" }, 
	{ 0x1033, 0x0008, "GUI Accelerator" }, 
	{ 0x1033, 0x0009, "GUI Accelerator for W98" }, 
	{ 0x1033, 0x001a, "[Nile II]" }, 
	{ 0x1033, 0x0021, "Vrc4373 [Nile I]" }, 
	{ 0x1033, 0x0029, "PowerVR PCX1" }, 
	{ 0x1033, 0x002a, "PowerVR 3D" }, 
	{ 0x1033, 0x0035, "USB" }, 
	{ 0x1033, 0x003e, "NAPCCARD Cardbus Controller" }, 
	{ 0x1033, 0x0046, "PowerVR PCX2 [midas]" }, 
	{ 0x1033, 0x005a, "Vrc5074 [Nile 4]" }, 
	{ 0x1033, 0x0063, "Firewarden" }, 
	{ 0x1033, 0x0067, "PowerVR Neon 250 Chipset" }, 
	{ 0x1033, 0x0074, "56k Voice Modem" }, 
	{ 0x1033, 0x009b, "Vrc5476" }, 
	{ 0x1033, 0x00a6, "VRC5477 AC97" }, 
	{ 0x1033, 0x00cd, "IEEE 1394 [OrangeLink] Host Controller" }, 
	{ 0x1033, 0x00e0, "USB 2.0" }, 
	{ 0x1036, 0x0000, "TMC-18C30 [36C70]" }, 
	{ 0x1039, 0x0001, "5591/5592 AGP" }, 
	{ 0x1039, 0x0002, "SG86C202" }, 
	{ 0x1039, 0x0006, "85C501/2/3" }, 
	{ 0x1039, 0x0008, "85C503/5513" }, 
	{ 0x1039, 0x0009, "ACPI" }, 
	{ 0x1039, 0x0018, "SiS85C503/5513 (LPC Bridge)" }, 
	{ 0x1039, 0x0200, "5597/5598 VGA" }, 
	{ 0x1039, 0x0204, "82C204" }, 
	{ 0x1039, 0x0205, "SG86C205" }, 
	{ 0x1039, 0x0406, "85C501/2" }, 
	{ 0x1039, 0x0496, "85C496" }, 
	{ 0x1039, 0x0530, "530 Host" }, 
	{ 0x1039, 0x0540, "540 Host" }, 
	{ 0x1039, 0x0597, "5513C" }, 
	{ 0x1039, 0x0601, "85C601" }, 
	{ 0x1039, 0x0620, "620 Host" }, 
	{ 0x1039, 0x0630, "630 Host" }, 
	{ 0x1039, 0x0730, "730 Host" }, 
	{ 0x1039, 0x0735, "735 Host" }, 
	{ 0x1039, 0x0900, "SiS900 10/100 Ethernet" }, 
	{ 0x1039, 0x3602, "83C602" }, 
	{ 0x1039, 0x5107, "5107" }, 
	{ 0x1039, 0x5300, "SiS540 PCI Display Adapter" }, 
	{ 0x1039, 0x5401, "486 PCI Chipset" }, 
	{ 0x1039, 0x5511, "5511/5512" }, 
	{ 0x1039, 0x5513, "5513 [IDE]" }, 
	{ 0x1039, 0x5517, "5517" }, 
	{ 0x1039, 0x5571, "5571" }, 
	{ 0x1039, 0x5581, "5581 Pentium Chipset" }, 
	{ 0x1039, 0x5582, "5582" }, 
	{ 0x1039, 0x5591, "5591/5592 Host" }, 
	{ 0x1039, 0x5596, "5596 Pentium Chipset" }, 
	{ 0x1039, 0x5597, "5597 [SiS5582]" }, 
	{ 0x1039, 0x5600, "5600 Host" }, 
	{ 0x1039, 0x6204, "Video decoder & MPEG interface" }, 
	{ 0x1039, 0x6205, "VGA Controller" }, 
	{ 0x1039, 0x6236, "6236 3D-AGP" }, 
	{ 0x1039, 0x6300, "SiS630 GUI Accelerator+3D" }, 
	{ 0x1039, 0x6306, "6306 3D-AGP" }, 
	{ 0x1039, 0x6326, "86C326" }, 
	{ 0x1039, 0x7001, "7001" }, 
	{ 0x1039, 0x7007, "FireWire Controller" }, 
	{ 0x1039, 0x7012, "SiS7012 PCI Audio Accelerator" }, 
	{ 0x1039, 0x7013, "56k Winmodem (Smart Link HAMR5600 compatible)" }, 
	{ 0x1039, 0x7016, "SiS7016 10/100 Ethernet Adapter" }, 
	{ 0x1039, 0x7018, "SiS PCI Audio Accelerator" }, 
	{ 0x103c, 0x1005, "A4977A Visualize EG" }, 
	{ 0x103c, 0x1028, "Tach TL Fibre Channel Host Adapter" }, 
	{ 0x103c, 0x1029, "Tach XL2 Fibre Channel Host Adapter" }, 
	{ 0x103c, 0x102a, "Tach TS Fibre Channel Host Adapter" }, 
	{ 0x103c, 0x1030, "J2585A DeskDirect 10/100VG NIC" }, 
	{ 0x103c, 0x1031, "J2585B HP 10/100VG PCI LAN Adapter" }, 
	{ 0x103c, 0x1040, "J2973A DeskDirect 10BaseT NIC" }, 
	{ 0x103c, 0x1041, "J2585B DeskDirect 10/100 NIC" }, 
	{ 0x103c, 0x1042, "J2970A DeskDirect 10BaseT/2 NIC" }, 
	{ 0x103c, 0x1064, "79C970 PCnet Ethernet Controller" }, 
	{ 0x103c, 0x10c1, "NetServer Smart IRQ Router" }, 
	{ 0x103c, 0x10ed, "TopTools Remote Control" }, 
	{ 0x103c, 0x1200, "82557B 10/100 NIC" }, 
	{ 0x103c, 0x1219, "NetServer PCI Hot-Plug Controller" }, 
	{ 0x103c, 0x121a, "NetServer SMIC Controller" }, 
	{ 0x103c, 0x121b, "NetServer Legacy COM Port Decoder" }, 
	{ 0x103c, 0x121c, "NetServer PCI COM Port Decoder" }, 
	{ 0x103c, 0x1229, "zx1 System Bus Adapter" }, 
	{ 0x103c, 0x122a, "zx1 I/O Controller" }, 
	{ 0x103c, 0x122e, "zx1 Local Bus Adapter" }, 
	{ 0x103c, 0x2910, "E2910A PCIBus Exerciser" }, 
	{ 0x103c, 0x2925, "E2925A 32 Bit, 33 MHzPCI Exerciser & Analyzer" }, 
	{ 0x1042, 0x1000, "FDC 37C665" }, 
	{ 0x1042, 0x1001, "37C922" }, 
	{ 0x1042, 0x3000, "Samurai_0" }, 
	{ 0x1042, 0x3010, "Samurai_1" }, 
	{ 0x1042, 0x3020, "Samurai_IDE" }, 
	{ 0x1043, 0x0675, "ISDNLink P-IN100-ST-D" }, 
	{ 0x1043, 0x4057, "V8200 GeForce 3" }, 
	{ 0x1044, 0x1012, "Domino RAID Engine" }, 
	{ 0x1044, 0xa400, "SmartCache/Raid I-IV Controller" }, 
	{ 0x1044, 0xa500, "PCI Bridge" }, 
	{ 0x1044, 0xa501, "SmartRAID V Controller" }, 
	{ 0x1044, 0xa511, "SmartRAID V Controller" }, 
	{ 0x1045, 0xa0f8, "82C750 [Vendetta] USB Controller" }, 
	{ 0x1045, 0xc101, "92C264" }, 
	{ 0x1045, 0xc178, "92C178" }, 
	{ 0x1045, 0xc556, "82X556 [Viper]" }, 
	{ 0x1045, 0xc557, "82C557 [Viper-M]" }, 
	{ 0x1045, 0xc558, "82C558 [Viper-M ISA+IDE]" }, 
	{ 0x1045, 0xc567, "82C750 [Vendetta], device 0" }, 
	{ 0x1045, 0xc568, "82C750 [Vendetta], device 1" }, 
	{ 0x1045, 0xc569, "82C579 [Viper XPress+ Chipset]" }, 
	{ 0x1045, 0xc621, "82C621" }, 
	{ 0x1045, 0xc700, "82C700" }, 
	{ 0x1045, 0xc701, "82C701 [FireStar Plus]" }, 
	{ 0x1045, 0xc814, "82C814 [Firebridge 1]" }, 
	{ 0x1045, 0xc822, "82C822" }, 
	{ 0x1045, 0xc824, "82C824" }, 
	{ 0x1045, 0xc825, "82C825 [Firebridge 2]" }, 
	{ 0x1045, 0xc832, "82C832" }, 
	{ 0x1045, 0xc861, "82C861" }, 
	{ 0x1045, 0xc895, "82C895" }, 
	{ 0x1045, 0xc935, "EV1935 ECTIVA MachOne PCI Audio" }, 
	{ 0x1045, 0xd568, "82C825 [Firebridge 2]" }, 
	{ 0x1048, 0x1000, "QuickStep 1000" }, 
	{ 0x1048, 0x3000, "QuickStep 3000" }, 
	{ 0x104a, 0x0008, "STG 2000X" }, 
	{ 0x104a, 0x0009, "STG 1764X" }, 
	{ 0x104a, 0x0981, "DEC-Tulip compatible 10/100 Ethernet" }, 
	{ 0x104a, 0x1746, "STG 1764X" }, 
	{ 0x104a, 0x2774, "DEC-Tulip compatible 10/100 Ethernet" }, 
	{ 0x104a, 0x3520, "MPEG-II decoder card" }, 
	{ 0x104b, 0x0140, "BT-946C (old) [multimaster  01]" }, 
	{ 0x104b, 0x1040, "BT-946C (BA80C30) [MultiMaster 10]" }, 
	{ 0x104b, 0x8130, "Flashpoint LT" }, 
	{ 0x104c, 0x0500, "100 MBit LAN Controller" }, 
	{ 0x104c, 0x0508, "TMS380C2X Compressor Interface" }, 
	{ 0x104c, 0x1000, "Eagle i/f AS" }, 
	{ 0x104c, 0x3d04, "TVP4010 [Permedia]" }, 
	{ 0x104c, 0x3d07, "TVP4020 [Permedia 2]" }, 
	{ 0x104c, 0x8000, "PCILynx/PCILynx2 IEEE 1394 Link Layer Controller" }, 
	{ 0x104c, 0x8009, "FireWire Controller" }, 
	{ 0x104c, 0x8017, "PCI4410 FireWire Controller" }, 
	{ 0x104c, 0x8019, "TSB12LV23 IEEE-1394 Controller" }, 
	{ 0x104c, 0x8020, "TSB12LV26 IEEE-1394 Controller (Link)" }, 
	{ 0x104c, 0x8021, "TSB43AA22 IEEE-1394 Controller (PHY/Link Integrated)" }, 
	{ 0x104c, 0x8022, "TSB43AB22 IEEE-1394 Controller (PHY/Link) 1394a-2000" }, 
	{ 0x104c, 0x8024, "TSB43AB23 IEEE-1394 Controller (PHY/Link) 1394a-2000" }, 
	{ 0x104c, 0x8026, "TSB43AB21 IEEE-1394 Controller (PHY/Link) 1394a-2000" }, 
	{ 0x104c, 0x8027, "PCI4451 IEEE-1394 Controller" }, 
	{ 0x104c, 0xa001, "TDC1570" }, 
	{ 0x104c, 0xa100, "TDC1561" }, 
	{ 0x104c, 0xac10, "PCI1050" }, 
	{ 0x104c, 0xac11, "PCI1053" }, 
	{ 0x104c, 0xac12, "PCI1130" }, 
	{ 0x104c, 0xac13, "PCI1031" }, 
	{ 0x104c, 0xac15, "PCI1131" }, 
	{ 0x104c, 0xac16, "PCI1250" }, 
	{ 0x104c, 0xac17, "PCI1220" }, 
	{ 0x104c, 0xac18, "PCI1260" }, 
	{ 0x104c, 0xac19, "PCI1221" }, 
	{ 0x104c, 0xac1a, "PCI1210" }, 
	{ 0x104c, 0xac1b, "PCI1450" }, 
	{ 0x104c, 0xac1c, "PCI1225" }, 
	{ 0x104c, 0xac1d, "PCI1251A" }, 
	{ 0x104c, 0xac1e, "PCI1211" }, 
	{ 0x104c, 0xac1f, "PCI1251B" }, 
	{ 0x104c, 0xac20, "TI 2030" }, 
	{ 0x104c, 0xac21, "PCI2031" }, 
	{ 0x104c, 0xac30, "PCI1260 PC card Cardbus Controller" }, 
	{ 0x104c, 0xac40, "PCI4450 PC card Cardbus Controller" }, 
	{ 0x104c, 0xac41, "PCI4410 PC card Cardbus Controller" }, 
	{ 0x104c, 0xac42, "PCI4451 PC card Cardbus Controller" }, 
	{ 0x104c, 0xac50, "PCI1410 PC card Cardbus Controller" }, 
	{ 0x104c, 0xac51, "PCI1420" }, 
	{ 0x104c, 0xac52, "PCI1451 PC card Cardbus Controller" }, 
	{ 0x104c, 0xac53, "PCI1421 PC card Cardbus Controller" }, 
	{ 0x104c, 0xfe00, "FireWire Host Controller" }, 
	{ 0x104c, 0xfe03, "12C01A FireWire Host Controller" }, 
	{ 0x104d, 0x8009, "CXD1947Q i.LINK Controller" }, 
	{ 0x104d, 0x8039, "CXD3222 i.LINK Controller" }, 
	{ 0x104d, 0x8056, "Rockwell HCF 56K modem" }, 
	{ 0x104d, 0x808a, "Memory Stick Controller" }, 
	{ 0x104d, 0x80e7, "Vaio PCG-GR114MK" }, 
	{ 0x104e, 0x0017, "OTI-64017" }, 
	{ 0x104e, 0x0107, "OTI-107 [Spitfire]" }, 
	{ 0x104e, 0x0109, "Video Adapter" }, 
	{ 0x104e, 0x0111, "OTI-64111 [Spitfire]" }, 
	{ 0x104e, 0x0217, "OTI-64217" }, 
	{ 0x104e, 0x0317, "OTI-64317" }, 
	{ 0x1050, 0x0000, "NE2000" }, 
	{ 0x1050, 0x0001, "W83769F" }, 
	{ 0x1050, 0x0105, "W82C105" }, 
	{ 0x1050, 0x0840, "W89C840" }, 
	{ 0x1050, 0x0940, "W89C940" }, 
	{ 0x1050, 0x5a5a, "W89C940F" }, 
	{ 0x1050, 0x9970, "W9970CF" }, 
	{ 0x1055, 0x9130, "EIDE Controller" }, 
	{ 0x1055, 0x9460, "PCI to ISA Bridge" }, 
	{ 0x1055, 0x9462, "USB Universal Host Controller" }, 
	{ 0x1055, 0x9463, "Power Management Controller [Bridge]" }, 
	{ 0x1057, 0x0001, "MPC105 [Eagle]" }, 
	{ 0x1057, 0x0002, "MPC106 [Grackle]" }, 
	{ 0x1057, 0x0100, "MC145575 [HFC-PCI]" }, 
	{ 0x1057, 0x0431, "KTI829c 100VG" }, 
	{ 0x1057, 0x1801, "Audio I/O Controller (MIDI)" }, 
	{ 0x1057, 0x4801, "Raven" }, 
	{ 0x1057, 0x4802, "Falcon" }, 
	{ 0x1057, 0x4803, "Hawk" }, 
	{ 0x1057, 0x4806, "CPX8216" }, 
	{ 0x1057, 0x4d68, "20268" }, 
	{ 0x1057, 0x5600, "SM56 PCI Modem" }, 
	{ 0x105a, 0x0d30, "20265" }, 
	{ 0x105a, 0x0d38, "20263" }, 
	{ 0x105a, 0x4d30, "20267" }, 
	{ 0x105a, 0x4d33, "20246" }, 
	{ 0x105a, 0x4d38, "20262" }, 
	{ 0x105a, 0x4d68, "20268" }, 
	{ 0x105a, 0x4d69, "20269" }, 
	{ 0x105a, 0x5275, "PDC20276 IDE" }, 
	{ 0x105a, 0x5300, "DC5300" }, 
	{ 0x105a, 0x6268, "20268R" }, 
	{ 0x105d, 0x2309, "Imagine 128" }, 
	{ 0x105d, 0x2339, "Imagine 128-II" }, 
	{ 0x105d, 0x493d, "Imagine 128 T2R [Ticket to Ride]" }, 
	{ 0x105d, 0x5348, "Revolution 4" }, 
	{ 0x1060, 0x0001, "UM82C881" }, 
	{ 0x1060, 0x0002, "UM82C886" }, 
	{ 0x1060, 0x0101, "UM8673F" }, 
	{ 0x1060, 0x0881, "UM8881" }, 
	{ 0x1060, 0x0886, "UM8886F" }, 
	{ 0x1060, 0x0891, "UM8891A" }, 
	{ 0x1060, 0x1001, "UM886A" }, 
	{ 0x1060, 0x673a, "UM8886BF" }, 
	{ 0x1060, 0x673b, "EIDE Master/DMA" }, 
	{ 0x1060, 0x8710, "UM8710" }, 
	{ 0x1060, 0x886a, "UM8886A" }, 
	{ 0x1060, 0x8881, "UM8881F" }, 
	{ 0x1060, 0x8886, "UM8886F" }, 
	{ 0x1060, 0x888a, "UM8886A" }, 
	{ 0x1060, 0x8891, "UM8891A" }, 
	{ 0x1060, 0x9017, "UM9017F" }, 
	{ 0x1060, 0x9018, "UM9018" }, 
	{ 0x1060, 0x9026, "UM9026" }, 
	{ 0x1060, 0xe881, "UM8881N" }, 
	{ 0x1060, 0xe886, "UM8886N" }, 
	{ 0x1060, 0xe88a, "UM8886N" }, 
	{ 0x1060, 0xe891, "UM8891N" }, 
	{ 0x1061, 0x0001, "AGX016" }, 
	{ 0x1061, 0x0002, "IIT3204/3501" }, 
	{ 0x1066, 0x0000, "PT80C826" }, 
	{ 0x1066, 0x0001, "PT86C52x [Vesuvius]" }, 
	{ 0x1066, 0x0002, "PT80C524 [Nile]" }, 
	{ 0x1066, 0x0005, "National PC87550 System Controller" }, 
	{ 0x1066, 0x8002, "PT80C524 [Nile]" }, 
	{ 0x1067, 0x1002, "VG500 [VolumePro Volume Rendering Accelerator]" }, 
	{ 0x1069, 0x0001, "DAC960P" }, 
	{ 0x1069, 0x0002, "DAC960PD" }, 
	{ 0x1069, 0x0010, "DAC960PX" }, 
	{ 0x1069, 0x0050, "AcceleRAID 352/170/160 support Device" }, 
	{ 0x1069, 0xba55, "eXtremeRAID 1100 support Device" }, 
	{ 0x1069, 0xba56, "eXtremeRAID 2000/3000 support Device" }, 
	{ 0x106b, 0x0001, "Bandit PowerPC host bridge" }, 
	{ 0x106b, 0x0002, "Grand Central I/O" }, 
	{ 0x106b, 0x0003, "Control Video" }, 
	{ 0x106b, 0x0004, "PlanB Video-In" }, 
	{ 0x106b, 0x0007, "O'Hare I/O" }, 
	{ 0x106b, 0x000e, "Hydra Mac I/O" }, 
	{ 0x106b, 0x0010, "Heathrow Mac I/O" }, 
	{ 0x106b, 0x0017, "Paddington Mac I/O" }, 
	{ 0x106b, 0x0018, "UniNorth FireWire" }, 
	{ 0x106b, 0x0019, "KeyLargo USB" }, 
	{ 0x106b, 0x001e, "UniNorth Internal PCI" }, 
	{ 0x106b, 0x001f, "UniNorth PCI" }, 
	{ 0x106b, 0x0020, "UniNorth AGP" }, 
	{ 0x106b, 0x0021, "UniNorth GMAC (Sun GEM)" }, 
	{ 0x106b, 0x0022, "KeyLargo Mac I/O" }, 
	{ 0x106b, 0x0024, "UniNorth/Pangea GMAC (Sun GEM)" }, 
	{ 0x106b, 0x0025, "KeyLargo/Pangea Mac I/O" }, 
	{ 0x106b, 0x0026, "KeyLargo/Pangea USB" }, 
	{ 0x106b, 0x0027, "UniNorth/Pangea AGP" }, 
	{ 0x106b, 0x0028, "UniNorth/Pangea PCI" }, 
	{ 0x106b, 0x0029, "UniNorth/Pangea Internal PCI" }, 
	{ 0x106b, 0x002d, "UniNorth 1.5 AGP" }, 
	{ 0x106b, 0x002e, "UniNorth 1.5 PCI" }, 
	{ 0x106b, 0x002f, "UniNorth 1.5 Internal PCI" }, 
	{ 0x106b, 0x0030, "UniNorth/Pangea FireWire" }, 
	{ 0x106c, 0x8801, "Dual Pentium ISA/PCI Motherboard" }, 
	{ 0x106c, 0x8802, "PowerPC ISA/PCI Motherboard" }, 
	{ 0x106c, 0x8803, "Dual Window Graphics Accelerator" }, 
	{ 0x106c, 0x8804, "LAN Controller" }, 
	{ 0x106c, 0x8805, "100-BaseT LAN" }, 
	{ 0x1073, 0x0001, "3D GUI Accelerator" }, 
	{ 0x1073, 0x0002, "YGV615 [RPA3 3D-Graphics Controller]" }, 
	{ 0x1073, 0x0003, "YMF-740" }, 
	{ 0x1073, 0x0004, "YMF-724" }, 
	{ 0x1073, 0x0005, "DS1 Audio" }, 
	{ 0x1073, 0x0006, "DS1 Audio" }, 
	{ 0x1073, 0x0008, "DS1 Audio" }, 
	{ 0x1073, 0x000a, "DS1L Audio" }, 
	{ 0x1073, 0x000c, "YMF-740C [DS-1L Audio Controller]" }, 
	{ 0x1073, 0x000d, "YMF-724F [DS-1 Audio Controller]" }, 
	{ 0x1073, 0x0010, "YMF-744B [DS-1S Audio Controller]" }, 
	{ 0x1073, 0x0012, "YMF-754 [DS-1E Audio Controller]" }, 
	{ 0x1073, 0x0020, "DS-1 Audio" }, 
	{ 0x1073, 0x2000, "DS2416 Digital Mixing Card" }, 
	{ 0x1074, 0x4e78, "82c500/1" }, 
	{ 0x1077, 0x1016, "ISP10160 Single Channel Ultra3 SCSI Processor" }, 
	{ 0x1077, 0x1020, "ISP1020 Fast-wide SCSI" }, 
	{ 0x1077, 0x1022, "ISP1022 Fast-wide SCSI" }, 
	{ 0x1077, 0x1080, "ISP1080 SCSI Host Adapter" }, 
	{ 0x1077, 0x1216, "ISP12160 Dual Channel Ultra3 SCSI Processor" }, 
	{ 0x1077, 0x1240, "ISP1240 SCSI Host Adapter" }, 
	{ 0x1077, 0x1280, "ISP1280" }, 
	{ 0x1077, 0x2020, "ISP2020A Fast!SCSI Basic Adapter" }, 
	{ 0x1077, 0x2100, "QLA2100 64-bit Fibre Channel Adapter" }, 
	{ 0x1077, 0x2200, "QLA2200" }, 
	{ 0x1077, 0x2300, "QLA2300 64-bit FC-AL Adapter" }, 
	{ 0x1077, 0x2312, "QLA2312 Fibre Channel Adapter" }, 
	{ 0x1078, 0x0000, "5510 [Grappa]" }, 
	{ 0x1078, 0x0001, "PCI Master" }, 
	{ 0x1078, 0x0002, "5520 [Cognac]" }, 
	{ 0x1078, 0x0100, "5530 Legacy [Kahlua]" }, 
	{ 0x1078, 0x0101, "5530 SMI [Kahlua]" }, 
	{ 0x1078, 0x0102, "5530 IDE [Kahlua]" }, 
	{ 0x1078, 0x0103, "5530 Audio [Kahlua]" }, 
	{ 0x1078, 0x0104, "5530 Video [Kahlua]" }, 
	{ 0x1078, 0x0400, "ZFMicro PCI Bridge" }, 
	{ 0x1078, 0x0401, "ZFMicro Chipset SMI" }, 
	{ 0x1078, 0x0402, "ZFMicro Chipset IDE" }, 
	{ 0x1078, 0x0403, "ZFMicro Expansion Bus" }, 
	{ 0x107d, 0x0000, "P86C850" }, 
	{ 0x107e, 0x0001, "5515 ATM Adapter [Flipper]" }, 
	{ 0x107e, 0x0002, "100 VG AnyLan Controller" }, 
	{ 0x107e, 0x0004, "5526 Fibre Channel Host Adapter" }, 
	{ 0x107e, 0x0005, "x526 Fibre Channel Host Adapter" }, 
	{ 0x107e, 0x0008, "5525/5575 ATM Adapter (155 Mbit) [Atlantic]" }, 
	{ 0x107e, 0x9003, "5535-4P-BRI-ST" }, 
	{ 0x107e, 0x9007, "5535-4P-BRI-U" }, 
	{ 0x107e, 0x9008, "5535-1P-SR" }, 
	{ 0x107e, 0x900c, "5535-1P-SR-ST" }, 
	{ 0x107e, 0x900e, "5535-1P-SR-U" }, 
	{ 0x107e, 0x9011, "5535-1P-PRI" }, 
	{ 0x107e, 0x9013, "5535-2P-PRI" }, 
	{ 0x107e, 0x9023, "5536-4P-BRI-ST" }, 
	{ 0x107e, 0x9027, "5536-4P-BRI-U" }, 
	{ 0x107e, 0x9031, "5536-1P-PRI" }, 
	{ 0x107e, 0x9033, "5536-2P-PRI" }, 
	{ 0x107f, 0x0802, "SL82C105" }, 
	{ 0x1080, 0x0600, "82C599" }, 
	{ 0x1080, 0xc691, "Cypress CY82C691" }, 
	{ 0x1080, 0xc693, "82c693" }, 
	{ 0x1081, 0x0d47, "Radius PCI to NuBUS Bridge" }, 
	{ 0x1083, 0x0001, "FR710" }, 
	{ 0x108a, 0x0001, "VME Bridge Model 617" }, 
	{ 0x108a, 0x0010, "VME Bridge Model 618" }, 
	{ 0x108a, 0x3000, "VME Bridge Model 2706" }, 
	{ 0x108d, 0x0001, "Token-Ring 16/4 PCI Adapter (3136/3137)" }, 
	{ 0x108d, 0x0002, "16/4 Token Ring" }, 
	{ 0x108d, 0x0004, "RapidFire 3139 Token-Ring 16/4 PCI Adapter" }, 
	{ 0x108d, 0x0005, "GoCard 3250 Token-Ring 16/4 CardBus PC Card" }, 
	{ 0x108d, 0x0006, "OC-3530 RapidFire Token-Ring 100" }, 
	{ 0x108d, 0x0007, "RapidFire 3141 Token-Ring 16/4 PCI Fiber Adapter" }, 
	{ 0x108d, 0x0008, "RapidFire 3540 HSTR 100/16/4 PCI Adapter" }, 
	{ 0x108d, 0x0011, "OC-2315" }, 
	{ 0x108d, 0x0012, "OC-2325" }, 
	{ 0x108d, 0x0013, "OC-2183/2185" }, 
	{ 0x108d, 0x0014, "OC-2326" }, 
	{ 0x108d, 0x0019, "OC-2327/2250 10/100 Ethernet Adapter" }, 
	{ 0x108d, 0x0021, "OC-6151/6152 [RapidFire ATM 155]" }, 
	{ 0x108d, 0x0022, "ATM Adapter" }, 
	{ 0x108e, 0x0001, "EBUS" }, 
	{ 0x108e, 0x1000, "EBUS" }, 
	{ 0x108e, 0x1001, "Happy Meal" }, 
	{ 0x108e, 0x1100, "RIO EBUS" }, 
	{ 0x108e, 0x1101, "RIO GEM" }, 
	{ 0x108e, 0x1102, "RIO 1394" }, 
	{ 0x108e, 0x1103, "RIO USB" }, 
	{ 0x108e, 0x2bad, "GEM" }, 
	{ 0x108e, 0x5000, "Simba Advanced PCI Bridge" }, 
	{ 0x108e, 0x5043, "SunPCI Co-processor" }, 
	{ 0x108e, 0x8000, "Psycho PCI Bus Module" }, 
	{ 0x108e, 0x8001, "Schizo PCI Bus Module" }, 
	{ 0x108e, 0xa000, "Ultra IIi" }, 
	{ 0x108e, 0xa001, "Ultra IIe" }, 
	{ 0x1091, 0x0020, "3D graphics processor" }, 
	{ 0x1091, 0x0021, "3D graphics processor w/Texturing" }, 
	{ 0x1091, 0x0040, "3D graphics frame buffer" }, 
	{ 0x1091, 0x0041, "3D graphics frame buffer" }, 
	{ 0x1091, 0x0060, "Proprietary bus bridge" }, 
	{ 0x1091, 0x00e4, "Powerstorm 4D50T" }, 
	{ 0x1091, 0x0720, "Motion JPEG codec" }, 
	{ 0x1092, 0x00a0, "Speedstar Pro SE" }, 
	{ 0x1092, 0x00a8, "Speedstar 64" }, 
	{ 0x1092, 0x0550, "Viper V550" }, 
	{ 0x1092, 0x08d4, "Supra 2260 Modem" }, 
	{ 0x1092, 0x094c, "SupraExpress 56i Pro" }, 
	{ 0x1092, 0x1092, "Viper V330" }, 
	{ 0x1092, 0x6120, "Maximum DVD" }, 
	{ 0x1092, 0x8810, "Stealth SE" }, 
	{ 0x1092, 0x8811, "Stealth 64/SE" }, 
	{ 0x1092, 0x8880, "Stealth" }, 
	{ 0x1092, 0x8881, "Stealth" }, 
	{ 0x1092, 0x88b0, "Stealth 64" }, 
	{ 0x1092, 0x88b1, "Stealth 64" }, 
	{ 0x1092, 0x88c0, "Stealth 64" }, 
	{ 0x1092, 0x88c1, "Stealth 64" }, 
	{ 0x1092, 0x88d0, "Stealth 64" }, 
	{ 0x1092, 0x88d1, "Stealth 64" }, 
	{ 0x1092, 0x88f0, "Stealth 64" }, 
	{ 0x1092, 0x88f1, "Stealth 64" }, 
	{ 0x1092, 0x9999, "DMD-I0928-1 \"Monster sound\" sound chip" }, 
	{ 0x1093, 0x0160, "PCI-DIO-96" }, 
	{ 0x1093, 0x0162, "PCI-MIO-16XE-50" }, 
	{ 0x1093, 0x1170, "PCI-MIO-16XE-10" }, 
	{ 0x1093, 0x1180, "PCI-MIO-16E-1" }, 
	{ 0x1093, 0x1190, "PCI-MIO-16E-4" }, 
	{ 0x1093, 0x1330, "PCI-6031E" }, 
	{ 0x1093, 0x1350, "PCI-6071E" }, 
	{ 0x1093, 0x2a60, "PCI-6023E" }, 
	{ 0x1093, 0xb001, "IMAQ-PCI-1408" }, 
	{ 0x1093, 0xb011, "IMAQ-PXI-1408" }, 
	{ 0x1093, 0xb021, "IMAQ-PCI-1424" }, 
	{ 0x1093, 0xb031, "IMAQ-PCI-1413" }, 
	{ 0x1093, 0xb041, "IMAQ-PCI-1407" }, 
	{ 0x1093, 0xb051, "IMAQ-PXI-1407" }, 
	{ 0x1093, 0xb061, "IMAQ-PCI-1411" }, 
	{ 0x1093, 0xb071, "IMAQ-PCI-1422" }, 
	{ 0x1093, 0xb081, "IMAQ-PXI-1422" }, 
	{ 0x1093, 0xb091, "IMAQ-PXI-1411" }, 
	{ 0x1093, 0xc801, "PCI-GPIB" }, 
	{ 0x1095, 0x0640, "PCI0640" }, 
	{ 0x1095, 0x0643, "PCI0643" }, 
	{ 0x1095, 0x0646, "PCI0646" }, 
	{ 0x1095, 0x0647, "PCI0647" }, 
	{ 0x1095, 0x0648, "PCI0648" }, 
	{ 0x1095, 0x0649, "PCI0649" }, 
	{ 0x1095, 0x0650, "PBC0650A" }, 
	{ 0x1095, 0x0670, "USB0670" }, 
	{ 0x1095, 0x0673, "USB0673" }, 
	{ 0x1095, 0x0680, "PCI0680" }, 
	{ 0x1098, 0x0001, "QD-8500" }, 
	{ 0x1098, 0x0002, "QD-8580" }, 
	{ 0x109e, 0x0350, "Bt848 TV with DMA push" }, 
	{ 0x109e, 0x0351, "Bt849A Video capture" }, 
	{ 0x109e, 0x036c, "Bt879(??) Video Capture" }, 
	{ 0x109e, 0x036e, "Bt878" }, 
	{ 0x109e, 0x036f, "Bt879" }, 
	{ 0x109e, 0x0370, "Bt880 Video Capture" }, 
	{ 0x109e, 0x0878, "Bt878" }, 
	{ 0x109e, 0x0879, "Bt879 Video Capture (Audio Section)" }, 
	{ 0x109e, 0x0880, "Bt880 Video Capture (Audio Section)" }, 
	{ 0x109e, 0x2115, "BtV 2115 Mediastream controller" }, 
	{ 0x109e, 0x2125, "BtV 2125 Mediastream controller" }, 
	{ 0x109e, 0x2164, "BtV 2164" }, 
	{ 0x109e, 0x2165, "BtV 2165" }, 
	{ 0x109e, 0x8230, "Bt8230 ATM Segment/Reassembly Ctrlr (SRC)" }, 
	{ 0x109e, 0x8472, "Bt8472" }, 
	{ 0x109e, 0x8474, "Bt8474" }, 
	{ 0x10a8, 0x0000, "STB Horizon 64" }, 
	{ 0x10a9, 0x0001, "Crosstalk to PCI Bridge" }, 
	{ 0x10a9, 0x0002, "Linc I/O controller" }, 
	{ 0x10a9, 0x0003, "IOC3 I/O controller" }, 
	{ 0x10a9, 0x0004, "O2 MACE" }, 
	{ 0x10a9, 0x0005, "RAD Audio" }, 
	{ 0x10a9, 0x0006, "HPCEX" }, 
	{ 0x10a9, 0x0007, "RPCEX" }, 
	{ 0x10a9, 0x0008, "DiVO VIP" }, 
	{ 0x10a9, 0x0009, "Alteon Gigabit Ethernet" }, 
	{ 0x10a9, 0x0010, "AMP Video I/O" }, 
	{ 0x10a9, 0x0011, "GRIP" }, 
	{ 0x10a9, 0x0012, "SGH PSHAC GSN" }, 
	{ 0x10a9, 0x1001, "Magic Carpet" }, 
	{ 0x10a9, 0x1002, "Lithium" }, 
	{ 0x10a9, 0x1003, "Dual JPEG 1" }, 
	{ 0x10a9, 0x1004, "Dual JPEG 2" }, 
	{ 0x10a9, 0x1005, "Dual JPEG 3" }, 
	{ 0x10a9, 0x1006, "Dual JPEG 4" }, 
	{ 0x10a9, 0x1007, "Dual JPEG 5" }, 
	{ 0x10a9, 0x1008, "Cesium" }, 
	{ 0x10a9, 0x2001, "Fibre Channel" }, 
	{ 0x10a9, 0x2002, "ASDE" }, 
	{ 0x10a9, 0x8001, "O2 1394" }, 
	{ 0x10a9, 0x8002, "G-net NT" }, 
	{ 0x10aa, 0x0000, "ACCM 2188" }, 
	{ 0x10ad, 0x0001, "W83769F" }, 
	{ 0x10ad, 0x0003, "SL82C103" }, 
	{ 0x10ad, 0x0005, "SL82C105" }, 
	{ 0x10ad, 0x0103, "SL82c103" }, 
	{ 0x10ad, 0x0105, "SL82c105" }, 
	{ 0x10ad, 0x0565, "W83C553" }, 
	{ 0x10b3, 0x3106, "DB87144" }, 
	{ 0x10b3, 0xb106, "DB87144" }, 
	{ 0x10b4, 0x1b1d, "Velocity 128 3D" }, 
	{ 0x10b5, 0x0001, "i960 PCI bus interface" }, 
	{ 0x10b5, 0x1076, "VScom 800 8 port serial adaptor" }, 
	{ 0x10b5, 0x1077, "VScom 400 4 port serial adaptor" }, 
	{ 0x10b5, 0x1078, "VScom 210 2 port serial and 1 port parallel adaptor" }, 
	{ 0x10b5, 0x1103, "VScom 200 2 port serial adaptor" }, 
	{ 0x10b5, 0x1146, "VScom 010 1 port parallel adaptor" }, 
	{ 0x10b5, 0x1147, "VScom 020 2 port parallel adaptor" }, 
	{ 0x10b5, 0x9030, "PCI <-> IOBus Bridge Hot Swap" }, 
	{ 0x10b5, 0x9036, "9036" }, 
	{ 0x10b5, 0x9050, "PCI <-> IOBus Bridge" }, 
	{ 0x10b5, 0x9060, "9060" }, 
	{ 0x10b5, 0x906d, "9060SD" }, 
	{ 0x10b5, 0x906e, "9060ES" }, 
	{ 0x10b5, 0x9080, "9080" }, 
	{ 0x10b5, 0xa001, "GTEK Jetport II 2 port serial adaptor" }, 
	{ 0x10b5, 0xc001, "GTEK Cyclone 16/32 port serial adaptor" }, 
	{ 0x10b6, 0x0001, "Smart 16/4 PCI Ringnode" }, 
	{ 0x10b6, 0x0002, "Smart 16/4 PCI Ringnode Mk2" }, 
	{ 0x10b6, 0x0003, "Smart 16/4 PCI Ringnode Mk3" }, 
	{ 0x10b6, 0x0004, "Smart 16/4 PCI Ringnode Mk1" }, 
	{ 0x10b6, 0x0006, "16/4 Cardbus Adapter" }, 
	{ 0x10b6, 0x0007, "Presto PCI Adapter" }, 
	{ 0x10b6, 0x0009, "Smart 100/16/4 PCI-HS Ringnode" }, 
	{ 0x10b6, 0x000a, "Smart 100/16/4 PCI Ringnode" }, 
	{ 0x10b6, 0x000b, "16/4 CardBus Adapter Mk2" }, 
	{ 0x10b6, 0x000c, "RapidFire 3140V2 16/4 TR Adapter" }, 
	{ 0x10b6, 0x1000, "Collage 25/155 ATM Client Adapter" }, 
	{ 0x10b6, 0x1001, "Collage 155 ATM Server Adapter" }, 
	{ 0x10b7, 0x0001, "3c985 1000BaseSX (SX/TX)" }, 
	{ 0x10b7, 0x1007, "Mini PCI 56k Winmodem" }, 
	{ 0x10b7, 0x3390, "3c339 TokenLink Velocity" }, 
	{ 0x10b7, 0x3590, "3c359 TokenLink Velocity XL" }, 
	{ 0x10b7, 0x4500, "3c450 Cyclone/unknown" }, 
	{ 0x10b7, 0x5055, "3c555 Laptop Hurricane" }, 
	{ 0x10b7, 0x5057, "3c575 [Megahertz] 10/100 LAN CardBus" }, 
	{ 0x10b7, 0x5157, "3c575 [Megahertz] 10/100 LAN CardBus" }, 
	{ 0x10b7, 0x5257, "3CCFE575CT Cyclone CardBus" }, 
	{ 0x10b7, 0x5900, "3c590 10BaseT [Vortex]" }, 
	{ 0x10b7, 0x5920, "3c592 EISA 10mbps Demon/Vortex" }, 
	{ 0x10b7, 0x5950, "3c595 100BaseTX [Vortex]" }, 
	{ 0x10b7, 0x5951, "3c595 100BaseT4 [Vortex]" }, 
	{ 0x10b7, 0x5952, "3c595 100Base-MII [Vortex]" }, 
	{ 0x10b7, 0x5970, "3c597 EISA Fast Demon/Vortex" }, 
	{ 0x10b7, 0x5b57, "3c595 [Megahertz] 10/100 LAN CardBus" }, 
	{ 0x10b7, 0x6055, "3c556 Hurricane CardBus" }, 
	{ 0x10b7, 0x6056, "3c556B Hurricane CardBus" }, 
	{ 0x10b7, 0x6560, "3CCFE656 Cyclone CardBus" }, 
	{ 0x10b7, 0x6561, "3CCFEM656 10/100 LAN 56K Modem CardBus" }, 
	{ 0x10b7, 0x6562, "3CCFEM656 [id 6562] Cyclone CardBus" }, 
	{ 0x10b7, 0x6563, "3CCFEM656B 10/100 LAN 56K Modem CardBus" }, 
	{ 0x10b7, 0x6564, "3CCFEM656 [id 6564] Cyclone CardBus" }, 
	{ 0x10b7, 0x7646, "3cSOHO100-TX Hurricane" }, 
	{ 0x10b7, 0x7940, "3c803 FDDILink UTP Controller" }, 
	{ 0x10b7, 0x7980, "3c804 FDDILink SAS Controller" }, 
	{ 0x10b7, 0x7990, "3c805 FDDILink DAS Controller" }, 
	{ 0x10b7, 0x8811, "Token ring" }, 
	{ 0x10b7, 0x9000, "3c900 10BaseT [Boomerang]" }, 
	{ 0x10b7, 0x9001, "3c900 Combo [Boomerang]" }, 
	{ 0x10b7, 0x9004, "3c900B-TPO [Etherlink XL TPO]" }, 
	{ 0x10b7, 0x9005, "3c900B-Combo [Etherlink XL Combo]" }, 
	{ 0x10b7, 0x9006, "3c900B-TPC [Etherlink XL TPC]" }, 
	{ 0x10b7, 0x900a, "3c900B-FL [Etherlink XL FL]" }, 
	{ 0x10b7, 0x9050, "3c905 100BaseTX [Boomerang]" }, 
	{ 0x10b7, 0x9051, "3c905 100BaseT4 [Boomerang]" }, 
	{ 0x10b7, 0x9055, "3c905B 100BaseTX [Cyclone]" }, 
	{ 0x10b7, 0x9056, "3c905B-T4 [Fast EtherLink XL 10/100]" }, 
	{ 0x10b7, 0x9058, "3c905B-Combo [Deluxe Etherlink XL 10/100]" }, 
	{ 0x10b7, 0x905a, "3c905B-FX [Fast Etherlink XL FX 10/100]" }, 
	{ 0x10b7, 0x9200, "3c905C-TX/TX-M [Tornado]" }, 
	{ 0x10b7, 0x9800, "3c980-TX [Fast Etherlink XL Server Adapter]" }, 
	{ 0x10b7, 0x9805, "3c980-TX 10/100baseTX NIC [Python-T]" }, 
	{ 0x10b7, 0x9902, "3CR990-TX-95 56-bit Typhoon Client" }, 
	{ 0x10b7, 0x9903, "3CR990-TX-97 168-bit Typhoon Client" }, 
	{ 0x10b7, 0x9908, "3CR990SVR95 56-bit Typhoon Server" }, 
	{ 0x10b7, 0x9909, "3CR990SVR97 Typhoon Server" }, 
	{ 0x10b8, 0x0005, "83C170QF" }, 
	{ 0x10b8, 0x0006, "LANEPIC" }, 
	{ 0x10b8, 0x1000, "FDC 37c665" }, 
	{ 0x10b8, 0x1001, "FDC 37C922" }, 
	{ 0x10b8, 0xa011, "83C170QF" }, 
	{ 0x10b8, 0xb106, "SMC34C90" }, 
	{ 0x10b9, 0x0111, "C-Media CMI8738/C3DX Audio Device (OEM)" }, 
	{ 0x10b9, 0x1435, "M1435" }, 
	{ 0x10b9, 0x1445, "M1445" }, 
	{ 0x10b9, 0x1449, "M1449" }, 
	{ 0x10b9, 0x1451, "M1451" }, 
	{ 0x10b9, 0x1461, "M1461" }, 
	{ 0x10b9, 0x1489, "M1489" }, 
	{ 0x10b9, 0x1511, "M1511 [Aladdin]" }, 
	{ 0x10b9, 0x1512, "M1512 [Aladdin]" }, 
	{ 0x10b9, 0x1513, "M1513 [Aladdin]" }, 
	{ 0x10b9, 0x1521, "M1521 [Aladdin III]" }, 
	{ 0x10b9, 0x1523, "M1523" }, 
	{ 0x10b9, 0x1531, "M1531 [Aladdin IV]" }, 
	{ 0x10b9, 0x1533, "M1533 PCI to ISA Bridge [Aladdin IV]" }, 
	{ 0x10b9, 0x1541, "M1541" }, 
	{ 0x10b9, 0x1543, "M1543" }, 
	{ 0x10b9, 0x1621, "M1621" }, 
	{ 0x10b9, 0x1631, "ALI M1631 PCI North Bridge Aladdin Pro III" }, 
	{ 0x10b9, 0x1632, "M1632M Northbridge+Trident" }, 
	{ 0x10b9, 0x1641, "ALI M1641 PCI North Bridge Aladdin Pro IV" }, 
	{ 0x10b9, 0x1644, "M1644/M1644T Northbridge+Trident" }, 
	{ 0x10b9, 0x1646, "M1646 Northbridge+Trident" }, 
	{ 0x10b9, 0x1647, "M1647 Northbridge [MAGiK 1 / MobileMAGiK 1]" }, 
	{ 0x10b9, 0x1651, "M1651/M1651T Northbridge [Aladdin-Pro 5/5M,Aladdin-Pro 5T/5TM]" }, 
	{ 0x10b9, 0x1671, "M1671 Northbridge [Aladdin-P4]" }, 
	{ 0x10b9, 0x3141, "M3141" }, 
	{ 0x10b9, 0x3143, "M3143" }, 
	{ 0x10b9, 0x3145, "M3145" }, 
	{ 0x10b9, 0x3147, "M3147" }, 
	{ 0x10b9, 0x3149, "M3149" }, 
	{ 0x10b9, 0x3151, "M3151" }, 
	{ 0x10b9, 0x3307, "M3307" }, 
	{ 0x10b9, 0x3309, "M3309" }, 
	{ 0x10b9, 0x5212, "M4803" }, 
	{ 0x10b9, 0x5215, "MS4803" }, 
	{ 0x10b9, 0x5217, "M5217H" }, 
	{ 0x10b9, 0x5219, "M5219" }, 
	{ 0x10b9, 0x5225, "M5225" }, 
	{ 0x10b9, 0x5229, "M5229 IDE" }, 
	{ 0x10b9, 0x5235, "M5225" }, 
	{ 0x10b9, 0x5237, "USB 1.1 Controller" }, 
	{ 0x10b9, 0x5239, "USB 2.0 Controller" }, 
	{ 0x10b9, 0x5243, "M1541 PCI to AGP Controller" }, 
	{ 0x10b9, 0x5247, "PCI to AGP Controller" }, 
	{ 0x10b9, 0x5251, "M5251 P1394 OHCI 1.0 Controller" }, 
	{ 0x10b9, 0x5253, "M5253 P1394 OHCI 1.1 Controller" }, 
	{ 0x10b9, 0x5261, "M5261 Ethernet Controller" }, 
	{ 0x10b9, 0x5451, "M5451 PCI AC-Link Controller Audio Device" }, 
	{ 0x10b9, 0x5453, "M5453 PCI AC-Link Controller Modem Device" }, 
	{ 0x10b9, 0x5455, "M5455 PCI AC-Link Controller Audio Device" }, 
	{ 0x10b9, 0x5457, "M5457 AC-Link Modem Interface Controller" }, 
	{ 0x10b9, 0x5471, "M5471 Memory Stick Controller" }, 
	{ 0x10b9, 0x5473, "M5473 SD-MMC Controller" }, 
	{ 0x10b9, 0x7101, "M7101 PMU" }, 
	{ 0x10ba, 0x0301, "AccelGraphics AccelECLIPSE" }, 
	{ 0x10bd, 0x0e34, "NE-34" }, 
	{ 0x10c3, 0x1100, "Smartether100 SC1100 LAN Adapter (i82557B)" }, 
	{ 0x10c8, 0x0001, "NM2070 [MagicGraph NM2070]" }, 
	{ 0x10c8, 0x0002, "NM2090 [MagicGraph 128V]" }, 
	{ 0x10c8, 0x0003, "NM2093 [MagicGraph 128ZV]" }, 
	{ 0x10c8, 0x0004, "NM2160 [MagicGraph 128XD]" }, 
	{ 0x10c8, 0x0005, "[MagicMedia 256AV]" }, 
	{ 0x10c8, 0x0006, "NM2360 [MagicMedia 256ZX]" }, 
	{ 0x10c8, 0x0016, "NM2380 [MagicMedia 256XL+]" }, 
	{ 0x10c8, 0x0025, "[MagicMedia 256AV+]" }, 
	{ 0x10c8, 0x0083, "[MagicGraph 128ZV Plus]" }, 
	{ 0x10c8, 0x8005, "[MagicMedia 256AV Audio]" }, 
	{ 0x10c8, 0x8006, "NM2360 [MagicMedia 256ZX Audio]" }, 
	{ 0x10c8, 0x8016, "NM2360 [MagicMedia 256ZX Audio]" }, 
	{ 0x10cd, 0x1100, "ASC1100" }, 
	{ 0x10cd, 0x1200, "ASC1200 [(abp940) Fast SCSI-II]" }, 
	{ 0x10cd, 0x1300, "ABP940-U / ABP960-U" }, 
	{ 0x10cd, 0x2300, "ABP940-UW" }, 
	{ 0x10cd, 0x2500, "ABP940-U2W" }, 
	{ 0x10cf, 0x2001, "mb86605" }, 
	{ 0x10d9, 0x0512, "MX98713" }, 
	{ 0x10d9, 0x0531, "MX987x5" }, 
	{ 0x10d9, 0x8625, "MX86250" }, 
	{ 0x10d9, 0x8888, "MX86200" }, 
	{ 0x10da, 0x0508, "TC4048 Token Ring 4/16" }, 
	{ 0x10da, 0x3390, "Tl3c3x9" }, 
	{ 0x10dc, 0x0001, "STAR/RD24 SCI-PCI (PMC)" }, 
	{ 0x10dc, 0x0002, "TAR/RD24 SCI-PCI (PMC)" }, 
	{ 0x10dc, 0x0021, "HIPPI destination" }, 
	{ 0x10dc, 0x0022, "HIPPI source" }, 
	{ 0x10dc, 0x10dc, "ATT2C15-3 FPGA" }, 
	{ 0x10de, 0x0008, "EDGE 3D [NV1]" }, 
	{ 0x10de, 0x0009, "EDGE 3D [NV1]" }, 
	{ 0x10de, 0x0010, "Mutara V08 [NV2]" }, 
	{ 0x10de, 0x0020, "Riva TnT [NV04]" }, 
	{ 0x10de, 0x0028, "Riva TnT2 [NV5]" }, 
	{ 0x10de, 0x0029, "Riva TnT2 Ultra [NV5]" }, 
	{ 0x10de, 0x002a, "Riva TnT2 [NV5]" }, 
	{ 0x10de, 0x002b, "Riva TnT2 [NV5]" }, 
	{ 0x10de, 0x002c, "Vanta [NV6]" }, 
	{ 0x10de, 0x002d, "Vanta [NV6]" }, 
	{ 0x10de, 0x002e, "Vanta [NV6]" }, 
	{ 0x10de, 0x002f, "Vanta [NV6]" }, 
	{ 0x10de, 0x00a0, "Riva TNT2" }, 
	{ 0x10de, 0x0100, "NV10 (GeForce 256)" }, 
	{ 0x10de, 0x0101, "GeForce 256 DDR" }, 
	{ 0x10de, 0x0103, "Quadro (GeForce 256 GL)" }, 
	{ 0x10de, 0x0110, "NV11 (GeForce2 MX)" }, 
	{ 0x10de, 0x0111, "NV11 (GeForce2 MX DDR)" }, 
	{ 0x10de, 0x0112, "GeForce2 Go" }, 
	{ 0x10de, 0x0113, "NV11 (GeForce2 MXR)" }, 
	{ 0x10de, 0x0150, "NV15 (GeForce2 Pro)" }, 
	{ 0x10de, 0x0151, "NV15 DDR (GeForce2 GTS)" }, 
	{ 0x10de, 0x0152, "NV15 Bladerunner (GeForce2 Ultra)" }, 
	{ 0x10de, 0x0153, "NV15 GL (Quadro2 Pro)" }, 
	{ 0x10de, 0x0170, "NV1x" }, 
	{ 0x10de, 0x0171, "NV1x" }, 
	{ 0x10de, 0x0172, "NV1x" }, 
	{ 0x10de, 0x0173, "NV1x" }, 
	{ 0x10de, 0x0174, "NV1x" }, 
	{ 0x10de, 0x0175, "NV1x" }, 
	{ 0x10de, 0x0176, "GeForce4 420 Go 32M" }, 
	{ 0x10de, 0x0178, "NV1x" }, 
	{ 0x10de, 0x0179, "GeForce4 440 Go 64M" }, 
	{ 0x10de, 0x017a, "NV1x" }, 
	{ 0x10de, 0x017b, "NV1x" }, 
	{ 0x10de, 0x017c, "NV1x" }, 
	{ 0x10de, 0x01a0, "GeForce2 Integrated GPU" }, 
	{ 0x10de, 0x01bc, "nForce IDE" }, 
	{ 0x10de, 0x0200, "NV20 (GeForce3)" }, 
	{ 0x10de, 0x0201, "GeForce3 Ti200" }, 
	{ 0x10de, 0x0202, "GeForce3 Ti500" }, 
	{ 0x10de, 0x0203, "Quadro DCC" }, 
	{ 0x10de, 0x0250, "NV25 (GeForce 4)" }, 
	{ 0x10de, 0x0251, "GeForce4 Ti 4400" }, 
	{ 0x10de, 0x0253, "GeForce4 Ti 4200" }, 
	{ 0x10de, 0x0258, "NV25 (GeForce 4)" }, 
	{ 0x10de, 0x025b, "NV25 (GeForce 4)" }, 
	{ 0x10df, 0x10df, "Light Pulse Fibre Channel Adapter" }, 
	{ 0x10df, 0x1ae5, "LP6000 Fibre Channel Host Adapter" }, 
	{ 0x10df, 0xf700, "LP7000 Fibre Channel Host Adapter" }, 
	{ 0x10e0, 0x5026, "IMS5026/27/28" }, 
	{ 0x10e0, 0x5027, "IMS5027" }, 
	{ 0x10e0, 0x5028, "IMS5028" }, 
	{ 0x10e0, 0x8849, "IMS8849" }, 
	{ 0x10e0, 0x8853, "IMS8853" }, 
	{ 0x10e0, 0x9128, "IMS9129 [Twin turbo 128]" }, 
	{ 0x10e1, 0x0391, "TRM-S1040" }, 
	{ 0x10e1, 0x690c, "DC-690c" }, 
	{ 0x10e1, 0xdc29, "DC-290" }, 
	{ 0x10e3, 0x0000, "CA91C042 [Universe]" }, 
	{ 0x10e3, 0x0860, "CA91C860 [QSpan]" }, 
	{ 0x10e8, 0x2011, "Q-Motion Video Capture/Edit board" }, 
	{ 0x10e8, 0x4750, "S5930 [Matchmaker]" }, 
	{ 0x10e8, 0x5920, "S5920" }, 
	{ 0x10e8, 0x8043, "LANai4.x [Myrinet LANai interface chip]" }, 
	{ 0x10e8, 0x8062, "S5933_PARASTATION" }, 
	{ 0x10e8, 0x807d, "S5933 [Matchmaker]" }, 
	{ 0x10e8, 0x8088, "Kongsberg Spacetec Format Synchronizer" }, 
	{ 0x10e8, 0x8089, "Kongsberg Spacetec Serial Output Board" }, 
	{ 0x10e8, 0x809c, "S5933_HEPC3" }, 
	{ 0x10e8, 0x80d7, "PCI-9112" }, 
	{ 0x10e8, 0x80d9, "PCI-9118" }, 
	{ 0x10e8, 0x80da, "PCI-9812" }, 
	{ 0x10e8, 0x811a, "PCI-IEEE1355-DS-DE Interface" }, 
	{ 0x10e8, 0x8170, "S5933 [Matchmaker] (Chipset Development Tool)" }, 
	{ 0x10e8, 0x82db, "AJA HDNTV HD SDI Framestore" }, 
	{ 0x10ea, 0x1680, "IGA-1680" }, 
	{ 0x10ea, 0x1682, "IGA-1682" }, 
	{ 0x10ea, 0x1683, "IGA-1683" }, 
	{ 0x10ea, 0x2000, "CyberPro 2000" }, 
	{ 0x10ea, 0x2010, "CyberPro 2000A" }, 
	{ 0x10ea, 0x5000, "CyberPro 5000" }, 
	{ 0x10ea, 0x5050, "CyberPro 5050" }, 
	{ 0x10eb, 0x0101, "3GA" }, 
	{ 0x10eb, 0x8111, "Twist3 Frame Grabber" }, 
	{ 0x10ec, 0x8029, "RTL-8029(AS)" }, 
	{ 0x10ec, 0x8129, "RTL-8129" }, 
	{ 0x10ec, 0x8138, "RT8139 (B/C) Cardbus Fast Ethernet Adapter" }, 
	{ 0x10ec, 0x8139, "RTL-8139/8139C" }, 
	{ 0x10ed, 0x7310, "V7310" }, 
	{ 0x10ee, 0x3fc0, "RME Digi96" }, 
	{ 0x10ee, 0x3fc1, "RME Digi96/8" }, 
	{ 0x10ee, 0x3fc2, "RME Digi96/8 Pro" }, 
	{ 0x10ee, 0x3fc3, "RME Digi96/8 Pad" }, 
	{ 0x10ef, 0x8154, "M815x Token Ring Adapter" }, 
	{ 0x10f5, 0xa001, "NDR4000 [NR4600 Bridge]" }, 
	{ 0x10fa, 0x000c, "TARGA 1000" }, 
	{ 0x10fc, 0x0003, "Cardbus IDE Controller" }, 
	{ 0x1101, 0x1060, "INI-A100U2W" }, 
	{ 0x1101, 0x9100, "INI-9100/9100W" }, 
	{ 0x1101, 0x9400, "INI-940" }, 
	{ 0x1101, 0x9401, "INI-950" }, 
	{ 0x1101, 0x9500, "360P" }, 
	{ 0x1102, 0x0002, "SB Live! EMU10k1" }, 
	{ 0x1102, 0x0004, "SB Audigy" }, 
	{ 0x1102, 0x4001, "SB Audigy FireWire Port" }, 
	{ 0x1102, 0x7002, "SB Live! MIDI/Game Port" }, 
	{ 0x1102, 0x7003, "SB Audigy MIDI/Game port" }, 
	{ 0x1102, 0x8938, "ES1371" }, 
	{ 0x1103, 0x0003, "HPT343" }, 
	{ 0x1103, 0x0004, "HPT366 / HPT370" }, 
	{ 0x1103, 0x0005, "HPT370" }, 
	{ 0x1105, 0x8300, "REALmagic Hollywood Plus DVD Decoder" }, 
	{ 0x1105, 0x8400, "EM840x REALmagic DVD/MPEG-2 Audio/Video Decoder" }, 
	{ 0x1106, 0x0305, "VT8363/8365 [KT133/KM133]" }, 
	{ 0x1106, 0x0391, "VT8371 [KX133]" }, 
	{ 0x1106, 0x0501, "VT8501 [Apollo MVP4]" }, 
	{ 0x1106, 0x0505, "VT82C505" }, 
	{ 0x1106, 0x0561, "VT82C561" }, 
	{ 0x1106, 0x0571, "Bus Master IDE" }, 
	{ 0x1106, 0x0576, "VT82C576 3V [Apollo Master]" }, 
	{ 0x1106, 0x0585, "VT82C585VP [Apollo VP1/VPX]" }, 
	{ 0x1106, 0x0586, "VT82C586/A/B PCI-to-ISA [Apollo VP]" }, 
	{ 0x1106, 0x0595, "VT82C595 [Apollo VP2]" }, 
	{ 0x1106, 0x0596, "VT82C596 ISA [Mobile South]" }, 
	{ 0x1106, 0x0597, "VT82C597 [Apollo VP3]" }, 
	{ 0x1106, 0x0598, "VT82C598 [Apollo MVP3]" }, 
	{ 0x1106, 0x0601, "VT8601 [Apollo ProMedia]" }, 
	{ 0x1106, 0x0605, "VT8605 [ProSavage PM133]" }, 
	{ 0x1106, 0x0680, "VT82C680 [Apollo P6]" }, 
	{ 0x1106, 0x0686, "VT82C686 [Apollo Super South]" }, 
	{ 0x1106, 0x0691, "VT82C693A/694x [Apollo PRO133x]" }, 
	{ 0x1106, 0x0693, "VT82C693 [Apollo Pro Plus]" }, 
	{ 0x1106, 0x0698, "VT82C693A [Apollo Pro133 AGP]" }, 
	{ 0x1106, 0x0926, "VT82C926 [Amazon]" }, 
	{ 0x1106, 0x1000, "VT82C570MV" }, 
	{ 0x1106, 0x1106, "VT82C570MV" }, 
	{ 0x1106, 0x1571, "VT82C416MV" }, 
	{ 0x1106, 0x1595, "VT82C595/97 [Apollo VP2/97]" }, 
	{ 0x1106, 0x3038, "UHCI USB" }, 
	{ 0x1106, 0x3040, "VT82C586B ACPI" }, 
	{ 0x1106, 0x3043, "VT3043 [Rhine]" }, 
	{ 0x1106, 0x3044, "IEEE 1394 Host Controller" }, 
	{ 0x1106, 0x3050, "VT82C596 Power Management" }, 
	{ 0x1106, 0x3051, "VT82C596 Power Management" }, 
	{ 0x1106, 0x3057, "VT82C686 [Apollo Super ACPI]" }, 
	{ 0x1106, 0x3058, "VT82C686 AC97 Audio Controller" }, 
	{ 0x1106, 0x3059, "VT8233 AC97 Audio Controller" }, 
	{ 0x1106, 0x3065, "VT6102 [Rhine-II]" }, 
	{ 0x1106, 0x3068, "AC97 Modem Controller" }, 
	{ 0x1106, 0x3074, "VT8233 PCI to ISA Bridge" }, 
	{ 0x1106, 0x3091, "VT8633 [Apollo Pro266]" }, 
	{ 0x1106, 0x3099, "VT8367 [KT266]" }, 
	{ 0x1106, 0x3104, "USB 2.0" }, 
	{ 0x1106, 0x3109, "VT8233C PCI to ISA Bridge" }, 
	{ 0x1106, 0x3128, "VT8753 [P4X266 AGP]" }, 
	{ 0x1106, 0x5030, "VT82C596 ACPI [Apollo PRO]" }, 
	{ 0x1106, 0x6100, "VT85C100A [Rhine II]" }, 
	{ 0x1106, 0x8231, "VT8231 [PCI-to-ISA Bridge]" }, 
	{ 0x1106, 0x8235, "VT8235 Power Management" }, 
	{ 0x1106, 0x8305, "VT8363/8365 [KT133/KM133 AGP]" }, 
	{ 0x1106, 0x8391, "VT8371 [KX133 AGP]" }, 
	{ 0x1106, 0x8501, "VT8501 [Apollo MVP4 AGP]" }, 
	{ 0x1106, 0x8596, "VT82C596 [Apollo PRO AGP]" }, 
	{ 0x1106, 0x8597, "VT82C597 [Apollo VP3 AGP]" }, 
	{ 0x1106, 0x8598, "VT82C598/694x [Apollo MVP3/Pro133x AGP]" }, 
	{ 0x1106, 0x8601, "VT8601 [Apollo ProMedia AGP]" }, 
	{ 0x1106, 0x8605, "VT8605 [PM133 AGP]" }, 
	{ 0x1106, 0x8691, "VT82C691 [Apollo Pro]" }, 
	{ 0x1106, 0xb091, "VT8633 [Apollo Pro266 AGP]" }, 
	{ 0x1106, 0xb099, "VT8367 [KT266 AGP]" }, 
	{ 0x1107, 0x0576, "VIA VT82C570MV [Apollo] (Wrong vendor ID!)" }, 
	{ 0x1108, 0x0100, "p1690plus_AA" }, 
	{ 0x1108, 0x0101, "p1690plus_AB" }, 
	{ 0x1108, 0x0105, "P1690Plus" }, 
	{ 0x1108, 0x0108, "P1690Plus" }, 
	{ 0x1108, 0x0138, "P1690Plus" }, 
	{ 0x1108, 0x0139, "P1690Plus" }, 
	{ 0x1108, 0x013c, "P1690Plus" }, 
	{ 0x1108, 0x013d, "P1690Plus" }, 
	{ 0x1109, 0x1400, "EM110TX [EX110TX]" }, 
	{ 0x110a, 0x0002, "Pirahna 2-port" }, 
	{ 0x110a, 0x0005, "Tulip controller, power management, switch extender" }, 
	{ 0x110a, 0x2102, "DSCC4 WAN adapter" }, 
	{ 0x110a, 0x4942, "FPGA I-Bus Tracer for MBD" }, 
	{ 0x110a, 0x6120, "SZB6120" }, 
	{ 0x110b, 0x0001, "Mpact Media Processor" }, 
	{ 0x110b, 0x0004, "Mpact 2" }, 
	{ 0x1110, 0x6037, "Firepower Powerized SMP I/O ASIC" }, 
	{ 0x1110, 0x6073, "Firepower Powerized SMP I/O ASIC" }, 
	{ 0x1112, 0x2200, "FDDI Adapter" }, 
	{ 0x1112, 0x2300, "Fast Ethernet Adapter" }, 
	{ 0x1112, 0x2340, "4 Port Fast Ethernet Adapter" }, 
	{ 0x1112, 0x2400, "ATM Adapter" }, 
	{ 0x1113, 0x1211, "SMC2-1211TX" }, 
	{ 0x1113, 0x1216, "EN-1216 Ethernet Adapter" }, 
	{ 0x1113, 0x1217, "EN-1217 Ethernet Adapter" }, 
	{ 0x1113, 0x5105, "10Mbps Network card" }, 
	{ 0x1113, 0x9211, "EN-1207D Fast Ethernet Adapter" }, 
	{ 0x1113, 0x9511, "Fast Ethernet Adapter" }, 
	{ 0x1116, 0x0022, "DT3001" }, 
	{ 0x1116, 0x0023, "DT3002" }, 
	{ 0x1116, 0x0024, "DT3003" }, 
	{ 0x1116, 0x0025, "DT3004" }, 
	{ 0x1116, 0x0026, "DT3005" }, 
	{ 0x1116, 0x0027, "DT3001-PGL" }, 
	{ 0x1116, 0x0028, "DT3003-PGL" }, 
	{ 0x1117, 0x9500, "Max-1C SVGA card" }, 
	{ 0x1117, 0x9501, "Max-1C image processing" }, 
	{ 0x1119, 0x0000, "GDT 6000/6020/6050" }, 
	{ 0x1119, 0x0001, "GDT 6000B/6010" }, 
	{ 0x1119, 0x0002, "GDT 6110/6510" }, 
	{ 0x1119, 0x0003, "GDT 6120/6520" }, 
	{ 0x1119, 0x0004, "GDT 6530" }, 
	{ 0x1119, 0x0005, "GDT 6550" }, 
	{ 0x1119, 0x0006, "GDT 6x17" }, 
	{ 0x1119, 0x0007, "GDT 6x27" }, 
	{ 0x1119, 0x0008, "GDT 6537" }, 
	{ 0x1119, 0x0009, "GDT 6557" }, 
	{ 0x1119, 0x000a, "GDT 6115/6515" }, 
	{ 0x1119, 0x000b, "GDT 6125/6525" }, 
	{ 0x1119, 0x000c, "GDT 6535" }, 
	{ 0x1119, 0x000d, "GDT 6555" }, 
	{ 0x1119, 0x0100, "GDT 6117RP/6517RP" }, 
	{ 0x1119, 0x0101, "GDT 6127RP/6527RP" }, 
	{ 0x1119, 0x0102, "GDT 6537RP" }, 
	{ 0x1119, 0x0103, "GDT 6557RP" }, 
	{ 0x1119, 0x0104, "GDT 6111RP/6511RP" }, 
	{ 0x1119, 0x0105, "GDT 6121RP/6521RP" }, 
	{ 0x1119, 0x0110, "GDT 6117RD/6517RD" }, 
	{ 0x1119, 0x0111, "GDT 6127RD/6527RD" }, 
	{ 0x1119, 0x0112, "GDT 6537RD" }, 
	{ 0x1119, 0x0113, "GDT 6557RD" }, 
	{ 0x1119, 0x0114, "GDT 6111RD/6511RD" }, 
	{ 0x1119, 0x0115, "GDT 6121RD/6521RD" }, 
	{ 0x1119, 0x0118, "GDT 6118RD/6518RD/6618RD" }, 
	{ 0x1119, 0x0119, "GDT 6128RD/6528RD/6628RD" }, 
	{ 0x1119, 0x011a, "GDT 6538RD/6638RD" }, 
	{ 0x1119, 0x011b, "GDT 6558RD/6658RD" }, 
	{ 0x1119, 0x0120, "GDT 6117RP2/6517RP2" }, 
	{ 0x1119, 0x0121, "GDT 6127RP2/6527RP2" }, 
	{ 0x1119, 0x0122, "GDT 6537RP2" }, 
	{ 0x1119, 0x0123, "GDT 6557RP2" }, 
	{ 0x1119, 0x0124, "GDT 6111RP2/6511RP2" }, 
	{ 0x1119, 0x0125, "GDT 6121RP2/6521RP2" }, 
	{ 0x1119, 0x0136, "GDT 6113RS/6513RS" }, 
	{ 0x1119, 0x0137, "GDT 6123RS/6523RS" }, 
	{ 0x1119, 0x0138, "GDT 6118RS/6518RS/6618RS" }, 
	{ 0x1119, 0x0139, "GDT 6128RS/6528RS/6628RS" }, 
	{ 0x1119, 0x013a, "GDT 6538RS/6638RS" }, 
	{ 0x1119, 0x013b, "GDT 6558RS/6658RS" }, 
	{ 0x1119, 0x013c, "GDT 6533RS/6633RS" }, 
	{ 0x1119, 0x013d, "GDT 6543RS/6643RS" }, 
	{ 0x1119, 0x013e, "GDT 6553RS/6653RS" }, 
	{ 0x1119, 0x013f, "GDT 6563RS/6663RS" }, 
	{ 0x1119, 0x0166, "GDT 7113RN/7513RN/7613RN" }, 
	{ 0x1119, 0x0167, "GDT 7123RN/7523RN/7623RN" }, 
	{ 0x1119, 0x0168, "GDT 7118RN/7518RN/7518RN" }, 
	{ 0x1119, 0x0169, "GDT 7128RN/7528RN/7628RN" }, 
	{ 0x1119, 0x016a, "GDT 7538RN/7638RN" }, 
	{ 0x1119, 0x016b, "GDT 7558RN/7658RN" }, 
	{ 0x1119, 0x016c, "GDT 7533RN/7633RN" }, 
	{ 0x1119, 0x016d, "GDT 7543RN/7643RN" }, 
	{ 0x1119, 0x016e, "GDT 7553RN/7653RN" }, 
	{ 0x1119, 0x016f, "GDT 7563RN/7663RN" }, 
	{ 0x1119, 0x01d6, "GDT 4x13RZ" }, 
	{ 0x1119, 0x01d7, "GDT 4x23RZ" }, 
	{ 0x1119, 0x01f6, "GDT 8x13RZ" }, 
	{ 0x1119, 0x01f7, "GDT 8x23RZ" }, 
	{ 0x1119, 0x01fc, "GDT 8x33RZ" }, 
	{ 0x1119, 0x01fd, "GDT 8x43RZ" }, 
	{ 0x1119, 0x01fe, "GDT 8x53RZ" }, 
	{ 0x1119, 0x01ff, "GDT 8x63RZ" }, 
	{ 0x1119, 0x0210, "GDT 6519RD/6619RD" }, 
	{ 0x1119, 0x0211, "GDT 6529RD/6629RD" }, 
	{ 0x1119, 0x0260, "GDT 7519RN/7619RN" }, 
	{ 0x1119, 0x0261, "GDT 7529RN/7629RN" }, 
	{ 0x1119, 0x0300, "GDT Raid Controller" }, 
	{ 0x111a, 0x0000, "155P-MF1 (FPGA)" }, 
	{ 0x111a, 0x0002, "155P-MF1 (ASIC)" }, 
	{ 0x111a, 0x0003, "ENI-25P ATM" }, 
	{ 0x111a, 0x0005, "SpeedStream (LANAI)" }, 
	{ 0x111a, 0x0007, "SpeedStream ADSL" }, 
	{ 0x111c, 0x0001, "Powerbis Bridge" }, 
	{ 0x111d, 0x0001, "IDT77211 ATM Adapter" }, 
	{ 0x111d, 0x0003, "IDT77252 ATM network controller" }, 
	{ 0x111f, 0x4a47, "Precision MX Video engine interface" }, 
	{ 0x111f, 0x5243, "Frame capture bus interface" }, 
	{ 0x1127, 0x0200, "ForeRunner PCA-200 ATM" }, 
	{ 0x1127, 0x0210, "PCA-200PC" }, 
	{ 0x1127, 0x0250, "ATM" }, 
	{ 0x1127, 0x0300, "PCA-200E" }, 
	{ 0x1127, 0x0310, "ATM" }, 
	{ 0x1127, 0x0400, "ForeRunnerHE ATM Adapter" }, 
	{ 0x112f, 0x0000, "MVC IC-PCI" }, 
	{ 0x112f, 0x0001, "MVC IM-PCI Video frame grabber/processor" }, 
	{ 0x1131, 0x7145, "SAA7145" }, 
	{ 0x1131, 0x7146, "SAA7146" }, 
	{ 0x1133, 0x7901, "EiconCard S90" }, 
	{ 0x1133, 0x7902, "EiconCard S90" }, 
	{ 0x1133, 0x7911, "EiconCard S91" }, 
	{ 0x1133, 0x7912, "EiconCard S91" }, 
	{ 0x1133, 0x7941, "EiconCard S94" }, 
	{ 0x1133, 0x7942, "EiconCard S94" }, 
	{ 0x1133, 0x7943, "EiconCard S94" }, 
	{ 0x1133, 0x7944, "EiconCard S94" }, 
	{ 0x1133, 0xb921, "EiconCard P92" }, 
	{ 0x1133, 0xb922, "EiconCard P92" }, 
	{ 0x1133, 0xb923, "EiconCard P92" }, 
	{ 0x1133, 0xe001, "DIVA 20PRO" }, 
	{ 0x1133, 0xe002, "DIVA 20" }, 
	{ 0x1133, 0xe003, "DIVA 20PRO_U" }, 
	{ 0x1133, 0xe004, "DIVA 20_U" }, 
	{ 0x1133, 0xe005, "DIVA LOW" }, 
	{ 0x1133, 0xe010, "DIVA Server BRI-2M" }, 
	{ 0x1133, 0xe012, "DIVA Server BRI-8M" }, 
	{ 0x1133, 0xe014, "DIVA Server PRI-30M" }, 
	{ 0x1134, 0x0001, "Raceway Bridge" }, 
	{ 0x1135, 0x0001, "Printer controller" }, 
	{ 0x1138, 0x8905, "8905 [STD 32 Bridge]" }, 
	{ 0x1139, 0x0001, "VGA Compatable 3D Graphics" }, 
	{ 0x113c, 0x0000, "PCI-9060 i960 Bridge" }, 
	{ 0x113c, 0x0001, "PCI-SDK [PCI i960 Evaluation Platform]" }, 
	{ 0x113c, 0x0911, "PCI-911 [i960Jx-based Intelligent I/O Controller]" }, 
	{ 0x113c, 0x0912, "PCI-912 [i960CF-based Intelligent I/O Controller]" }, 
	{ 0x113c, 0x0913, "PCI-913" }, 
	{ 0x113c, 0x0914, "PCI-914 [I/O Controller w/ secondary PCI bus]" }, 
	{ 0x113f, 0x0808, "SST-64P Adapter" }, 
	{ 0x113f, 0x1010, "SST-128P Adapter" }, 
	{ 0x113f, 0x80c0, "SST-16P DB Adapter" }, 
	{ 0x113f, 0x80c4, "SST-16P RJ Adapter" }, 
	{ 0x113f, 0x80c8, "SST-16P Adapter" }, 
	{ 0x113f, 0x8888, "SST-4P Adapter" }, 
	{ 0x113f, 0x9090, "SST-8P Adapter" }, 
	{ 0x1142, 0x3210, "AP6410" }, 
	{ 0x1142, 0x6422, "ProVideo 6422" }, 
	{ 0x1142, 0x6424, "ProVideo 6424" }, 
	{ 0x1142, 0x6425, "ProMotion AT25" }, 
	{ 0x1142, 0x643d, "ProMotion AT3D" }, 
	{ 0x1144, 0x0001, "Noservo controller" }, 
	{ 0x1148, 0x4000, "FDDI Adapter" }, 
	{ 0x1148, 0x4200, "Token Ring adapter" }, 
	{ 0x1148, 0x4300, "Gigabit Ethernet" }, 
	{ 0x114a, 0x5579, "VMIPCI-5579 (Reflective Memory Card)" }, 
	{ 0x114a, 0x7587, "VMIVME-7587" }, 
	{ 0x114f, 0x0002, "AccelePort EPC" }, 
	{ 0x114f, 0x0003, "RightSwitch SE-6" }, 
	{ 0x114f, 0x0004, "AccelePort Xem" }, 
	{ 0x114f, 0x0005, "AccelePort Xr" }, 
	{ 0x114f, 0x0006, "AccelePort Xr,C/X" }, 
	{ 0x114f, 0x0009, "AccelePort Xr/J" }, 
	{ 0x114f, 0x000a, "AccelePort EPC/J" }, 
	{ 0x114f, 0x000c, "DataFirePRIme T1 (1-port)" }, 
	{ 0x114f, 0x000d, "SyncPort 2-Port (x.25/FR)" }, 
	{ 0x114f, 0x0011, "AccelePort 8r EIA-232 (IBM)" }, 
	{ 0x114f, 0x0012, "AccelePort 8r EIA-422" }, 
	{ 0x114f, 0x0013, "AccelePort Xr" }, 
	{ 0x114f, 0x0014, "AccelePort 8r EIA-422" }, 
	{ 0x114f, 0x0015, "AccelePort Xem" }, 
	{ 0x114f, 0x0016, "AccelePort EPC/X" }, 
	{ 0x114f, 0x0017, "AccelePort C/X" }, 
	{ 0x114f, 0x001a, "DataFirePRIme E1 (1-port)" }, 
	{ 0x114f, 0x001b, "AccelePort C/X (IBM)" }, 
	{ 0x114f, 0x001d, "DataFire RAS T1/E1/PRI" }, 
	{ 0x114f, 0x0023, "AccelePort RAS" }, 
	{ 0x114f, 0x0024, "DataFire RAS B4 ST/U" }, 
	{ 0x114f, 0x0026, "AccelePort 4r 920" }, 
	{ 0x114f, 0x0027, "AccelePort Xr 920" }, 
	{ 0x114f, 0x0034, "AccelePort 2r 920" }, 
	{ 0x114f, 0x0035, "DataFire DSP T1/E1/PRI cPCI" }, 
	{ 0x114f, 0x0040, "AccelePort Xp" }, 
	{ 0x114f, 0x0042, "AccelePort 2p PCI" }, 
	{ 0x114f, 0x0070, "Datafire Micro V IOM2 (Europe)" }, 
	{ 0x114f, 0x0071, "Datafire Micro V (Europe)" }, 
	{ 0x114f, 0x0072, "Datafire Micro V IOM2 (North America)" }, 
	{ 0x114f, 0x0073, "Datafire Micro V (North America)" }, 
	{ 0x114f, 0x6001, "Avanstar" }, 
	{ 0x1158, 0x3011, "Tokenet/vg 1001/10m anylan" }, 
	{ 0x1158, 0x9050, "Lanfleet/Truevalue" }, 
	{ 0x1158, 0x9051, "Lanfleet/Truevalue" }, 
	{ 0x1159, 0x0001, "MV-1000" }, 
	{ 0x115d, 0x0003, "Cardbus Ethernet 10/100" }, 
	{ 0x115d, 0x0005, "Cardbus Ethernet 10/100" }, 
	{ 0x115d, 0x0007, "Cardbus Ethernet 10/100" }, 
	{ 0x115d, 0x000b, "Cardbus Ethernet 10/100" }, 
	{ 0x115d, 0x000c, "Mini-PCI V.90 56k Modem" }, 
	{ 0x115d, 0x000f, "Cardbus Ethernet 10/100" }, 
	{ 0x115d, 0x0101, "Cardbus 56k modem" }, 
	{ 0x115d, 0x0103, "Cardbus Ethernet + 56k Modem" }, 
	{ 0x1163, 0x0001, "Verite 1000" }, 
	{ 0x1163, 0x2000, "Verite V2000/V2100/V2200" }, 
	{ 0x1165, 0x0001, "Motion TPEG Recorder/Player with audio" }, 
	{ 0x1166, 0x0007, "CNB20-LE Host Bridge" }, 
	{ 0x1166, 0x0008, "CNB20HE Host Bridge" }, 
	{ 0x1166, 0x0009, "CNB20LE Host Bridge" }, 
	{ 0x1166, 0x0010, "CIOB30" }, 
	{ 0x1166, 0x0011, "CMIC-HE" }, 
	{ 0x1166, 0x0200, "OSB4 South Bridge" }, 
	{ 0x1166, 0x0201, "CSB5 South Bridge" }, 
	{ 0x1166, 0x0211, "OSB4 IDE Controller" }, 
	{ 0x1166, 0x0212, "CSB5 IDE Controller" }, 
	{ 0x1166, 0x0220, "OSB4/CSB5 USB Controller" }, 
	{ 0x116a, 0x6100, "Bus/Tag Channel" }, 
	{ 0x116a, 0x6800, "Escon Channel" }, 
	{ 0x116a, 0x7100, "Bus/Tag Channel" }, 
	{ 0x116a, 0x7800, "Escon Channel" }, 
	{ 0x1178, 0xafa1, "Fast Ethernet Adapter" }, 
	{ 0x1179, 0x0404, "DVD Decoder card" }, 
	{ 0x1179, 0x0406, "Tecra Video Capture device" }, 
	{ 0x1179, 0x0407, "DVD Decoder card (Version 2)" }, 
	{ 0x1179, 0x0601, "601" }, 
	{ 0x1179, 0x0603, "ToPIC95 PCI to CardBus Bridge for Notebooks" }, 
	{ 0x1179, 0x060a, "ToPIC95" }, 
	{ 0x1179, 0x060f, "ToPIC97" }, 
	{ 0x1179, 0x0617, "ToPIC95 PCI to Cardbus Bridge with ZV Support" }, 
	{ 0x1179, 0x0618, "CPU to PCI and PCI to ISA bridge" }, 
	{ 0x1179, 0x0701, "FIR Port" }, 
	{ 0x1179, 0x0d01, "FIR Port Type-DO" }, 
	{ 0x1180, 0x0465, "RL5c465" }, 
	{ 0x1180, 0x0466, "RL5c466" }, 
	{ 0x1180, 0x0475, "RL5c475" }, 
	{ 0x1180, 0x0476, "RL5c476 II" }, 
	{ 0x1180, 0x0477, "RL5c477" }, 
	{ 0x1180, 0x0478, "RL5c478" }, 
	{ 0x1180, 0x0552, "R5C552 IEEE 1394 Controller" }, 
	{ 0x1186, 0x0100, "DC21041" }, 
	{ 0x1186, 0x1002, "Sundance Ethernet" }, 
	{ 0x1186, 0x1300, "RTL8139 Ethernet" }, 
	{ 0x1186, 0x1340, "DFE-690TXD CardBus PC Card" }, 
	{ 0x1186, 0x1561, "DRP-32TXD Cardbus PC Card" }, 
	{ 0x1186, 0x4000, "DL2K Ethernet" }, 
	{ 0x118c, 0x0014, "PCIB [C-bus II to PCI bus host bridge chip]" }, 
	{ 0x118c, 0x1117, "Intel 8-way XEON Profusion Chipset [Cache Coherency Filter]" }, 
	{ 0x118d, 0x0001, "Raptor-PCI framegrabber" }, 
	{ 0x118d, 0x0012, "Model 12 Road Runner Frame Grabber" }, 
	{ 0x118d, 0x0014, "Model 14 Road Runner Frame Grabber" }, 
	{ 0x118d, 0x0024, "Model 24 Road Runner Frame Grabber" }, 
	{ 0x118d, 0x0044, "Model 44 Road Runner Frame Grabber" }, 
	{ 0x118d, 0x0112, "Model 12 Road Runner Frame Grabber" }, 
	{ 0x118d, 0x0114, "Model 14 Road Runner Frame Grabber" }, 
	{ 0x118d, 0x0124, "Model 24 Road Runner Frame Grabber" }, 
	{ 0x118d, 0x0144, "Model 44 Road Runner Frame Grabber" }, 
	{ 0x118d, 0x0212, "Model 12 Road Runner Frame Grabber" }, 
	{ 0x118d, 0x0214, "Model 14 Road Runner Frame Grabber" }, 
	{ 0x118d, 0x0224, "Model 24 Road Runner Frame Grabber" }, 
	{ 0x118d, 0x0244, "Model 44 Road Runner Frame Grabber" }, 
	{ 0x118d, 0x0312, "Model 12 Road Runner Frame Grabber" }, 
	{ 0x118d, 0x0314, "Model 14 Road Runner Frame Grabber" }, 
	{ 0x118d, 0x0324, "Model 24 Road Runner Frame Grabber" }, 
	{ 0x118d, 0x0344, "Model 44 Road Runner Frame Grabber" }, 
	{ 0x1190, 0xc731, "TP-910/920/940 PCI Ultra(Wide) SCSI Adapter" }, 
	{ 0x1191, 0x0003, "SCSI Cache Host Adapter" }, 
	{ 0x1191, 0x0004, "ATP8400" }, 
	{ 0x1191, 0x0005, "ATP850UF" }, 
	{ 0x1191, 0x0006, "ATP860 NO-BIOS" }, 
	{ 0x1191, 0x0007, "ATP860" }, 
	{ 0x1191, 0x0008, "ATP865 NO-ROM" }, 
	{ 0x1191, 0x0009, "ATP865" }, 
	{ 0x1191, 0x8002, "AEC6710 SCSI-2 Host Adapter" }, 
	{ 0x1191, 0x8010, "AEC6712UW SCSI" }, 
	{ 0x1191, 0x8020, "AEC6712U SCSI" }, 
	{ 0x1191, 0x8030, "AEC6712S SCSI" }, 
	{ 0x1191, 0x8040, "AEC6712D SCSI" }, 
	{ 0x1191, 0x8050, "AEC6712SUW SCSI" }, 
	{ 0x1193, 0x0001, "1221" }, 
	{ 0x1193, 0x0002, "1225" }, 
	{ 0x119b, 0x1221, "82C092G" }, 
	{ 0x119e, 0x0001, "FireStream 155" }, 
	{ 0x119e, 0x0003, "FireStream 50" }, 
	{ 0x11a9, 0x4240, "AMCC S933Q Intelligent Serial Card" }, 
	{ 0x11ab, 0x0146, "GT-64010" }, 
	{ 0x11ab, 0x4801, "GT-48001" }, 
	{ 0x11ab, 0xf003, "GT-64010 Primary Image Piranha Image Generator" }, 
	{ 0x11ad, 0x0002, "LNE100TX" }, 
	{ 0x11ad, 0xc115, "LNE100TX [Linksys EtherFast 10/100]" }, 
	{ 0x11b0, 0x0002, "V300PSC" }, 
	{ 0x11b0, 0x0292, "V292PBC [Am29030/40 Bridge]" }, 
	{ 0x11b0, 0x0960, "V96xPBC" }, 
	{ 0x11b0, 0xc960, "V96DPC" }, 
	{ 0x11b8, 0x0001, "Quad PeerMaster" }, 
	{ 0x11b9, 0xc0ed, "SSA Controller" }, 
	{ 0x11bc, 0x0001, "NP-PCI" }, 
	{ 0x11c1, 0x0440, "56k WinModem" }, 
	{ 0x11c1, 0x0441, "56k WinModem" }, 
	{ 0x11c1, 0x0442, "56k WinModem" }, 
	{ 0x11c1, 0x0443, "LT WinModem" }, 
	{ 0x11c1, 0x0444, "LT WinModem" }, 
	{ 0x11c1, 0x0445, "LT WinModem" }, 
	{ 0x11c1, 0x0446, "LT WinModem" }, 
	{ 0x11c1, 0x0447, "LT WinModem" }, 
	{ 0x11c1, 0x0448, "WinModem 56k" }, 
	{ 0x11c1, 0x0449, "WinModem 56k" }, 
	{ 0x11c1, 0x044a, "F-1156IV WinModem (V90, 56KFlex)" }, 
	{ 0x11c1, 0x044b, "LT WinModem" }, 
	{ 0x11c1, 0x044c, "LT WinModem" }, 
	{ 0x11c1, 0x044d, "LT WinModem" }, 
	{ 0x11c1, 0x044e, "LT WinModem" }, 
	{ 0x11c1, 0x044f, "V90 WildWire Modem" }, 
	{ 0x11c1, 0x0450, "LT WinModem" }, 
	{ 0x11c1, 0x0451, "LT WinModem" }, 
	{ 0x11c1, 0x0452, "LT WinModem" }, 
	{ 0x11c1, 0x0453, "LT WinModem" }, 
	{ 0x11c1, 0x0454, "LT WinModem" }, 
	{ 0x11c1, 0x0455, "LT WinModem" }, 
	{ 0x11c1, 0x0456, "LT WinModem" }, 
	{ 0x11c1, 0x0457, "LT WinModem" }, 
	{ 0x11c1, 0x0458, "LT WinModem" }, 
	{ 0x11c1, 0x0459, "LT WinModem" }, 
	{ 0x11c1, 0x045a, "LT WinModem" }, 
	{ 0x11c1, 0x0461, "V90 WildWire Modem" }, 
	{ 0x11c1, 0x0462, "V90 WildWire Modem" }, 
	{ 0x11c1, 0x0480, "Venus Modem (V90, 56KFlex)" }, 
	{ 0x11c1, 0x5811, "FW323" }, 
	{ 0x11c8, 0x0658, "PSB32 SCI-Adapter D31x" }, 
	{ 0x11c8, 0xd665, "PSB64 SCI-Adapter D32x" }, 
	{ 0x11c8, 0xd667, "PSB66 SCI-Adapter D33x" }, 
	{ 0x11c9, 0x0010, "16-line serial port w/- DMA" }, 
	{ 0x11c9, 0x0011, "4-line serial port w/- DMA" }, 
	{ 0x11cb, 0x2000, "PCI_9050" }, 
	{ 0x11cb, 0x4000, "SUPI_1" }, 
	{ 0x11cb, 0x8000, "T225" }, 
	{ 0x11d1, 0x01f7, "VxP524" }, 
	{ 0x11d4, 0x1805, "SM56 PCI modem" }, 
	{ 0x11d4, 0x1889, "AD1889 sound chip" }, 
	{ 0x11d5, 0x0115, "10115" }, 
	{ 0x11d5, 0x0117, "10117" }, 
	{ 0x11de, 0x6057, "ZR36057PQC Video cutting chipset" }, 
	{ 0x11de, 0x6120, "ZR36120" }, 
	{ 0x11f0, 0x4231, "FDDI" }, 
	{ 0x11f0, 0x4232, "FASTline UTP Quattro" }, 
	{ 0x11f0, 0x4233, "FASTline FO" }, 
	{ 0x11f0, 0x4234, "FASTline UTP" }, 
	{ 0x11f0, 0x4235, "FASTline-II UTP" }, 
	{ 0x11f0, 0x4236, "FASTline-II FO" }, 
	{ 0x11f0, 0x4731, "GIGAline" }, 
	{ 0x11f4, 0x2915, "CAMAC controller" }, 
	{ 0x11f6, 0x0112, "ENet100VG4" }, 
	{ 0x11f6, 0x0113, "FreedomLine 100" }, 
	{ 0x11f6, 0x1401, "ReadyLink 2000" }, 
	{ 0x11f6, 0x2011, "RL100-ATX 10/100" }, 
	{ 0x11f6, 0x2201, "ReadyLink 100TX (Winbond W89C840)" }, 
	{ 0x11f6, 0x9881, "RL100TX" }, 
	{ 0x11f8, 0x7375, "PM7375 [LASAR-155 ATM SAR]" }, 
	{ 0x11fe, 0x0001, "RocketPort 8 Oct" }, 
	{ 0x11fe, 0x0002, "RocketPort 8 Intf" }, 
	{ 0x11fe, 0x0003, "RocketPort 16 Intf" }, 
	{ 0x11fe, 0x0004, "RocketPort 32 Intf" }, 
	{ 0x11fe, 0x0005, "RocketPort Octacable" }, 
	{ 0x11fe, 0x0006, "RocketPort 8J" }, 
	{ 0x11fe, 0x0008, "RocketPort 8-port" }, 
	{ 0x11fe, 0x0009, "RocketPort 16-port" }, 
	{ 0x11fe, 0x000a, "RocketPort Plus Quadcable" }, 
	{ 0x11fe, 0x000b, "RocketPort Plus Octacable" }, 
	{ 0x11fe, 0x000c, "RocketPort 8-port Modem" }, 
	{ 0x1208, 0x4853, "HS-Link Device" }, 
	{ 0x120e, 0x0100, "Cyclom_Y below first megabyte" }, 
	{ 0x120e, 0x0101, "Cyclom_Y above first megabyte" }, 
	{ 0x120e, 0x0102, "Cyclom_4Y below first megabyte" }, 
	{ 0x120e, 0x0103, "Cyclom_4Y above first megabyte" }, 
	{ 0x120e, 0x0104, "Cyclom_8Y below first megabyte" }, 
	{ 0x120e, 0x0105, "Cyclom_8Y above first megabyte" }, 
	{ 0x120e, 0x0200, "Cyclom_Z below first megabyte" }, 
	{ 0x120e, 0x0201, "Cyclom_Z above first megabyte" }, 
	{ 0x120e, 0x0300, "PC300 RX 2" }, 
	{ 0x120e, 0x0301, "PC300 RX 1" }, 
	{ 0x120e, 0x0310, "PC300 TE 2" }, 
	{ 0x120e, 0x0311, "PC300 TE 1" }, 
	{ 0x120f, 0x0001, "Roadrunner serial HIPPI" }, 
	{ 0x1217, 0x6729, "6729" }, 
	{ 0x1217, 0x673a, "6730" }, 
	{ 0x1217, 0x6832, "6832" }, 
	{ 0x1217, 0x6836, "6836" }, 
	{ 0x1217, 0x6872, "OZ6812 Cardbus Controller" }, 
	{ 0x1217, 0x6933, "OZ6933 Cardbus Controller" }, 
	{ 0x121a, 0x0001, "Voodoo" }, 
	{ 0x121a, 0x0002, "Voodoo 2" }, 
	{ 0x121a, 0x0003, "Voodoo Banshee" }, 
	{ 0x121a, 0x0004, "Voodoo Banshee [Velocity 100]" }, 
	{ 0x121a, 0x0005, "Voodoo 3" }, 
	{ 0x121a, 0x0009, "Voodoo 4 / Voodoo 5" }, 
	{ 0x121a, 0x0057, "Voodoo 3/3000 [Avenger]" }, 
	{ 0x1220, 0x1220, "AMCC 5933 TMS320C80 DSP/Imaging board" }, 
	{ 0x1223, 0x0003, "PM/Link" }, 
	{ 0x1223, 0x0004, "PM/T1" }, 
	{ 0x1223, 0x0005, "PM/E1" }, 
	{ 0x1223, 0x0008, "PM/SLS" }, 
	{ 0x1223, 0x0009, "BajaSpan Resource Target" }, 
	{ 0x1223, 0x000a, "BajaSpan Section 0" }, 
	{ 0x1223, 0x000b, "BajaSpan Section 1" }, 
	{ 0x1223, 0x000c, "BajaSpan Section 2" }, 
	{ 0x1223, 0x000d, "BajaSpan Section 3" }, 
	{ 0x1223, 0x000e, "PM/PPC" }, 
	{ 0x122d, 0x1206, "368DSP" }, 
	{ 0x122d, 0x50dc, "3328 Audio" }, 
	{ 0x122d, 0x80da, "3328 Audio" }, 
	{ 0x1236, 0x0000, "RealMagic64/GX" }, 
	{ 0x1236, 0x6401, "REALmagic 64/GX (SD 6425)" }, 
	{ 0x123d, 0x0000, "EasyConnect 8/32" }, 
	{ 0x123d, 0x0002, "EasyConnect 8/64" }, 
	{ 0x123d, 0x0003, "EasyIO" }, 
	{ 0x123f, 0x00e4, "MPEG" }, 
	{ 0x123f, 0x8120, "E4?" }, 
	{ 0x123f, 0x8888, "Cinemaster C 3.0 DVD Decoder" }, 
	{ 0x1242, 0x4643, "FCI-1063 Fibre Channel Adapter" }, 
	{ 0x1244, 0x0700, "B1 ISDN" }, 
	{ 0x1244, 0x0800, "C4 ISDN" }, 
	{ 0x1244, 0x0a00, "A1 ISDN [Fritz]" }, 
	{ 0x1244, 0x0e00, "Fritz!PCI v2.0 ISDN" }, 
	{ 0x1244, 0x1100, "C2 ISDN" }, 
	{ 0x1244, 0x1200, "T1 ISDN" }, 
	{ 0x124b, 0x0040, "cPCI-200 Four Slot IndustryPack carrier" }, 
	{ 0x124d, 0x0000, "EasyConnection 8/32" }, 
	{ 0x124d, 0x0002, "EasyConnection 8/64" }, 
	{ 0x124d, 0x0003, "EasyIO" }, 
	{ 0x124d, 0x0004, "EasyConnection/RA" }, 
	{ 0x124f, 0x0041, "IFT-2000 Series RAID Controller" }, 
	{ 0x1255, 0x1110, "MPEG Forge" }, 
	{ 0x1255, 0x1210, "MPEG Fusion" }, 
	{ 0x1255, 0x2110, "VideoPlex" }, 
	{ 0x1255, 0x2120, "VideoPlex CC" }, 
	{ 0x1255, 0x2130, "VideoQuest" }, 
	{ 0x1256, 0x4201, "PCI-2220I" }, 
	{ 0x1256, 0x4401, "PCI-2240I" }, 
	{ 0x1256, 0x5201, "PCI-2000" }, 
	{ 0x1259, 0x2560, "AT-2560 Fast Ethernet Adapter (i82557B)" }, 
	{ 0x125b, 0x1400, "ALFA GFC2204" }, 
	{ 0x125d, 0x0000, "ES336H Fax Modem (Early Model)" }, 
	{ 0x125d, 0x1948, "Solo?" }, 
	{ 0x125d, 0x1968, "ES1968 Maestro 2" }, 
	{ 0x125d, 0x1969, "ES1969 Solo-1 Audiodrive" }, 
	{ 0x125d, 0x1978, "ES1978 Maestro 2E" }, 
	{ 0x125d, 0x1988, "ES1988 Allegro-1" }, 
	{ 0x125d, 0x1989, "ESS Modem" }, 
	{ 0x125d, 0x1998, "ES1983S Maestro-3i PCI Audio Accelerator" }, 
	{ 0x125d, 0x1999, "ES1983S Maestro-3i PCI Modem Accelerator" }, 
	{ 0x125d, 0x199a, "ES1983S Maestro-3i PCI Audio Accelerator" }, 
	{ 0x125d, 0x199b, "ES1983S Maestro-3i PCI Modem Accelerator" }, 
	{ 0x125d, 0x2808, "ES336H Fax Modem (Later Model)" }, 
	{ 0x125d, 0x2838, "ES2838/2839 SuperLink Modem" }, 
	{ 0x125d, 0x2898, "ES2898 Modem" }, 
	{ 0x1260, 0x8130, "HMP8130 NTSC/PAL Video Decoder" }, 
	{ 0x1260, 0x8131, "HMP8131 NTSC/PAL Video Decoder" }, 
	{ 0x1266, 0x0001, "NE10/100 Adapter (i82557B)" }, 
	{ 0x1266, 0x1910, "NE2000Plus (RT8029) Ethernet Adapter" }, 
	{ 0x1267, 0x5352, "PCR2101" }, 
	{ 0x1267, 0x5a4b, "Telsat Turbo" }, 
	{ 0x126f, 0x0710, "SM710 LynxEM" }, 
	{ 0x126f, 0x0712, "SM712 LynxEM+" }, 
	{ 0x126f, 0x0720, "SM720 Lynx3DM" }, 
	{ 0x126f, 0x0810, "SM810 LynxE" }, 
	{ 0x126f, 0x0811, "SM811 LynxE" }, 
	{ 0x126f, 0x0820, "SM820 Lynx3D" }, 
	{ 0x126f, 0x0910, "SM910" }, 
	{ 0x1273, 0x0002, "DirecPC" }, 
	{ 0x1274, 0x1371, "ES1371 [AudioPCI-97]" }, 
	{ 0x1274, 0x5000, "ES1370 [AudioPCI]" }, 
	{ 0x1274, 0x5880, "5880 AudioPCI" }, 
	{ 0x1278, 0x0701, "TPE3/TM3 PowerPC Node" }, 
	{ 0x1279, 0x0295, "Northbridge" }, 
	{ 0x1279, 0x0395, "LongRun Northbridge" }, 
	{ 0x1279, 0x0396, "SDRAM controller" }, 
	{ 0x1279, 0x0397, "BIOS scratchpad" }, 
	{ 0x127a, 0x1002, "HCF 56k Data/Fax Modem" }, 
	{ 0x127a, 0x1003, "HCF 56k Data/Fax Modem" }, 
	{ 0x127a, 0x1004, "HCF 56k Data/Fax/Voice Modem" }, 
	{ 0x127a, 0x1005, "HCF 56k Data/Fax/Voice/Spkp (w/Handset) Modem" }, 
	{ 0x127a, 0x1022, "HCF 56k Modem" }, 
	{ 0x127a, 0x1023, "HCF 56k Data/Fax Modem" }, 
	{ 0x127a, 0x1024, "HCF 56k Data/Fax/Voice Modem" }, 
	{ 0x127a, 0x1025, "HCF 56k Data/Fax/Voice/Spkp (w/Handset) Modem" }, 
	{ 0x127a, 0x1026, "HCF 56k PCI Speakerphone Modem" }, 
	{ 0x127a, 0x1032, "HCF 56k Modem" }, 
	{ 0x127a, 0x1033, "HCF 56k Modem" }, 
	{ 0x127a, 0x1034, "HCF 56k Modem" }, 
	{ 0x127a, 0x1035, "HCF 56k PCI Speakerphone Modem" }, 
	{ 0x127a, 0x1036, "HCF 56k Modem" }, 
	{ 0x127a, 0x1085, "HCF 56k Volcano PCI Modem" }, 
	{ 0x127a, 0x2005, "HCF 56k Data/Fax Modem" }, 
	{ 0x127a, 0x2013, "HSF 56k Data/Fax Modem" }, 
	{ 0x127a, 0x2014, "HSF 56k Data/Fax/Voice Modem" }, 
	{ 0x127a, 0x2015, "HSF 56k Data/Fax/Voice/Spkp (w/Handset) Modem" }, 
	{ 0x127a, 0x2016, "HSF 56k Data/Fax/Voice/Spkp Modem" }, 
	{ 0x127a, 0x4311, "Riptide HSF 56k PCI Modem" }, 
	{ 0x127a, 0x4320, "Riptide PCI Audio Controller" }, 
	{ 0x127a, 0x4321, "Riptide HCF 56k PCI Modem" }, 
	{ 0x127a, 0x4322, "Riptide PCI Game Controller" }, 
	{ 0x127a, 0x8234, "RapidFire 616X ATM155 Adapter" }, 
	{ 0x1282, 0x9009, "Ethernet 100/10 MBit" }, 
	{ 0x1282, 0x9100, "Ethernet 100/10 MBit" }, 
	{ 0x1282, 0x9102, "Ethernet 100/10 MBit" }, 
	{ 0x1282, 0x9132, "Ethernet 100/10 MBit" }, 
	{ 0x1283, 0x673a, "IT8330G" }, 
	{ 0x1283, 0x8330, "IT8330G" }, 
	{ 0x1283, 0x8888, "IT8888F PCI to ISA Bridge with SMB" }, 
	{ 0x1283, 0x8889, "IT8889F PCI to ISA Bridge" }, 
	{ 0x1283, 0xe886, "IT8330G" }, 
	{ 0x1285, 0x0100, "AGOGO sound chip (aka ESS Maestro 1)" }, 
	{ 0x1287, 0x001e, "LS220D DVD Decoder" }, 
	{ 0x1287, 0x001f, "LS220C DVD Decoder" }, 
	{ 0x128d, 0x0021, "ATM155 Adapter" }, 
	{ 0x128e, 0x0008, "ST128 WSS/SB" }, 
	{ 0x128e, 0x0009, "ST128 SAM9407" }, 
	{ 0x128e, 0x000a, "ST128 Game Port" }, 
	{ 0x128e, 0x000b, "ST128 MPU Port" }, 
	{ 0x128e, 0x000c, "ST128 Ctrl Port" }, 
	{ 0x129a, 0x0615, "PBT-615 PCI-X Bus Analyzer" }, 
	{ 0x12ab, 0x3000, "MPG-200C PCI DVD Decoder Card" }, 
	{ 0x12ae, 0x0001, "AceNIC Gigabit Ethernet (Fibre)" }, 
	{ 0x12ae, 0x0002, "AceNIC Gigabit Ethernet (Copper)" }, 
	{ 0x12b9, 0x1006, "WinModem" }, 
	{ 0x12b9, 0x1007, "USR 56k Internal WinModem" }, 
	{ 0x12b9, 0x1008, "56K FaxModem Model 5610" }, 
	{ 0x12be, 0x3041, "AN3041Q CO-MEM" }, 
	{ 0x12be, 0x3042, "AN3042Q CO-MEM Lite" }, 
	{ 0x12c3, 0x0058, "PCI NE2K Ethernet" }, 
	{ 0x12c3, 0x5598, "PCI NE2K Ethernet" }, 
	{ 0x12c5, 0x0081, "PCIVST [Grayscale Thresholding Engine]" }, 
	{ 0x12c5, 0x0085, "Video Simulator/Sender" }, 
	{ 0x12c5, 0x0086, "THR2 Multi-scale Thresholder" }, 
	{ 0x12d2, 0x0008, "NV1" }, 
	{ 0x12d2, 0x0009, "DAC64" }, 
	{ 0x12d2, 0x0018, "Riva128" }, 
	{ 0x12d2, 0x0019, "Riva128ZX" }, 
	{ 0x12d2, 0x0020, "TNT" }, 
	{ 0x12d2, 0x0028, "TNT2" }, 
	{ 0x12d2, 0x0029, "UTNT2" }, 
	{ 0x12d2, 0x002c, "VTNT2" }, 
	{ 0x12d2, 0x00a0, "ITNT2" }, 
	{ 0x12e0, 0x0010, "ST16C654 Quad UART" }, 
	{ 0x12e0, 0x0020, "ST16C654 Quad UART" }, 
	{ 0x12e0, 0x0030, "ST16C654 Quad UART" }, 
	{ 0x12eb, 0x0001, "Vortex 1" }, 
	{ 0x12eb, 0x0002, "Vortex 2" }, 
	{ 0x12eb, 0x0003, "AU8810 Vortex Digital Audio Processor" }, 
	{ 0x12eb, 0x8803, "Vortex 56k Software Modem" }, 
	{ 0x12f8, 0x0002, "VideoMaker" }, 
	{ 0x1307, 0x0001, "PCI-DAS1602/16" }, 
	{ 0x1307, 0x000b, "PCI-DIO48H" }, 
	{ 0x1307, 0x000c, "PCI-PDISO8" }, 
	{ 0x1307, 0x000d, "PCI-PDISO16" }, 
	{ 0x1307, 0x000f, "PCI-DAS1200" }, 
	{ 0x1307, 0x0010, "PCI-DAS1602/12" }, 
	{ 0x1307, 0x0014, "PCI-DIO24H" }, 
	{ 0x1307, 0x0015, "PCI-DIO24H/CTR3" }, 
	{ 0x1307, 0x0016, "PCI-DIO48H/CTR15" }, 
	{ 0x1307, 0x0017, "PCI-DIO96H" }, 
	{ 0x1307, 0x0018, "PCI-CTR05" }, 
	{ 0x1307, 0x0019, "PCI-DAS1200/JR" }, 
	{ 0x1307, 0x001a, "PCI-DAS1001" }, 
	{ 0x1307, 0x001b, "PCI-DAS1002" }, 
	{ 0x1307, 0x001c, "PCI-DAS1602JR/16" }, 
	{ 0x1307, 0x001d, "PCI-DAS6402/16" }, 
	{ 0x1307, 0x001e, "PCI-DAS6402/12" }, 
	{ 0x1307, 0x001f, "PCI-DAS16/M1" }, 
	{ 0x1307, 0x0020, "PCI-DDA02/12" }, 
	{ 0x1307, 0x0021, "PCI-DDA04/12" }, 
	{ 0x1307, 0x0022, "PCI-DDA08/12" }, 
	{ 0x1307, 0x0023, "PCI-DDA02/16" }, 
	{ 0x1307, 0x0024, "PCI-DDA04/16" }, 
	{ 0x1307, 0x0025, "PCI-DDA08/16" }, 
	{ 0x1307, 0x0026, "PCI-DAC04/12-HS" }, 
	{ 0x1307, 0x0027, "PCI-DAC04/16-HS" }, 
	{ 0x1307, 0x0028, "PCI-DIO24" }, 
	{ 0x1307, 0x0029, "PCI-DAS08" }, 
	{ 0x1307, 0x002c, "PCI-INT32" }, 
	{ 0x1307, 0x0033, "PCI-DUAL-AC5" }, 
	{ 0x1307, 0x0034, "PCI-DAS-TC" }, 
	{ 0x1307, 0x0035, "PCI-DAS64/M1/16" }, 
	{ 0x1307, 0x0036, "PCI-DAS64/M2/16" }, 
	{ 0x1307, 0x0037, "PCI-DAS64/M3/16" }, 
	{ 0x1307, 0x004c, "PCI-DAS1000" }, 
	{ 0x1308, 0x0001, "NetCelerator Adapter" }, 
	{ 0x1317, 0x0981, "Fast Ethernet 10/100" }, 
	{ 0x1317, 0x0985, "Network Everywhere Fast Ethernet 10/100 model NC100" }, 
	{ 0x1317, 0x1985, "Fast Ethernet 10/100" }, 
	{ 0x1318, 0x0911, "PCI Ethernet Adapter" }, 
	{ 0x1319, 0x0801, "Xwave QS3000A [FM801]" }, 
	{ 0x1319, 0x0802, "Xwave QS3000A [FM801 game port]" }, 
	{ 0x1319, 0x1000, "FM801 PCI Audio" }, 
	{ 0x1319, 0x1001, "FM801 PCI Joystick" }, 
	{ 0x131f, 0x1000, "CyberSerial (1-port) 16550" }, 
	{ 0x131f, 0x1001, "CyberSerial (1-port) 16650" }, 
	{ 0x131f, 0x1002, "CyberSerial (1-port) 16850" }, 
	{ 0x131f, 0x1010, "Duet 1S(16550)+1P" }, 
	{ 0x131f, 0x1011, "Duet 1S(16650)+1P" }, 
	{ 0x131f, 0x1012, "Duet 1S(16850)+1P" }, 
	{ 0x131f, 0x1020, "CyberParallel (1-port)" }, 
	{ 0x131f, 0x1021, "CyberParallel (2-port)" }, 
	{ 0x131f, 0x1030, "CyberSerial (2-port) 16550" }, 
	{ 0x131f, 0x1031, "CyberSerial (2-port) 16650" }, 
	{ 0x131f, 0x1032, "CyberSerial (2-port) 16850" }, 
	{ 0x131f, 0x1034, "Trio 2S(16550)+1P" }, 
	{ 0x131f, 0x1035, "Trio 2S(16650)+1P" }, 
	{ 0x131f, 0x1036, "Trio 2S(16850)+1P" }, 
	{ 0x131f, 0x1050, "CyberSerial (4-port) 16550" }, 
	{ 0x131f, 0x1051, "CyberSerial (4-port) 16650" }, 
	{ 0x131f, 0x1052, "CyberSerial (4-port) 16850" }, 
	{ 0x131f, 0x2000, "CyberSerial (1-port) 16550" }, 
	{ 0x131f, 0x2001, "CyberSerial (1-port) 16650" }, 
	{ 0x131f, 0x2002, "CyberSerial (1-port) 16850" }, 
	{ 0x131f, 0x2010, "Duet 1S(16550)+1P" }, 
	{ 0x131f, 0x2011, "Duet 1S(16650)+1P" }, 
	{ 0x131f, 0x2012, "Duet 1S(16850)+1P" }, 
	{ 0x131f, 0x2020, "CyberParallel (1-port)" }, 
	{ 0x131f, 0x2021, "CyberParallel (2-port)" }, 
	{ 0x131f, 0x2030, "CyberSerial (2-port) 16550" }, 
	{ 0x131f, 0x2031, "CyberSerial (2-port) 16650" }, 
	{ 0x131f, 0x2032, "CyberSerial (2-port) 16850" }, 
	{ 0x131f, 0x2040, "Trio 1S(16550)+2P" }, 
	{ 0x131f, 0x2041, "Trio 1S(16650)+2P" }, 
	{ 0x131f, 0x2042, "Trio 1S(16850)+2P" }, 
	{ 0x131f, 0x2050, "CyberSerial (4-port) 16550" }, 
	{ 0x131f, 0x2051, "CyberSerial (4-port) 16650" }, 
	{ 0x131f, 0x2052, "CyberSerial (4-port) 16850" }, 
	{ 0x131f, 0x2060, "Trio 2S(16550)+1P" }, 
	{ 0x131f, 0x2061, "Trio 2S(16650)+1P" }, 
	{ 0x131f, 0x2062, "Trio 2S(16850)+1P" }, 
	{ 0x134a, 0x0001, "Domex 536" }, 
	{ 0x134a, 0x0002, "Domex DMX3194UP SCSI Adapter" }, 
	{ 0x134d, 0x7890, "HSP MicroModem 56" }, 
	{ 0x134d, 0x7891, "HSP MicroModem 56" }, 
	{ 0x134d, 0x7892, "HSP MicroModem 56" }, 
	{ 0x134d, 0x7893, "HSP MicroModem 56" }, 
	{ 0x134d, 0x7894, "HSP MicroModem 56" }, 
	{ 0x134d, 0x7895, "HSP MicroModem 56" }, 
	{ 0x134d, 0x7896, "HSP MicroModem 56" }, 
	{ 0x134d, 0x7897, "HSP MicroModem 56" }, 
	{ 0x135e, 0x7101, "Single Port RS-232/422/485/530" }, 
	{ 0x135e, 0x7201, "Dual Port RS-232/422/485 Interface" }, 
	{ 0x135e, 0x7202, "Dual Port RS-232 Interface" }, 
	{ 0x135e, 0x7401, "Four Port RS-232 Interface" }, 
	{ 0x135e, 0x7402, "Four Port RS-422/485 Interface" }, 
	{ 0x135e, 0x7801, "Eight Port RS-232 Interface" }, 
	{ 0x135e, 0x8001, "8001 Digital I/O Adapter" }, 
	{ 0x1385, 0x4100, "802.11b Wireless Adapter (MA301)" }, 
	{ 0x1385, 0x620a, "GA620" }, 
	{ 0x1385, 0x622a, "GA622" }, 
	{ 0x1385, 0x630a, "GA630" }, 
	{ 0x1385, 0xf311, "FA311" }, 
	{ 0x1389, 0x0001, "PCI1500PFB [Intelligent fieldbus adaptor]" }, 
	{ 0x1393, 0x1040, "Smartio C104H/PCI" }, 
	{ 0x1393, 0x1680, "Smartio C168H/PCI" }, 
	{ 0x1393, 0x2040, "Intellio CP-204J" }, 
	{ 0x1393, 0x2180, "Intellio C218 Turbo PCI" }, 
	{ 0x1393, 0x3200, "Intellio C320 Turbo PCI" }, 
	{ 0x1394, 0x0001, "LXT1001 Gigabit Ethernet" }, 
	{ 0x1397, 0x2bd0, "ISDN network controller [HFC-PCI]" }, 
	{ 0x13a3, 0x0005, "7751 Security Processor" }, 
	{ 0x13a3, 0x0006, "6500 Public Key Processor" }, 
	{ 0x13a3, 0x0007, "7811 Security Processor" }, 
	{ 0x13a3, 0x0012, "7951 Security Processor" }, 
	{ 0x13a8, 0x0158, "XR17C158 Octal UART" }, 
	{ 0x13c0, 0x0010, "SyncLink WAN Adapter" }, 
	{ 0x13c1, 0x1000, "3ware ATA-RAID" }, 
	{ 0x13c1, 0x1001, "3ware 7000-series ATA-RAID" }, 
	{ 0x13d1, 0xab06, "RTL8139 [FE2000VX] CardBus Fast Ethernet Attached Port Adapter" }, 
	{ 0x13df, 0x0001, "PCI56RVP Modem" }, 
	{ 0x13f0, 0x0201, "Sundance Ethernet" }, 
	{ 0x13f4, 0x1401, "Zentai Fibre Channel Adapter" }, 
	{ 0x13f6, 0x0100, "CM8338A" }, 
	{ 0x13f6, 0x0101, "CM8338B" }, 
	{ 0x13f6, 0x0111, "CM8738" }, 
	{ 0x13f6, 0x0211, "CM8738" }, 
	{ 0x1400, 0x1401, "9432 TX" }, 
	{ 0x1407, 0x0100, "Lava Dual Serial" }, 
	{ 0x1407, 0x0101, "Lava Quatro A" }, 
	{ 0x1407, 0x0102, "Lava Quatro B" }, 
	{ 0x1407, 0x0200, "Lava Port Plus" }, 
	{ 0x1407, 0x0201, "Lava Quad A" }, 
	{ 0x1407, 0x0202, "Lava Quad B" }, 
	{ 0x1407, 0x0500, "Lava Single Serial" }, 
	{ 0x1407, 0x0600, "Lava Port 650" }, 
	{ 0x1407, 0x8000, "Lava Parallel" }, 
	{ 0x1407, 0x8002, "Lava Dual Parallel port A" }, 
	{ 0x1407, 0x8003, "Lava Dual Parallel port B" }, 
	{ 0x1407, 0x8800, "BOCA Research IOPPAR" }, 
	{ 0x1409, 0x7168, "PCI2S550 (Dual 16550 UART)" }, 
	{ 0x1412, 0x1712, "ICE1712 [Envy24]" }, 
	{ 0x1415, 0x8403, "VScom 011H-EP1 1 port parallel adaptor" }, 
	{ 0x1415, 0x9501, "Quad 16950 UART" }, 
	{ 0x1415, 0x9511, "OX16PCI954 (Quad 16950 UART) function 1" }, 
	{ 0x1415, 0x9521, "OX16PCI952 (Dual 16950 UART)" }, 
	{ 0x144a, 0x7296, "PCI-7296" }, 
	{ 0x144a, 0x7432, "PCI-7432" }, 
	{ 0x144a, 0x7433, "PCI-7433" }, 
	{ 0x144a, 0x7434, "PCI-7434" }, 
	{ 0x144a, 0x7841, "PCI-7841" }, 
	{ 0x144a, 0x8133, "PCI-8133" }, 
	{ 0x144a, 0x8554, "PCI-8554" }, 
	{ 0x144a, 0x9111, "PCI-9111" }, 
	{ 0x144a, 0x9113, "PCI-9113" }, 
	{ 0x144a, 0x9114, "PCI-9114" }, 
	{ 0x145f, 0x0001, "NextMove PCI" }, 
	{ 0x148d, 0x1003, "HCF 56k Data/Fax Modem" }, 
	{ 0x14b3, 0x0000, "DSL NIC" }, 
	{ 0x14b7, 0x0001, "Symphony 4110" }, 
	{ 0x14b9, 0x0001, "PC4800" }, 
	{ 0x14b9, 0x0340, "PC4800" }, 
	{ 0x14b9, 0x0350, "PC4800" }, 
	{ 0x14b9, 0x4500, "PC4500" }, 
	{ 0x14b9, 0x4800, "PC4800" }, 
	{ 0x14d2, 0x8001, "VScom 010L 1 port parallel adaptor" }, 
	{ 0x14d2, 0x8002, "VScom 020L 2 port parallel adaptor" }, 
	{ 0x14d2, 0x8010, "VScom 100L 1 port serial adaptor" }, 
	{ 0x14d2, 0x8011, "VScom 110L 1 port serial and 1 port parallel adaptor" }, 
	{ 0x14d2, 0x8020, "VScom 200L 1 port serial adaptor" }, 
	{ 0x14d2, 0x8021, "VScom 210L 2 port serial and 1 port parallel adaptor" }, 
	{ 0x14d2, 0x8040, "VScom 400L 4 port serial adaptor" }, 
	{ 0x14d2, 0x8080, "VScom 800L 8 port serial adaptor" }, 
	{ 0x14d2, 0xa000, "VScom 010H 1 port parallel adaptor" }, 
	{ 0x14d2, 0xa001, "VScom 100H 1 port serial adaptor" }, 
	{ 0x14d2, 0xa003, "VScom 400H 4 port serial adaptor" }, 
	{ 0x14d2, 0xa004, "VScom 400HF1 4 port serial adaptor" }, 
	{ 0x14d2, 0xa005, "VScom 200H 2 port serial adaptor" }, 
	{ 0x14d2, 0xe001, "VScom 010HV2 1 port parallel adaptor" }, 
	{ 0x14d2, 0xe010, "VScom 100HV2 1 port serial adaptor" }, 
	{ 0x14d2, 0xe020, "VScom 200HV2 2 port serial adaptor" }, 
	{ 0x14db, 0x2120, "TK9902" }, 
	{ 0x14dc, 0x0000, "PCI230" }, 
	{ 0x14dc, 0x0001, "PCI242" }, 
	{ 0x14dc, 0x0002, "PCI244" }, 
	{ 0x14dc, 0x0003, "PCI247" }, 
	{ 0x14dc, 0x0004, "PCI248" }, 
	{ 0x14dc, 0x0005, "PCI249" }, 
	{ 0x14dc, 0x0006, "PCI260" }, 
	{ 0x14dc, 0x0007, "PCI224" }, 
	{ 0x14dc, 0x0008, "PCI234" }, 
	{ 0x14dc, 0x0009, "PCI236" }, 
	{ 0x14e4, 0x1644, "NetXtreme BCM5700 Gigabit Ethernet" }, 
	{ 0x14e4, 0x1645, "NetXtreme BCM5701 Gigabit Ethernet" }, 
	{ 0x14e4, 0x1646, "NetXtreme BCM5702 Gigabit Ethernet" }, 
	{ 0x14e4, 0x1647, "NetXtreme BCM5703 Gigabit Ethernet" }, 
	{ 0x14e4, 0x164d, "NetXtreme BCM5702FE Gigabit Ethernet" }, 
	{ 0x14e4, 0x16a6, "NetXtreme BCM5702X Gigabit Ethernet" }, 
	{ 0x14e4, 0x16a7, "NetXtreme BCM5703X Gigabit Ethernet" }, 
	{ 0x14e4, 0x4212, "BCM v.90 56k modem" }, 
	{ 0x14e4, 0x5820, "BCM5820 Crypto Accelerator" }, 
	{ 0x14f1, 0x1002, "HCF 56k Modem" }, 
	{ 0x14f1, 0x1003, "HCF 56k Modem" }, 
	{ 0x14f1, 0x1004, "HCF 56k Modem" }, 
	{ 0x14f1, 0x1005, "HCF 56k Modem" }, 
	{ 0x14f1, 0x1006, "HCF 56k Modem" }, 
	{ 0x14f1, 0x1022, "HCF 56k Modem" }, 
	{ 0x14f1, 0x1023, "HCF 56k Modem" }, 
	{ 0x14f1, 0x1024, "HCF 56k Modem" }, 
	{ 0x14f1, 0x1025, "HCF 56k Modem" }, 
	{ 0x14f1, 0x1026, "HCF 56k Modem" }, 
	{ 0x14f1, 0x1032, "HCF 56k Modem" }, 
	{ 0x14f1, 0x1033, "HCF 56k Data/Fax Modem" }, 
	{ 0x14f1, 0x1034, "HCF 56k Data/Fax/Voice Modem" }, 
	{ 0x14f1, 0x1035, "HCF 56k Data/Fax/Voice/Spkp (w/Handset) Modem" }, 
	{ 0x14f1, 0x1036, "HCF 56k Data/Fax/Voice/Spkp Modem" }, 
	{ 0x14f1, 0x1052, "HCF 56k Data/Fax Modem (Worldwide)" }, 
	{ 0x14f1, 0x1053, "HCF 56k Data/Fax Modem (Worldwide)" }, 
	{ 0x14f1, 0x1054, "HCF 56k Data/Fax/Voice Modem (Worldwide)" }, 
	{ 0x14f1, 0x1055, "HCF 56k Data/Fax/Voice/Spkp (w/Handset) Modem (Worldwide)" }, 
	{ 0x14f1, 0x1056, "HCF 56k Data/Fax/Voice/Spkp Modem (Worldwide)" }, 
	{ 0x14f1, 0x1057, "HCF 56k Data/Fax/Voice/Spkp Modem (Worldwide)" }, 
	{ 0x14f1, 0x1059, "HCF 56k Data/Fax/Voice Modem (Worldwide)" }, 
	{ 0x14f1, 0x1063, "HCF 56k Data/Fax Modem" }, 
	{ 0x14f1, 0x1064, "HCF 56k Data/Fax/Voice Modem" }, 
	{ 0x14f1, 0x1065, "HCF 56k Data/Fax/Voice/Spkp (w/Handset) Modem" }, 
	{ 0x14f1, 0x1066, "HCF 56k Data/Fax/Voice/Spkp Modem" }, 
	{ 0x14f1, 0x1433, "HCF 56k Data/Fax Modem" }, 
	{ 0x14f1, 0x1434, "HCF 56k Data/Fax/Voice Modem" }, 
	{ 0x14f1, 0x1435, "HCF 56k Data/Fax/Voice/Spkp (w/Handset) Modem" }, 
	{ 0x14f1, 0x1436, "HCF 56k Data/Fax Modem" }, 
	{ 0x14f1, 0x1453, "HCF 56k Data/Fax Modem" }, 
	{ 0x14f1, 0x1454, "HCF 56k Data/Fax/Voice Modem" }, 
	{ 0x14f1, 0x1455, "HCF 56k Data/Fax/Voice/Spkp (w/Handset) Modem" }, 
	{ 0x14f1, 0x1456, "HCF 56k Data/Fax/Voice/Spkp Modem" }, 
	{ 0x14f1, 0x1803, "HCF 56k Modem" }, 
	{ 0x14f1, 0x1815, "HCF 56k Modem" }, 
	{ 0x14f1, 0x2003, "HSF 56k Data/Fax Modem" }, 
	{ 0x14f1, 0x2004, "HSF 56k Data/Fax/Voice Modem" }, 
	{ 0x14f1, 0x2005, "HSF 56k Data/Fax/Voice/Spkp (w/Handset) Modem" }, 
	{ 0x14f1, 0x2006, "HSF 56k Data/Fax/Voice/Spkp Modem" }, 
	{ 0x14f1, 0x2013, "HSF 56k Data/Fax Modem" }, 
	{ 0x14f1, 0x2014, "HSF 56k Data/Fax/Voice Modem" }, 
	{ 0x14f1, 0x2015, "HSF 56k Data/Fax/Voice/Spkp (w/Handset) Modem" }, 
	{ 0x14f1, 0x2016, "HSF 56k Data/Fax/Voice/Spkp Modem" }, 
	{ 0x14f1, 0x2043, "HSF 56k Data/Fax Modem (WorldW SmartDAA)" }, 
	{ 0x14f1, 0x2044, "HSF 56k Data/Fax/Voice Modem (WorldW SmartDAA)" }, 
	{ 0x14f1, 0x2045, "HSF 56k Data/Fax/Voice/Spkp (w/Handset) Modem (WorldW SmartDAA)" }, 
	{ 0x14f1, 0x2046, "HSF 56k Data/Fax/Voice/Spkp Modem (WorldW SmartDAA)" }, 
	{ 0x14f1, 0x2063, "HSF 56k Data/Fax Modem (SmartDAA)" }, 
	{ 0x14f1, 0x2064, "HSF 56k Data/Fax/Voice Modem (SmartDAA)" }, 
	{ 0x14f1, 0x2065, "HSF 56k Data/Fax/Voice/Spkp (w/Handset) Modem (SmartDAA)" }, 
	{ 0x14f1, 0x2066, "HSF 56k Data/Fax/Voice/Spkp Modem (SmartDAA)" }, 
	{ 0x14f1, 0x2093, "HSF 56k Modem" }, 
	{ 0x14f1, 0x2143, "HSF 56k Data/Fax/Cell Modem (Mob WorldW SmartDAA)" }, 
	{ 0x14f1, 0x2144, "HSF 56k Data/Fax/Voice/Cell Modem (Mob WorldW SmartDAA)" }, 
	{ 0x14f1, 0x2145, "HSF 56k Data/Fax/Voice/Spkp (w/HS)/Cell Modem (Mob WorldW SmartDAA)" }, 
	{ 0x14f1, 0x2146, "HSF 56k Data/Fax/Voice/Spkp/Cell Modem (Mob WorldW SmartDAA)" }, 
	{ 0x14f1, 0x2163, "HSF 56k Data/Fax/Cell Modem (Mob SmartDAA)" }, 
	{ 0x14f1, 0x2164, "HSF 56k Data/Fax/Voice/Cell Modem (Mob SmartDAA)" }, 
	{ 0x14f1, 0x2165, "HSF 56k Data/Fax/Voice/Spkp (w/HS)/Cell Modem (Mob SmartDAA)" }, 
	{ 0x14f1, 0x2166, "HSF 56k Data/Fax/Voice/Spkp/Cell Modem (Mob SmartDAA)" }, 
	{ 0x14f1, 0x2343, "HSF 56k Data/Fax CardBus Modem (Mob WorldW SmartDAA)" }, 
	{ 0x14f1, 0x2344, "HSF 56k Data/Fax/Voice CardBus Modem (Mob WorldW SmartDAA)" }, 
	{ 0x14f1, 0x2345, "HSF 56k Data/Fax/Voice/Spkp (w/HS) CardBus Modem (Mob WorldW SmartDAA)" }, 
	{ 0x14f1, 0x2346, "HSF 56k Data/Fax/Voice/Spkp CardBus Modem (Mob WorldW SmartDAA)" }, 
	{ 0x14f1, 0x2363, "HSF 56k Data/Fax CardBus Modem (Mob SmartDAA)" }, 
	{ 0x14f1, 0x2364, "HSF 56k Data/Fax/Voice CardBus Modem (Mob SmartDAA)" }, 
	{ 0x14f1, 0x2365, "HSF 56k Data/Fax/Voice/Spkp (w/HS) CardBus Modem (Mob SmartDAA)" }, 
	{ 0x14f1, 0x2366, "HSF 56k Data/Fax/Voice/Spkp CardBus Modem (Mob SmartDAA)" }, 
	{ 0x14f1, 0x2443, "HSF 56k Data/Fax Modem (Mob WorldW SmartDAA)" }, 
	{ 0x14f1, 0x2444, "HSF 56k Data/Fax/Voice Modem (Mob WorldW SmartDAA)" }, 
	{ 0x14f1, 0x2445, "HSF 56k Data/Fax/Voice/Spkp (w/HS) Modem (Mob WorldW SmartDAA)" }, 
	{ 0x14f1, 0x2446, "HSF 56k Data/Fax/Voice/Spkp Modem (Mob WorldW SmartDAA)" }, 
	{ 0x14f1, 0x2463, "HSF 56k Data/Fax Modem (Mob SmartDAA)" }, 
	{ 0x14f1, 0x2464, "HSF 56k Data/Fax/Voice Modem (Mob SmartDAA)" }, 
	{ 0x14f1, 0x2465, "HSF 56k Data/Fax/Voice/Spkp (w/HS) Modem (Mob SmartDAA)" }, 
	{ 0x14f1, 0x2466, "HSF 56k Data/Fax/Voice/Spkp Modem (Mob SmartDAA)" }, 
	{ 0x14f1, 0x2f00, "HSF 56k HSFi Modem" }, 
	{ 0x1507, 0x0001, "MPC105 [Eagle]" }, 
	{ 0x1507, 0x0002, "MPC106 [Grackle]" }, 
	{ 0x1507, 0x0003, "MPC8240 [Kahlua]" }, 
	{ 0x1507, 0x0100, "MC145575 [HFC-PCI]" }, 
	{ 0x1507, 0x0431, "KTI829c 100VG" }, 
	{ 0x1507, 0x4801, "Raven" }, 
	{ 0x1507, 0x4802, "Falcon" }, 
	{ 0x1507, 0x4803, "Hawk" }, 
	{ 0x1507, 0x4806, "CPX8216" }, 
	{ 0x151a, 0x1002, "PCI-1002" }, 
	{ 0x151a, 0x1004, "PCI-1004" }, 
	{ 0x151a, 0x1008, "PCI-1008" }, 
	{ 0x151f, 0x0000, "TP560 Data/Fax/Voice 56k modem" }, 
	{ 0x1522, 0x0100, "PCI <-> IOBus Bridge" }, 
	{ 0x1571, 0xa001, "CCSI PCI20-485 ARCnet" }, 
	{ 0x1571, 0xa002, "CCSI PCI20-485D ARCnet" }, 
	{ 0x1571, 0xa003, "CCSI PCI20-485X ARCnet" }, 
	{ 0x1571, 0xa004, "CCSI PCI20-CXB ARCnet" }, 
	{ 0x1571, 0xa005, "CCSI PCI20-CXS ARCnet" }, 
	{ 0x1571, 0xa006, "CCSI PCI20-FOG-SMA ARCnet" }, 
	{ 0x1571, 0xa007, "CCSI PCI20-FOG-ST ARCnet" }, 
	{ 0x1571, 0xa008, "CCSI PCI20-TB5 ARCnet" }, 
	{ 0x1571, 0xa009, "CCSI PCI20-5-485 5Mbit ARCnet" }, 
	{ 0x1571, 0xa00a, "CCSI PCI20-5-485D 5Mbit ARCnet" }, 
	{ 0x1571, 0xa00b, "CCSI PCI20-5-485X 5Mbit ARCnet" }, 
	{ 0x1571, 0xa00c, "CCSI PCI20-5-FOG-ST 5Mbit ARCnet" }, 
	{ 0x1571, 0xa00d, "CCSI PCI20-5-FOG-SMA 5Mbit ARCnet" }, 
	{ 0x1571, 0xa201, "CCSI PCI22-485 10Mbit ARCnet" }, 
	{ 0x1571, 0xa202, "CCSI PCI22-485D 10Mbit ARCnet" }, 
	{ 0x1571, 0xa203, "CCSI PCI22-485X 10Mbit ARCnet" }, 
	{ 0x1571, 0xa204, "CCSI PCI22-CHB 10Mbit ARCnet" }, 
	{ 0x1571, 0xa205, "CCSI PCI22-FOG_ST 10Mbit ARCnet" }, 
	{ 0x1571, 0xa206, "CCSI PCI22-THB 10Mbit ARCnet" }, 
	{ 0x157c, 0x8001, "Fix2000 PCI Y2K Compliance Card" }, 
	{ 0x1592, 0x0781, "Multi-IO Card" }, 
	{ 0x1592, 0x0782, "Parallel Port Card 2xEPP" }, 
	{ 0x1592, 0x0783, "Multi-IO Card" }, 
	{ 0x1592, 0x0785, "Multi-IO Card" }, 
	{ 0x1592, 0x0786, "Multi-IO Card" }, 
	{ 0x1592, 0x0787, "Multi-IO Card" }, 
	{ 0x1592, 0x0788, "Multi-IO Card" }, 
	{ 0x1592, 0x078a, "Multi-IO Card" }, 
	{ 0x15a2, 0x0001, "TA700 PCI Bus Analyzer/Exerciser" }, 
	{ 0x15ad, 0x0710, "Virtual SVGA" }, 
	{ 0x15b3, 0x5274, "MT21108 InfiniBridge" }, 
	{ 0x15bc, 0x2929, "E2929A PCI/PCI-X Bus Analyzer" }, 
	{ 0x15dc, 0x0001, "Argus 300 PCI Cryptography Module" }, 
	{ 0x1619, 0x0400, "FarSync T2P (2 port X.21/V.35/V.24)" }, 
	{ 0x1619, 0x0440, "FarSync T4P (4 port X.21/V.35/V.24)" }, 
	{ 0x1629, 0x1003, "Format synchronizer v3.0" }, 
	{ 0x1629, 0x2002, "Fast Universal Data Output" }, 
	{ 0x173b, 0x03e8, "AC1000 Gigabit Ethernet" }, 
	{ 0x173b, 0x03ea, "AC9100 Gigabit Ethernet" }, 
	{ 0x1743, 0x8139, "ROL/F-100 Fast Ethernet Adapter with ROL" }, 
	{ 0x1a08, 0x0000, "SC15064" }, 
	{ 0x1c1c, 0x0001, "82C101" }, 
	{ 0x1d44, 0xa400, "PM2x24/PM3224" }, 
	{ 0x1de1, 0x0391, "TRM-S1040" }, 
	{ 0x1de1, 0x2020, "DC-390" }, 
	{ 0x1de1, 0x690c, "690c" }, 
	{ 0x1de1, 0xdc29, "DC290" }, 
	{ 0x2348, 0x2010, "8142 100VG/AnyLAN" }, 
	{ 0x3388, 0x0021, "HB1-SE33 PCI-PCI Bridge" }, 
	{ 0x3388, 0x8011, "VXPro II Chipset" }, 
	{ 0x3388, 0x8012, "VXPro II Chipset" }, 
	{ 0x3388, 0x8013, "VXPro II Chipset" }, 
	{ 0x3d3d, 0x0001, "GLINT 300SX" }, 
	{ 0x3d3d, 0x0002, "GLINT 500TX" }, 
	{ 0x3d3d, 0x0003, "GLINT Delta" }, 
	{ 0x3d3d, 0x0004, "Permedia" }, 
	{ 0x3d3d, 0x0005, "Permedia" }, 
	{ 0x3d3d, 0x0006, "GLINT MX" }, 
	{ 0x3d3d, 0x0007, "3D Extreme" }, 
	{ 0x3d3d, 0x0008, "GLINT Gamma G1" }, 
	{ 0x3d3d, 0x0009, "Permedia II 2D+3D" }, 
	{ 0x3d3d, 0x000a, "GLINT R3" }, 
	{ 0x3d3d, 0x0100, "Permedia II 2D+3D" }, 
	{ 0x3d3d, 0x1004, "Permedia" }, 
	{ 0x3d3d, 0x3d04, "Permedia" }, 
	{ 0x3d3d, 0xffff, "Glint VGA" }, 
	{ 0x4005, 0x0300, "ALS300 PCI Audio Device" }, 
	{ 0x4005, 0x0308, "ALS300+ PCI Audio Device" }, 
	{ 0x4005, 0x0309, "PCI Input Controller" }, 
	{ 0x4005, 0x1064, "ALG-2064" }, 
	{ 0x4005, 0x2064, "ALG-2064i" }, 
	{ 0x4005, 0x2128, "ALG-2364A GUI Accelerator" }, 
	{ 0x4005, 0x2301, "ALG-2301" }, 
	{ 0x4005, 0x2302, "ALG-2302" }, 
	{ 0x4005, 0x2303, "AVG-2302 GUI Accelerator" }, 
	{ 0x4005, 0x2364, "ALG-2364A" }, 
	{ 0x4005, 0x2464, "ALG-2464" }, 
	{ 0x4005, 0x2501, "ALG-2564A/25128A" }, 
	{ 0x4005, 0x4000, "ALS4000 Audio Chipset" }, 
	{ 0x4005, 0x4710, "ALC200/200P" }, 
	{ 0x4033, 0x1360, "RTL8139 Ethernet" }, 
	{ 0x416c, 0x0100, "AladdinCARD" }, 
	{ 0x416c, 0x0200, "CPC" }, 
	{ 0x4916, 0x1960, "RedCreek PCI adapter" }, 
	{ 0x4a14, 0x5000, "NV5000SC" }, 
	{ 0x4d51, 0x0200, "MQ-200" }, 
	{ 0x5046, 0x1001, "PCI Radio" }, 
	{ 0x5053, 0x2010, "Daytona Audio Adapter" }, 
	{ 0x5145, 0x3031, "Concert AudioPCI" }, 
	{ 0x5301, 0x0001, "ProMotion aT3D" }, 
	{ 0x5333, 0x0551, "Plato/PX (system)" }, 
	{ 0x5333, 0x5631, "86c325 [ViRGE]" }, 
	{ 0x5333, 0x8800, "86c866 [Vision 866]" }, 
	{ 0x5333, 0x8801, "86c964 [Vision 964]" }, 
	{ 0x5333, 0x8810, "86c764_0 [Trio 32 vers 0]" }, 
	{ 0x5333, 0x8811, "86c764/765 [Trio32/64/64V+]" }, 
	{ 0x5333, 0x8812, "86cM65 [Aurora64V+]" }, 
	{ 0x5333, 0x8813, "86c764_3 [Trio 32/64 vers 3]" }, 
	{ 0x5333, 0x8814, "86c767 [Trio 64UV+]" }, 
	{ 0x5333, 0x8815, "86cM65 [Aurora 128]" }, 
	{ 0x5333, 0x883d, "86c988 [ViRGE/VX]" }, 
	{ 0x5333, 0x8870, "FireGL" }, 
	{ 0x5333, 0x8880, "86c868 [Vision 868 VRAM] vers 0" }, 
	{ 0x5333, 0x8881, "86c868 [Vision 868 VRAM] vers 1" }, 
	{ 0x5333, 0x8882, "86c868 [Vision 868 VRAM] vers 2" }, 
	{ 0x5333, 0x8883, "86c868 [Vision 868 VRAM] vers 3" }, 
	{ 0x5333, 0x88b0, "86c928 [Vision 928 VRAM] vers 0" }, 
	{ 0x5333, 0x88b1, "86c928 [Vision 928 VRAM] vers 1" }, 
	{ 0x5333, 0x88b2, "86c928 [Vision 928 VRAM] vers 2" }, 
	{ 0x5333, 0x88b3, "86c928 [Vision 928 VRAM] vers 3" }, 
	{ 0x5333, 0x88c0, "86c864 [Vision 864 DRAM] vers 0" }, 
	{ 0x5333, 0x88c1, "86c864 [Vision 864 DRAM] vers 1" }, 
	{ 0x5333, 0x88c2, "86c864 [Vision 864-P DRAM] vers 2" }, 
	{ 0x5333, 0x88c3, "86c864 [Vision 864-P DRAM] vers 3" }, 
	{ 0x5333, 0x88d0, "86c964 [Vision 964 VRAM] vers 0" }, 
	{ 0x5333, 0x88d1, "86c964 [Vision 964 VRAM] vers 1" }, 
	{ 0x5333, 0x88d2, "86c964 [Vision 964-P VRAM] vers 2" }, 
	{ 0x5333, 0x88d3, "86c964 [Vision 964-P VRAM] vers 3" }, 
	{ 0x5333, 0x88f0, "86c968 [Vision 968 VRAM] rev 0" }, 
	{ 0x5333, 0x88f1, "86c968 [Vision 968 VRAM] rev 1" }, 
	{ 0x5333, 0x88f2, "86c968 [Vision 968 VRAM] rev 2" }, 
	{ 0x5333, 0x88f3, "86c968 [Vision 968 VRAM] rev 3" }, 
	{ 0x5333, 0x8900, "86c755 [Trio 64V2/DX]" }, 
	{ 0x5333, 0x8901, "86c775/86c785 [Trio 64V2/DX or /GX]" }, 
	{ 0x5333, 0x8902, "Plato/PX" }, 
	{ 0x5333, 0x8903, "Trio 3D business multimedia" }, 
	{ 0x5333, 0x8904, "Trio 64 3D" }, 
	{ 0x5333, 0x8905, "Trio 64V+ family" }, 
	{ 0x5333, 0x8906, "Trio 64V+ family" }, 
	{ 0x5333, 0x8907, "Trio 64V+ family" }, 
	{ 0x5333, 0x8908, "Trio 64V+ family" }, 
	{ 0x5333, 0x8909, "Trio 64V+ family" }, 
	{ 0x5333, 0x890a, "Trio 64V+ family" }, 
	{ 0x5333, 0x890b, "Trio 64V+ family" }, 
	{ 0x5333, 0x890c, "Trio 64V+ family" }, 
	{ 0x5333, 0x890d, "Trio 64V+ family" }, 
	{ 0x5333, 0x890e, "Trio 64V+ family" }, 
	{ 0x5333, 0x890f, "Trio 64V+ family" }, 
	{ 0x5333, 0x8a01, "ViRGE/DX or /GX" }, 
	{ 0x5333, 0x8a10, "ViRGE/GX2" }, 
	{ 0x5333, 0x8a13, "86c368 [Trio 3D/2X]" }, 
	{ 0x5333, 0x8a20, "86c794 [Savage 3D]" }, 
	{ 0x5333, 0x8a21, "86c390 [Savage 3D/MV]" }, 
	{ 0x5333, 0x8a22, "Savage 4" }, 
	{ 0x5333, 0x8a23, "Savage 4" }, 
	{ 0x5333, 0x8a25, "ProSavage PM133" }, 
	{ 0x5333, 0x8a26, "ProSavage KM133" }, 
	{ 0x5333, 0x8c00, "ViRGE/M3" }, 
	{ 0x5333, 0x8c01, "ViRGE/MX" }, 
	{ 0x5333, 0x8c02, "ViRGE/MX+" }, 
	{ 0x5333, 0x8c03, "ViRGE/MX+MV" }, 
	{ 0x5333, 0x8c10, "86C270-294 Savage/MX-MV" }, 
	{ 0x5333, 0x8c11, "82C270-294 Savage/MX" }, 
	{ 0x5333, 0x8c12, "86C270-294 Savage/IX-MV" }, 
	{ 0x5333, 0x8c13, "86C270-294 Savage/IX" }, 
	{ 0x5333, 0x9102, "86C410 Savage 2000" }, 
	{ 0x5333, 0xca00, "SonicVibes" }, 
	{ 0x5455, 0x4458, "S5933" }, 
	{ 0x5544, 0x0001, "I-30xx Scanner Interface" }, 
	{ 0x5555, 0x0003, "TURBOstor HFP-832 [HiPPI NIC]" }, 
	{ 0x6374, 0x6773, "GPPCI" }, 
	{ 0x6666, 0x0001, "PCCOM4" }, 
	{ 0x6666, 0x0002, "PCCOM8" }, 
	{ 0x8008, 0x0010, "WDOG1 [PCI-Watchdog 1]" }, 
	{ 0x8008, 0x0011, "PWDOG2 [PCI-Watchdog 2]" }, 
	{ 0x8086, 0x0007, "82379AB" }, 
	{ 0x8086, 0x0039, "21145" }, 
	{ 0x8086, 0x0122, "82437FX" }, 
	{ 0x8086, 0x0482, "82375EB" }, 
	{ 0x8086, 0x0483, "82424ZX [Saturn]" }, 
	{ 0x8086, 0x0484, "82378IB [SIO ISA Bridge]" }, 
	{ 0x8086, 0x0486, "82430ZX [Aries]" }, 
	{ 0x8086, 0x04a3, "82434LX [Mercury/Neptune]" }, 
	{ 0x8086, 0x04d0, "82437FX [Triton FX]" }, 
	{ 0x8086, 0x0600, "RAID Controller" }, 
	{ 0x8086, 0x0960, "80960RP [i960 RP Microprocessor/Bridge]" }, 
	{ 0x8086, 0x0962, "80960RM [i960RM Bridge]" }, 
	{ 0x8086, 0x0964, "80960RP [i960 RP Microprocessor/Bridge]" }, 
	{ 0x8086, 0x1000, "82542 Gigabit Ethernet Controller" }, 
	{ 0x8086, 0x1001, "82543GC Gigabit Ethernet Controller" }, 
	{ 0x8086, 0x1002, "Pro 100 LAN Modem 56 Cardbus II" }, 
	{ 0x8086, 0x1004, "82543GC Gigabit Ethernet Controller" }, 
	{ 0x8086, 0x1008, "82544EI Gigabit Ethernet Controller" }, 
	{ 0x8086, 0x1009, "82544EI Gigabit Ethernet Controller" }, 
	{ 0x8086, 0x100c, "82544GC Gigabit Ethernet Controller" }, 
	{ 0x8086, 0x100d, "82544GC Gigabit Ethernet Controller" }, 
	{ 0x8086, 0x1029, "82559 Ethernet Controller" }, 
	{ 0x8086, 0x1030, "82559 InBusiness 10/100" }, 
	{ 0x8086, 0x1031, "82801CAM (ICH3) Chipset Ethernet Controller" }, 
	{ 0x8086, 0x1032, "82801CAM (ICH3) Chipset Ethernet Controller" }, 
	{ 0x8086, 0x1033, "82801CAM (ICH3) Chipset Ethernet Controller" }, 
	{ 0x8086, 0x1034, "82801CAM (ICH3) Chipset Ethernet Controller" }, 
	{ 0x8086, 0x1035, "82801CAM (ICH3) Chipset Ethernet Controller" }, 
	{ 0x8086, 0x1036, "82801CAM (ICH3) Chipset Ethernet Controller" }, 
	{ 0x8086, 0x1037, "82801CAM (ICH3) Chipset Ethernet Controller" }, 
	{ 0x8086, 0x1038, "82801CAM (ICH3) Chipset Ethernet Controller" }, 
	{ 0x8086, 0x1130, "82815 815 Chipset Host Bridge and Memory Controller Hub" }, 
	{ 0x8086, 0x1131, "82815 815 Chipset AGP Bridge" }, 
	{ 0x8086, 0x1132, "82815 CGC [Chipset Graphics Controller]" }, 
	{ 0x8086, 0x1161, "82806AA PCI64 Hub Advanced Programmable Interrupt Controller" }, 
	{ 0x8086, 0x1200, "Unknown device" }, 
	{ 0x8086, 0x1209, "82559ER" }, 
	{ 0x8086, 0x1221, "82092AA_0" }, 
	{ 0x8086, 0x1222, "82092AA_1" }, 
	{ 0x8086, 0x1223, "SAA7116" }, 
	{ 0x8086, 0x1225, "82452KX/GX [Orion]" }, 
	{ 0x8086, 0x1226, "82596 PRO/10 PCI" }, 
	{ 0x8086, 0x1227, "82865 EtherExpress PRO/100A" }, 
	{ 0x8086, 0x1228, "82556 EtherExpress PRO/100 Smart" }, 
	{ 0x8086, 0x1229, "82557/8/9 [Ethernet Pro 100]" }, 
	{ 0x8086, 0x122d, "430FX - 82437FX TSC [Triton I]" }, 
	{ 0x8086, 0x122e, "82371FB PIIX ISA [Triton I]" }, 
	{ 0x8086, 0x1230, "82371FB PIIX IDE [Triton I]" }, 
	{ 0x8086, 0x1231, "DSVD Modem" }, 
	{ 0x8086, 0x1234, "430MX - 82371MX Mobile PCI I/O IDE Xcelerator (MPIIX)" }, 
	{ 0x8086, 0x1235, "430MX - 82437MX Mob. System Ctrlr (MTSC) & 82438MX Data Path (MTDP)" }, 
	{ 0x8086, 0x1237, "440FX - 82441FX PMC [Natoma]" }, 
	{ 0x8086, 0x1239, "82371FB" }, 
	{ 0x8086, 0x123b, "82380PB" }, 
	{ 0x8086, 0x123c, "82380AB" }, 
	{ 0x8086, 0x123d, "683053 Programmable Interrupt Device" }, 
	{ 0x8086, 0x123f, "82466GX Integrated Hot-Plug Controller (IHPC)" }, 
	{ 0x8086, 0x1240, "752 AGP" }, 
	{ 0x8086, 0x124b, "82380FB" }, 
	{ 0x8086, 0x1250, "430HX - 82439HX TXC [Triton II]" }, 
	{ 0x8086, 0x1360, "82806AA PCI64 Hub PCI Bridge" }, 
	{ 0x8086, 0x1361, "82806AA PCI64 Hub Controller (HRes)" }, 
	{ 0x8086, 0x1460, "82870P2 P64H2 Hub PCI Bridge" }, 
	{ 0x8086, 0x1461, "82870P2 P64H2 I/OxAPIC" }, 
	{ 0x8086, 0x1462, "82870P2 P64H2 Hot Plug Controller" }, 
	{ 0x8086, 0x1960, "80960RP [i960RP Microprocessor]" }, 
	{ 0x8086, 0x1962, "80960RM [i960RM Microprocessor]" }, 
	{ 0x8086, 0x1a21, "82840 840 (Carmel) Chipset Host Bridge (Hub A)" }, 
	{ 0x8086, 0x1a23, "82840 840 (Carmel) Chipset AGP Bridge" }, 
	{ 0x8086, 0x1a24, "82840 840 (Carmel) Chipset PCI Bridge (Hub B)" }, 
	{ 0x8086, 0x1a30, "82845 845 (Brookdale) Chipset Host Bridge" }, 
	{ 0x8086, 0x1a31, "82845 845 (Brookdale) Chipset AGP Bridge" }, 
	{ 0x8086, 0x2410, "82801AA ISA Bridge (LPC)" }, 
	{ 0x8086, 0x2411, "82801AA IDE" }, 
	{ 0x8086, 0x2412, "82801AA USB" }, 
	{ 0x8086, 0x2413, "82801AA SMBus" }, 
	{ 0x8086, 0x2415, "82801AA AC'97 Audio" }, 
	{ 0x8086, 0x2416, "82801AA AC'97 Modem" }, 
	{ 0x8086, 0x2418, "82801AA PCI Bridge" }, 
	{ 0x8086, 0x2420, "82801AB ISA Bridge (LPC)" }, 
	{ 0x8086, 0x2421, "82801AB IDE" }, 
	{ 0x8086, 0x2422, "82801AB USB" }, 
	{ 0x8086, 0x2423, "82801AB SMBus" }, 
	{ 0x8086, 0x2425, "82801AB AC'97 Audio" }, 
	{ 0x8086, 0x2426, "82801AB AC'97 Modem" }, 
	{ 0x8086, 0x2428, "82801AB PCI Bridge" }, 
	{ 0x8086, 0x2440, "82801BA ISA Bridge (LPC)" }, 
	{ 0x8086, 0x2442, "82801BA/BAM USB (Hub #1)" }, 
	{ 0x8086, 0x2443, "82801BA/BAM SMBus" }, 
	{ 0x8086, 0x2444, "82801BA/BAM USB (Hub #2)" }, 
	{ 0x8086, 0x2445, "82801BA/BAM AC'97 Audio" }, 
	{ 0x8086, 0x2446, "82801BA/BAM AC'97 Modem" }, 
	{ 0x8086, 0x2448, "82801BAM/CAM PCI Bridge" }, 
	{ 0x8086, 0x2449, "82801BA/BAM/CA/CAM Ethernet Controller" }, 
	{ 0x8086, 0x244a, "82801BAM IDE U100" }, 
	{ 0x8086, 0x244b, "82801BA IDE U100" }, 
	{ 0x8086, 0x244c, "82801BAM ISA Bridge (LPC)" }, 
	{ 0x8086, 0x244e, "82801BA/CA/DB PCI Bridge" }, 
	{ 0x8086, 0x2450, "82801E ISA Bridge (LPC)" }, 
	{ 0x8086, 0x2452, "82801E USB" }, 
	{ 0x8086, 0x2453, "82801E SMBus" }, 
	{ 0x8086, 0x2459, "82801E Ethernet Controller 0" }, 
	{ 0x8086, 0x245b, "82801E IDE U100" }, 
	{ 0x8086, 0x245d, "82801E Ethernet Controller 1" }, 
	{ 0x8086, 0x245e, "82801E PCI Bridge" }, 
	{ 0x8086, 0x2480, "82801CA ISA Bridge (LPC)" }, 
	{ 0x8086, 0x2482, "82801CA/CAM USB (Hub #1)" }, 
	{ 0x8086, 0x2483, "82801CA/CAM SMBus" }, 
	{ 0x8086, 0x2484, "82801CA/CAM USB (Hub #2)" }, 
	{ 0x8086, 0x2485, "82801CA/CAM AC'97 Audio" }, 
	{ 0x8086, 0x2486, "82801CA/CAM AC'97 Modem" }, 
	{ 0x8086, 0x2487, "82801CA/CAM USB (Hub #3)" }, 
	{ 0x8086, 0x248a, "82801CAM IDE U100" }, 
	{ 0x8086, 0x248b, "82801CA IDE U100" }, 
	{ 0x8086, 0x248c, "82801CAM ISA Bridge (LPC)" }, 
	{ 0x8086, 0x24c0, "82801DB ISA Bridge (LPC)" }, 
	{ 0x8086, 0x24c2, "82801DB USB (Hub #1)" }, 
	{ 0x8086, 0x24c3, "82801DB SMBus" }, 
	{ 0x8086, 0x24c4, "82801DB USB (Hub #2)" }, 
	{ 0x8086, 0x24c5, "82801DB AC'97 Audio" }, 
	{ 0x8086, 0x24c6, "82801DB AC'97 Modem" }, 
	{ 0x8086, 0x24c7, "82801DB USB (Hub #3)" }, 
	{ 0x8086, 0x24cb, "82801DB IDE U100" }, 
	{ 0x8086, 0x24cd, "82801DB USB EHCI Controller" }, 
	{ 0x8086, 0x2500, "82820 820 (Camino) Chipset Host Bridge (MCH)" }, 
	{ 0x8086, 0x2501, "82820 820 (Camino) Chipset Host Bridge (MCH)" }, 
	{ 0x8086, 0x250b, "82820 820 (Camino) Chipset Host Bridge" }, 
	{ 0x8086, 0x250f, "82820 820 (Camino) Chipset AGP Bridge" }, 
	{ 0x8086, 0x2520, "82805AA MTH Memory Translator Hub" }, 
	{ 0x8086, 0x2521, "82804AA MRH-S Memory Repeater Hub for SDRAM" }, 
	{ 0x8086, 0x2530, "82850 850 (Tehama) Chipset Host Bridge (MCH)" }, 
	{ 0x8086, 0x2531, "82850 860 (Wombat) Chipset Host Bridge (MCH)" }, 
	{ 0x8086, 0x2532, "82850 850 (Tehama) Chipset AGP Bridge" }, 
	{ 0x8086, 0x2533, "82860 860 (Wombat) Chipset AGP Bridge" }, 
	{ 0x8086, 0x2534, "82860 860 (Wombat) Chipset PCI Bridge" }, 
	{ 0x8086, 0x2540, "e7500 (Plumas) DRAM Controller" }, 
	{ 0x8086, 0x2541, "e7500 (Plumas) DRAM Controller Error Reporting" }, 
	{ 0x8086, 0x2543, "e7500 (Plumas) HI_B Virtual PCI-to-PCI Bridge (F0)" }, 
	{ 0x8086, 0x2544, "e7500 (Plumas) HI_B Virtual PCI-to-PCI Bridge (F1)" }, 
	{ 0x8086, 0x2545, "e7500 (Plumas) HI_C Virtual PCI-to-PCI Bridge (F0)" }, 
	{ 0x8086, 0x2546, "e7500 (Plumas) HI_C Virtual PCI-to-PCI Bridge (F1)" }, 
	{ 0x8086, 0x2547, "e7500 (Plumas) HI_D Virtual PCI-to-PCI Bridge (F0)" }, 
	{ 0x8086, 0x2548, "e7500 (Plumas) HI_D Virtual PCI-to-PCI Bridge (F1)" }, 
	{ 0x8086, 0x3092, "Integrated RAID" }, 
	{ 0x8086, 0x3575, "82830 830 Chipset Host Bridge" }, 
	{ 0x8086, 0x3576, "82830 830 Chipset AGP Bridge" }, 
	{ 0x8086, 0x3577, "82830 CGC [Chipset Graphics Controller]" }, 
	{ 0x8086, 0x3578, "82830 830 Chipset Host Bridge" }, 
	{ 0x8086, 0x5200, "EtherExpress PRO/100 Intelligent Server" }, 
	{ 0x8086, 0x5201, "EtherExpress PRO/100 Intelligent Server" }, 
	{ 0x8086, 0x530d, "80310 IOP [IO Processor]" }, 
	{ 0x8086, 0x7000, "82371SB PIIX3 ISA [Natoma/Triton II]" }, 
	{ 0x8086, 0x7010, "82371SB PIIX3 IDE [Natoma/Triton II]" }, 
	{ 0x8086, 0x7020, "82371SB PIIX3 USB [Natoma/Triton II]" }, 
	{ 0x8086, 0x7030, "430VX - 82437VX TVX [Triton VX]" }, 
	{ 0x8086, 0x7100, "430TX - 82439TX MTXC" }, 
	{ 0x8086, 0x7110, "82371AB/EB/MB PIIX4 ISA" }, 
	{ 0x8086, 0x7111, "82371AB/EB/MB PIIX4 IDE" }, 
	{ 0x8086, 0x7112, "82371AB/EB/MB PIIX4 USB" }, 
	{ 0x8086, 0x7113, "82371AB/EB/MB PIIX4 ACPI" }, 
	{ 0x8086, 0x7120, "82810 GMCH [Graphics Memory Controller Hub]" }, 
	{ 0x8086, 0x7121, "82810 CGC [Chipset Graphics Controller]" }, 
	{ 0x8086, 0x7122, "82810 DC-100 GMCH [Graphics Memory Controller Hub]" }, 
	{ 0x8086, 0x7123, "82810 DC-100 CGC [Chipset Graphics Controller]" }, 
	{ 0x8086, 0x7124, "82810E DC-133 GMCH [Graphics Memory Controller Hub]" }, 
	{ 0x8086, 0x7125, "82810E DC-133 CGC [Chipset Graphics Controller]" }, 
	{ 0x8086, 0x7126, "82810 DC-133 System and Graphics Controller" }, 
	{ 0x8086, 0x7128, "82810-M DC-100 System and Graphics Controller" }, 
	{ 0x8086, 0x712a, "82810-M DC-133 System and Graphics Controller" }, 
	{ 0x8086, 0x7180, "440LX/EX - 82443LX/EX Host bridge" }, 
	{ 0x8086, 0x7181, "440LX/EX - 82443LX/EX AGP bridge" }, 
	{ 0x8086, 0x7190, "440BX/ZX/DX - 82443BX/ZX/DX Host bridge" }, 
	{ 0x8086, 0x7191, "440BX/ZX/DX - 82443BX/ZX/DX AGP bridge" }, 
	{ 0x8086, 0x7192, "440BX/ZX/DX - 82443BX/ZX/DX Host bridge (AGP disabled)" }, 
	{ 0x8086, 0x7194, "82440MX Host Bridge" }, 
	{ 0x8086, 0x7195, "82440MX AC'97 Audio Controller" }, 
	{ 0x8086, 0x7196, "82440MX AC'97 Modem Controller" }, 
	{ 0x8086, 0x7198, "82440MX ISA Bridge" }, 
	{ 0x8086, 0x7199, "82440MX EIDE Controller" }, 
	{ 0x8086, 0x719a, "82440MX USB Universal Host Controller" }, 
	{ 0x8086, 0x719b, "82440MX Power Management Controller" }, 
	{ 0x8086, 0x71a0, "440GX - 82443GX Host bridge" }, 
	{ 0x8086, 0x71a1, "440GX - 82443GX AGP bridge" }, 
	{ 0x8086, 0x71a2, "440GX - 82443GX Host bridge (AGP disabled)" }, 
	{ 0x8086, 0x7600, "82372FB PCI to ISA Bridge" }, 
	{ 0x8086, 0x7601, "82372FB PIIX4 IDE" }, 
	{ 0x8086, 0x7602, "82372FB [PCI-to-USB UHCI]" }, 
	{ 0x8086, 0x7603, "82372FB System Management Bus Controller" }, 
	{ 0x8086, 0x7800, "i740" }, 
	{ 0x8086, 0x84c4, "450KX/GX [Orion] - 82454KX/GX PCI bridge" }, 
	{ 0x8086, 0x84c5, "450KX/GX [Orion] - 82453KX/GX Memory controller" }, 
	{ 0x8086, 0x84ca, "450NX - 82451NX Memory & I/O Controller" }, 
	{ 0x8086, 0x84cb, "450NX - 82454NX/84460GX PCI Expander Bridge" }, 
	{ 0x8086, 0x84e0, "460GX - 84460GX System Address Controller (SAC)" }, 
	{ 0x8086, 0x84e1, "460GX - 84460GX System Data Controller (SDC)" }, 
	{ 0x8086, 0x84e2, "460GX - 84460GX AGP Bridge (GXB)" }, 
	{ 0x8086, 0x84e3, "460GX - 84460GX Memory Address Controller (MAC)" }, 
	{ 0x8086, 0x84e4, "460GX - 84460GX Memory Data Controller (MDC)" }, 
	{ 0x8086, 0x84e6, "460GX - 82466GX Wide and fast PCI eXpander Bridge (WXB)" }, 
	{ 0x8086, 0x9621, "Integrated RAID" }, 
	{ 0x8086, 0x9622, "Integrated RAID" }, 
	{ 0x8086, 0x9641, "Integrated RAID" }, 
	{ 0x8086, 0x96a1, "Integrated RAID" }, 
	{ 0x8086, 0xffff, "450NX/GX [Orion] - 82453KX/GX Memory controller [BUG]" }, 
	{ 0x8800, 0x2008, "Video assistent component" }, 
	{ 0x8e2e, 0x3000, "ET32P2" }, 
	{ 0x9004, 0x1078, "AIC-7810" }, 
	{ 0x9004, 0x1160, "AIC-1160 [Family Fibre Channel Adapter]" }, 
	{ 0x9004, 0x2178, "AIC-7821" }, 
	{ 0x9004, 0x3860, "AHA-2930CU" }, 
	{ 0x9004, 0x3b78, "AHA-4844W/4844UW" }, 
	{ 0x9004, 0x5075, "AIC-755x" }, 
	{ 0x9004, 0x5078, "AHA-7850" }, 
	{ 0x9004, 0x5175, "AIC-755x" }, 
	{ 0x9004, 0x5178, "AIC-7851" }, 
	{ 0x9004, 0x5275, "AIC-755x" }, 
	{ 0x9004, 0x5278, "AIC-7852" }, 
	{ 0x9004, 0x5375, "AIC-755x" }, 
	{ 0x9004, 0x5378, "AIC-7850" }, 
	{ 0x9004, 0x5475, "AIC-755x" }, 
	{ 0x9004, 0x5478, "AIC-7850" }, 
	{ 0x9004, 0x5575, "AVA-2930" }, 
	{ 0x9004, 0x5578, "AIC-7855" }, 
	{ 0x9004, 0x5675, "AIC-755x" }, 
	{ 0x9004, 0x5678, "AIC-7856" }, 
	{ 0x9004, 0x5775, "AIC-755x" }, 
	{ 0x9004, 0x5778, "AIC-7850" }, 
	{ 0x9004, 0x5800, "AIC-5800" }, 
	{ 0x9004, 0x5900, "ANA-5910/5930/5940 ATM155 & 25 LAN Adapter" }, 
	{ 0x9004, 0x5905, "ANA-5910A/5930A/5940A ATM Adapter" }, 
	{ 0x9004, 0x6038, "AIC-3860" }, 
	{ 0x9004, 0x6075, "AIC-1480 / APA-1480" }, 
	{ 0x9004, 0x6078, "AIC-7860" }, 
	{ 0x9004, 0x6178, "AIC-7861" }, 
	{ 0x9004, 0x6278, "AIC-7860" }, 
	{ 0x9004, 0x6378, "AIC-7860" }, 
	{ 0x9004, 0x6478, "AIC-786x" }, 
	{ 0x9004, 0x6578, "AIC-786x" }, 
	{ 0x9004, 0x6678, "AIC-786x" }, 
	{ 0x9004, 0x6778, "AIC-786x" }, 
	{ 0x9004, 0x6915, "ANA620xx/ANA69011A" }, 
	{ 0x9004, 0x7078, "AHA-294x / AIC-7870" }, 
	{ 0x9004, 0x7178, "AHA-2940/2940W / AIC-7871" }, 
	{ 0x9004, 0x7278, "AHA-3940/3940W / AIC-7872" }, 
	{ 0x9004, 0x7378, "AHA-3985 / AIC-7873" }, 
	{ 0x9004, 0x7478, "AHA-2944/2944W / AIC-7874" }, 
	{ 0x9004, 0x7578, "AHA-3944/3944W / AIC-7875" }, 
	{ 0x9004, 0x7678, "AHA-4944W/UW / AIC-7876" }, 
	{ 0x9004, 0x7778, "AIC-787x" }, 
	{ 0x9004, 0x7810, "AIC-7810" }, 
	{ 0x9004, 0x7815, "AIC-7815 RAID+Memory Controller IC" }, 
	{ 0x9004, 0x7850, "AIC-7850" }, 
	{ 0x9004, 0x7855, "AHA-2930" }, 
	{ 0x9004, 0x7860, "AIC-7860" }, 
	{ 0x9004, 0x7870, "AIC-7870" }, 
	{ 0x9004, 0x7871, "AHA-2940" }, 
	{ 0x9004, 0x7872, "AHA-3940" }, 
	{ 0x9004, 0x7873, "AHA-3980" }, 
	{ 0x9004, 0x7874, "AHA-2944" }, 
	{ 0x9004, 0x7880, "AIC-7880P" }, 
	{ 0x9004, 0x7890, "AIC-7890" }, 
	{ 0x9004, 0x7891, "AIC-789x" }, 
	{ 0x9004, 0x7892, "AIC-789x" }, 
	{ 0x9004, 0x7893, "AIC-789x" }, 
	{ 0x9004, 0x7894, "AIC-789x" }, 
	{ 0x9004, 0x7895, "AHA-2940U/UW / AHA-39xx / AIC-7895" }, 
	{ 0x9004, 0x7896, "AIC-789x" }, 
	{ 0x9004, 0x7897, "AIC-789x" }, 
	{ 0x9004, 0x8078, "AIC-7880U" }, 
	{ 0x9004, 0x8178, "AHA-2940U/UW/D / AIC-7881U" }, 
	{ 0x9004, 0x8278, "AHA-3940U/UW/UWD / AIC-7882U" }, 
	{ 0x9004, 0x8378, "AHA-3940U/UW / AIC-7883U" }, 
	{ 0x9004, 0x8478, "AHA-2944UW / AIC-7884U" }, 
	{ 0x9004, 0x8578, "AHA-3944U/UWD / AIC-7885" }, 
	{ 0x9004, 0x8678, "AHA-4944UW / AIC-7886" }, 
	{ 0x9004, 0x8778, "AHA-2940UW Pro / AIC-788x" }, 
	{ 0x9004, 0x8878, "AHA-2930UW / AIC-7888" }, 
	{ 0x9004, 0x8b78, "ABA-1030" }, 
	{ 0x9004, 0xec78, "AHA-4944W/UW" }, 
	{ 0x9005, 0x0010, "AHA-2940U2/U2W" }, 
	{ 0x9005, 0x0011, "AHA-2930U2" }, 
	{ 0x9005, 0x0013, "78902" }, 
	{ 0x9005, 0x001f, "AHA-2940U2/U2W / 7890/7891" }, 
	{ 0x9005, 0x0020, "AIC-7890" }, 
	{ 0x9005, 0x002f, "AIC-7890" }, 
	{ 0x9005, 0x0030, "AIC-7890" }, 
	{ 0x9005, 0x003f, "AIC-7890" }, 
	{ 0x9005, 0x0050, "AHA-3940U2x/395U2x" }, 
	{ 0x9005, 0x0051, "AHA-3950U2D" }, 
	{ 0x9005, 0x0053, "AIC-7896 SCSI Controller" }, 
	{ 0x9005, 0x005f, "AIC-7896U2/7897U2" }, 
	{ 0x9005, 0x0080, "AIC-7892A U160/m" }, 
	{ 0x9005, 0x0081, "AIC-7892B U160/m" }, 
	{ 0x9005, 0x0083, "AIC-7892D U160/m" }, 
	{ 0x9005, 0x008f, "AIC-7892P U160/m" }, 
	{ 0x9005, 0x00c0, "AHA-3960D / AIC-7899A U160/m" }, 
	{ 0x9005, 0x00c1, "AIC-7899B U160/m" }, 
	{ 0x9005, 0x00c3, "AIC-7899D U160/m" }, 
	{ 0x9005, 0x00c5, "RAID subsystem HBA" }, 
	{ 0x9005, 0x00cf, "AIC-7899P U160/m" }, 
	{ 0x907f, 0x2015, "IDE-2015PL" }, 
	{ 0x9412, 0x6565, "6565" }, 
	{ 0x9699, 0x6565, "6565" }, 
	{ 0x9710, 0x9815, "VScom 021H-EP2 2 port parallel adaptor" }, 
	{ 0x9710, 0x9835, "2xserial 1xparallel port adapter" }, 
	{ 0xd4d4, 0x0601, "PCI Mezzanine Card" }, 
	{ 0xe000, 0xe000, "W89C940" }, 
	{ 0xe159, 0x0001, "Model 300 128k" }, 
	{ 0xedd8, 0xa091, "1000PV [Stingray]" }, 
	{ 0xedd8, 0xa099, "2000PV [Stingray]" }, 
	{ 0xedd8, 0xa0a1, "2000MT" }, 
	{ 0xedd8, 0xa0a9, "2000MI" }, 
	{ 0xfffe, 0x0710, "Virtual SVGA" }, 
};

